Attribute VB_Name = "mMSLib145"
'--------------------------------------------------------------------------------------------------
' VBToolbox MSLIB145.BAS  - Copyright (C) M Shaw - Nov 2003..March 2011
'--------------------------------------------------------------------------------------------------
' Purpose: Visual BASIC declares file for VBToolbox (MSLIB145.DLL)
'--------------------------------------------------------------------------------------------------
' VB 5 and above declares provided to link to MSLIB145.DLL (ANSI only)
' Add this complete module to your project if you want to use the VBToolbox functions
' Use the MSLIB146.TLB and MSLIB146.DLL for TLB/Unicode use with limited Unicode support
'--------------------------------------------------------------------------------------------------
' Copyright (C) M Shaw - 2003-2011 - Freeware - *ABSOLUTELY NO WARRANTY*
' See website and any accompanying README.TXT for conditions of use
' Redistribution of these files is prohibited unless this copyright message is retained
' Website: http://vbtoolbox.kerys.co.uk
'
' Comment-out, uncomment, or copy sections of this file to your own project as required
' You may freely rename declared functions using aliases if required but keep the declares
' specific to each release of VBToolbox
'
' Latest version was tested OK on Windows NT4.0(SP6a), Windows 2000 (SP4), Windows XP(SP2)
' Console/CGI functions tested on the above and OK
'
' NB: GetAvailableVirtualMemory and GetTotalVirtualMemory API calls do not work on NT 4.0
'
' This file contains developer-only test routines at the end of the file which may be ignored
'--------------------------------------------------------------------------------------------------
' * WARNING * DO NOT UPX-PACK/REPACK the DLL if you use the LogEvent() functions!
' * Repack using the following: upx -9 --keep-resource=11/1 mslib145.dll
'--------------------------------------------------------------------------------------------------

'Updates:
'--------
'V1.00 23/11/2003 First version with very "basic" functions
'V1.01 15/04/2005 Updated version with encryption (code was lost c2006)
'V1.02 01/06/2008 Lost DLL C code partially reconstructed
'V1.03 02/06/2008 NumOrd, Mk*/Cv*, Windows version routines etc.
'v1.04 03/06/2008 Disk space API functs etc. Readfile fixed
'v1.05 04/06/2008 Added IP functs IPMatch, MatchCIDR, IPToLong etc.
'v1.06 05/06/2008 Added Windows mem API functs
'v1.07 15/06/2008 PHPDate added with basic functionality
'V1.08 18/06/2008 PHPDate expanded - PHPDateNow DSTAdjust
'                 vbdate_to_time WinSleep Fraction/Integral etc.
'V1.09 21/06/2008 Round HexToDate/DateToHex
'V1.10 22/06/2008 Code-review - attempt to reduce garbage passed after 0x00 in strings
'                  BitPack , BitUnPack, PiStrm, fixed DST bug using mktime() evaluating elmination
'                  of need for vbStr() by using byte allocation API calls (means no future Unicode)
'v1.11 25/06/2008 Bugfixes. Conditional Unicode compile (off). String (esp NULL) returns examined
'                 Need for vbStr() eliminated
'V1.12 26/06/2008 EncodeStr64 byte len - API allocates for NULL terminator (excess removed)
'                 Bugfix BinToDec() for mixed binary/alpha chars postfix
'V1.13 28/06/2008 StripX... functions changed to return a new API-allocated string via function return
'                 Note documentation re: conversion of console apps to full-console mode using LINK.EXE
'v1.14 31/06/2008 Removed InNewConsole(), Replaced with InNativeConsole()
'v1.15 05/07/2008 SetConsoleAttributes,ClearConsoleAttributes, InKey, Colour constant, WhereX/Y, GotoXY
'                 FileType, WriteLn (Changed), Writes, GetOpenFile, GetSave File (ready), GetArgs
'                 Tokenise,
'v1.16 --/07/2008 RotateByte, RotateInt, RotateLong
'v1.17 10/07/2008 HexToLong, HexToDouble, ListFiles, FilesMatch, WildcardMatch, ShellRun
'v1.18 14/07/2008 BaseConvDouble, MapNetworkDrive, MapNextFreeNetworkDrive, UnMapDrive, GetCGIArgs, DriveType
'                 IsHardDisk, IsRAMDisk, IsCDROMDisk, IsNetworkDisk, IsRemovableDisk, Variant memory
'                 allocation rewritten
'v1.19 19/07/2008 CreateGUID, LogEvent, AddEventSource, RemoveEventSource, GetDLLFileName
'                 IsEventSource, ReadDWORDFromRegistry, WriteDWORDToRegistry, WriteStringToRegistry
'v1.20 20/07/2009 Additional time traces for Windows 7 testing (found to be 10x slower than XP!)
'v1.21 24/08/2009 This version is a major revision
'                 Renamed IsDLLInstalled to IsVBToolboxDLLInstalled. Change encryptstring len from int to long
'                 added MapiSend(). Changed name of VERSION control Const to DLL_VERSION.
'                 Traced memory leak in VB to returned string - thus changed EncryptString from Function to a Sub
'                 Enhanced EncryptString() - new parameter ExtraSecure. New Length parameter for StrToHex to
'                 accurately-control processing of strings with embedded nulls as produced by EncrytString()
'                 Added new simple function: StringToHex() to supplement complex function StrToHex()
'                 Internal structure of many functions which return strings has been restructured to eliminate
'                 memory leaks. The test-program was changed to enable longer-term tests including the tracking
'                 of memory-allocation using Windows task-manager.
'V1.22 03/09/2009 Improved MAPISendMessage() Added GetProcessMemoryUsed(). PiStr() removed ready to migrate to
'                 a separate DLL (pi.dll)
'v1.23 09/09/2009 Revised encryption method for EncryptString() now with added Salt
'v1.24 11/09/2009 Fix bitshift bug in Bin8, Bin16, Bin32
'                 Implement RLECompress/RLEDecompress, RLECompressedByteCount, RLEDecompressedByteCount
'1.25 15/09/2009  Added mt_rnd() code, MTRnd(), MTRandomStr(), MTRandomise(). MTRndDouble()
'                 StringToBMP(), BMPToString(). Fix strlen() bug with binary strings in RandomStr()
'                 Ceil(), Floor(). Bugfix in RandomStringBinaryString*
'                 RLEByteCount, RLECompressedByteCount, RLEUncompressedByteCount
'1.26 21/06/2010  RLECompressible. Complete unfinished work from v1.25. StrSplit(), Tokenise() and Strsplit()
'                 now use dynamically-allocated heap memory rather than fixed limits
'1.27 03/07/2010  BGRSplit, BGRtoRGB and BMPDataSize added
'1.28 20/07/2010  WipeFile, GetUserDir and GetProfileDir added
'1.29 22/07/2010  Changed URL and embedded banner graphic in test project to match
'1.30 30/07/2010  ShlByte, ShrByte, ShlInt, ShrInt, ShlLong, ShrLong  bit-shifting functions
'                 RotlByte, RotrByte, RotlInt, RotrInt, RotlLong, RotrLong bit-rotating functions
'                 Bin$ revised for two's compliment, Unlink, MKTempName added
'1.31 31/08/2010  Interface for Rundll32.exe and stub.exe - Run() (ANSI/Declare version only)
'                 InStrSet, InStrSetBool, Join, Filter, Experimental callback code
'                 CreateGUID now in upper-case
'                 Typelib GUID is 543BA16F-9707-4493-92F4-FA11E864C9DC
'                 Change VBDate() to VBDateStr() to avoid clash with data-type name
'                 First dual-Unicode/ANSI versions using a TLB file - Unicode=MSLIB146.DLL, ANSI=MSLIB145.DLL
'                 Rewrote: StringToBMP, BMPToString (New parameter list)
'                 Rewrote: Tokenise
'                 Added QSort, QSortStr, QSortVal, PrintR
'                 Functions which return Strings have been changed to be compatible with
'                 TLB version. See individual changed function prototypes
'1.32 10/09/2010  CSVSplit, IsReady,GetVolumeFileSystem,GetVolumeLabel,GetVolumeNameLength,GetVolumeSerial
'                 IsNetworked, IsMousePresent, IsSafeMode, IsSlowMachine, WordCount, WordList
'                 Added Single data type to QSortVal() and PrintR()
'1.33 31/09/2010  MkDirs, IsClipboardEmpty, PrintDebug, DecimalToRoman, MatchBrackets, WordWrap
'                 PrintDebug , GetError, IsCursorVisible, SetCursorVisible, ShowFileProperties,
'                 ExitProgram, PrintScreen, StrCSpan, WindowsVersionMajor, WindowsVersionMinor,
'                 ReverseWords, FindClosingBracket, BracketStr, Expr, Expression, InStrIWildcard
'                 CommandLine, GetFileName, SetConsoleHTML, GetFileExt, Fmod, DToA
'                 Rewrote Replace. Several bugfixes triggered during development of Expression
'                 InsertString
'1.34 14/03/2011  AddString, AddBinaryString, Changed ReadFileToString (added errcode), SliceLeft
'                 MidCharStr, MidStrStr
'1.35 19/03/2011  Interim release. Bugfix for RLECompress* functions. AddHugeBinaryString,
'                 GetColourSelection

'--------------------------------------------------------------------------------------------------

Option Base 0               ' Arrays are based at 0 (change if required - not recommended)
Option Explicit             ' Variables must be declared

#Const VB5 = True           ' Comment-out this line for VB6 use to avoid declare clashes

Public Const VERNUM As String = "1.34"              ' This test app's release version
Public Const DLL_VERSION As String = "1.34"        ' This VB code release ID is required (to match DLL version)
Public Const WEBSITE As String = "http://vbtoolbox.kerys.co.uk"
Public Const DLLNAME As String = "mslib145.dll"     ' ANSI version: Can't use this Const in Declares
Public Const DLLDATE As String = "20100930"

' Temporary
Private Declare Function IsTextUnicode Lib "advapi32" ( _
    ByVal lpBuffer As String, _
    ByVal cb As Long, _
    lpi As Long) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
'Public Const HKEY_LOCAL_USER = &H80000001          ' Alternate HKCU
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_CURRENT_CONFIG = &H80000005

' RandomStr() Constants //////////////////////////////////////////

Public Const RandomStringMixedCase = 0
Public Const RandomStringLower = 1
Public Const RandomStringUpper = 2
Public Const RandomStringNumeric = 3
Public Const RandomStringAll = 4
Public Const RandomStringBinary = 5
Public Const RandomStringHex = 6                    ' // v1.21+ // New
Public Const RandomStringBinaryString = 7
Public Const RandomStringBinaryStringBias0 = 8
Public Const RandomStringBinaryStringBias1 = 9
Public Const RandomStringHexLower = 10

' For LogEvent() //////////////////////////////////////////////////

Public Const EVENTLOG_SUCCESS = 0
Public Const EVENTLOG_ERROR_TYPE = 1
Public Const EVENTLOG_WARNING_TYPE = 2
Public Const EVENTLOG_INFORMATION_TYPE = 4
Public Const EVENTLOG_AUDIT_SUCCESS = 8
Public Const EVENTLOG_AUDIT_FAILURE = 10

' TEST ONLY - FOR DEVELOPER USE ONLY //////////////////////////////
Public Declare Sub Foo Lib "mslib145.dll" (ByVal fptr As Long)
Public Declare Function Crash Lib "mslib145.dll" (ByRef s As String) As String
Public Declare Sub TestFunc Lib "mslib145.dll" (ByVal s As String, ByVal d As String)
Public Declare Function RTFGetHeader Lib "mslib145.dll" (ByVal s As String, Optional ByRef l As Long = 0) As String
           
'// New functions /////////////////////////////////////////////////
Public Declare Function FindHiddenTopWindow Lib "mslib145.dll" () As Long
Public Declare Function IsTaskVisible Lib "mslib145.dll" () As Boolean
Public Declare Function SetTaskVisible Lib "mslib145.dll" (ByVal State As Boolean) As Boolean
Public Declare Function IsConsoleVisible Lib "mslib145.dll" () As Boolean
Public Declare Sub SetConsoleVisible Lib "mslib145.dll" (ByVal State As Boolean)
Public Declare Sub PrintDebug Lib "mslib145.dll" (ByVal s As String)
Public Declare Function CanRedo Lib "mslib145.dll" (ByVal hWnd As Long) As Boolean
Public Declare Function CanUndo Lib "mslib145.dll" (ByVal hWnd As Long) As Boolean
' /////////////////////////////////////////////////////////////////

' DLL Management //////////////////////////////////////////////////

Public Declare Function LibDate Lib "mslib145.dll" () As String
Public Declare Function LibName Lib "mslib145.dll" () As String
Public Declare Function LibTime Lib "mslib145.dll" () As String
Public Declare Function LibUnicode Lib "mslib145.dll" () As Boolean
Public Declare Function LibVersion Lib "mslib145.dll" () As Long

' Graphics Functions //////////////////////////////////////////////

Public Declare Function BMPToString Lib "mslib145" (ByVal BMPData As String, _
            ByRef s As String, Optional ByRef NewStringLength As Long = 0) As Boolean
Public Declare Function BMPDataSize Lib "mslib145" (ByVal BMPData As String) As Long
Public Declare Function BMPInfo Lib "mslib145" (ByVal BMPData As String, _
            Optional ByRef Width As Long, Optional ByRef Height As Long, _
            Optional ByRef SizeBytes As Long, Optional ByRef Bpp As Long) As Boolean
Public Declare Sub BGRSplit Lib "mslib145" (ByVal BGRValue As Long, ByRef Red As Integer, ByRef Green As Integer, ByRef Blue As Integer)
Public Declare Function BGRToRGB Lib "mslib145" (ByVal BGRValue As Long) As Long
Public Declare Function JPEGHeader Lib "mslib145.dll" (ByVal Filename As String, _
            Width As Integer, Height As Integer, FileLength As Long) As Boolean
Public Declare Function JPEGCheck Lib "mslib145.dll" (ByVal Filename As String) As Boolean
Public Declare Function StringToBMP Lib "mslib145" (ByVal s As String, ByVal Size As Long, _
            ByRef BMPData As String, ByRef BMPSize As Long, _
            Optional ByVal ForeColour As Long = 0, _
            Optional ByVal BackColour As Long = &HFFFFFF) As Boolean
'Public Declare Function StringToBMP Lib "mslib145" (ByVal s As String, ByVal Size As Long, ByRef BMPSize As Long, _
'    Optional ByVal ForeColour As Long = 0, Optional ByVal BackColour As Long = &HFFFFFF) As String

' String Functions ///////////////////////////////////////////////////////

' BSTR AllocString(long l, char ch=0)
' Note AddString - 1st parameter is intentionally "ByRef"
Public Declare Function AddString Lib "mslib145.dll" (ByRef a As String, ByVal b As String) As String
Public Declare Function AddBinaryString Lib "mslib145.dll" (ByRef a As String, _
            ByVal b As String, Optional ByVal Length As Long = 0) As String
Public Declare Function AddHugeBinaryString Lib "mslib145.dll" (ByRef a As String, _
            ByVal b As String, Optional ByVal Length As Long = 0, Optional ErrCode As Integer = 0) As String
Public Declare Function AllocString Lib "mslib145.dll" (ByVal l As Long, _
            Optional ByVal BlankChar As Byte = 0) As String
Public Declare Function ArgFound Lib "mslib145.dll" (ByRef v As Variant, ByVal s As String, _
            Optional ByVal IgnoreCase As Boolean = True) As Boolean
Public Declare Function ArgVal Lib "mslib145.dll" (ByRef v As Variant, ByVal s As String, _
            Optional ByVal IgnoreCase As Boolean = True) As String
Public Declare Function BracketStr Lib "mslib145.dll" (ByVal s As String, _
        ByVal p As Long, Optional ByVal StripBrackets As Boolean = False) As String
Public Declare Function CommaStr Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal Decimals As Integer = 0) As String
Public Declare Function Comma Lib "mslib145.dll" (ByVal value As Double, _
            Optional ByVal Decimals As Integer = 0) As String
Public Declare Function CSVSplit Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal ArrayBase As Long = 0, _
            Optional ByVal SeparatorCharVal As Byte = 44) As Variant
Public Declare Function ElementCount Lib "mslib145.dll" (ByRef v As Variant) As Long
    
Public Declare Function FillString Lib "mslib145.dll" (ByVal s As String, _
    ByVal CharToUse As String) As String
' VB6-Compatible Filter Function
#If VB5 Then    'This function is built-in in VB6
Public Declare Function Filter Lib "mslib145.dll" (ByRef v As Variant, _
            ByVal FilterString As String, Optional ByVal Include As Boolean = True, _
            Optional ByVal Compare As Integer = 0) As Variant
#End If
Public Declare Function FindClosingBracket Lib "mslib145.dll" (ByVal s As String, _
        ByVal p As Long) As Long

Public Declare Function GetArrayDimensions Lib "mslib145.dll" (ByRef v As Variant) As Long
Public Declare Function GetArrayCount Lib "mslib145.dll" (ByRef v As Variant) As Long
Public Declare Function GetCGIArgs Lib "mslib145.dll" (ByVal s As String, _
            ByRef v As Variant) As Integer
Public Declare Function GetFileName Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function GetFileExt Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function InStrI Lib "mslib145.dll" (ByVal s As String, ByVal Search As String) As Long
Public Declare Function InStrIWildcard Lib "mslib145.dll" (ByVal s As String, ByVal Search As String) As Long
Public Declare Function InStrSet Lib "mslib145.dll" (ByVal s As String, ByVal SearchSet As String) As Long
Public Declare Function InStrSetBool Lib "mslib145.dll" (ByVal s As String, ByVal Search As String) As Boolean
Public Declare Function InChrRev Lib "mslib145.dll" (ByVal s As String, ByVal iChar As Integer) As Long
Public Declare Function InChr Lib "mslib145.dll" (ByVal s As String, ByVal iChar As Integer) As Long
Public Declare Function InsertString Lib "mslib145.dll" (ByVal s As String, _
            ByVal NewString As String, _
            Optional ByVal InsertPos As Long = 1) As String
Public Declare Function InStrRev Lib "mslib145.dll" (ByVal s As String, _
            ByVal Search As String, Optional ByVal StartPos As Long = -1, _
            Optional ByVal CompareMethod As Integer = vbBinaryCompare) As Long
Public Declare Function IsAllChar Lib "mslib145.dll" (ByVal s As String, ByVal TheChar As String) As Boolean
Public Declare Function IsValidVariant Lib "mslib145.dll" (ByRef v As Variant) As Boolean
#If VB5 Then    'This function is built-in in VB6
Public Declare Function Join Lib "mslib145" (ByRef v As Variant, Optional ByVal Separator As String = vbNullString, _
            Optional ByVal RemoveEmptyItems As Boolean = False) As String
#End If
Public Declare Sub Lower Lib "mslib145.dll" (ByRef s As String)
Public Declare Function LowerStr Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function MatchBrackets Lib "mslib145.dll" (ByVal s As String, ByVal LH As String, _
            ByVal rh As String) As Long
Public Declare Function MidCharStr Lib "mslib145.dll" (ByVal s As String, ByVal ch As String, _
            Optional ByVal ReverseSearch As Boolean = False) As String
Public Declare Function MidStrStr Lib "mslib145.dll" (ByVal s As String, ByVal SubStr As String, _
            Optional ByVal ReverseSearch As Boolean = False) As String
Public Declare Function QSort Lib "mslib145.dll" (ByRef v As Variant, _
            Optional ByVal ReverseSort As Boolean = False, _
            Optional ByVal IgnoreCase As Boolean = False) As Variant
Public Declare Function QSortStr Lib "mslib145.dll" (ByRef s() As String, _
            Optional ByVal ReverseSort As Boolean = False, _
            Optional ByVal IgnoreCase As Boolean = False, _
            Optional ByVal Reserved As Boolean = False) As Boolean
Public Declare Function QSortVal Lib "mslib145.dll" (ByRef v As Variant, _
            Optional ByVal ReverseSort As Boolean = False _
            ) As Variant
' ,const short allow_mixed_variants=1   ' Disabled
#If VB5 Then    'This function is built-in in VB6
Public Declare Function Replace Lib "mslib145.dll" (ByVal s As String, ByVal Find As String, _
            ByVal ReplaceWith As String) As String
#End If
Public Declare Function ReplaceChar Lib "mslib145.dll" (ByVal s As String, _
    ByVal SearchedFor As String, ByVal Replacement As String) As String
Public Declare Function ReverseWords Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function SliceLeft Lib "mslib145.dll" (ByRef s As String, ByVal RemoveBytes As Long) As Boolean
Public Declare Function StrCSpan Lib "mslib145.dll" (ByVal s As String, ByVal MaskString As String) As Long
Public Declare Function StripLStr Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripL Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripRStr Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripR Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
'VB6 Split Function Emulated
#If VB5 Then    'This function is built-in in VB6
Public Declare Function StrSplit Lib "mslib145.dll" (ByVal ArgString As String, _
            Optional ByVal Delimiter As String = "", _
            Optional ByVal ArrayBase As Integer = 0, _
            Optional ByVal IgnoreCase As Boolean = False) As Variant
#End If
#If VB5 Then    'This function is built-in in VB6
Public Declare Function StrRev Lib "mslib145.dll" (ByVal s As String) As String
#End If
Public Declare Sub SwapStr Lib "mslib145.dll" (ByRef a As String, ByRef b As String)
Public Declare Function SysLen Lib "mslib145.dll" (ByVal s As String) As Long
Public Declare Function Tokenise Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal Delimiters As String = "", _
            Optional ByVal ArrayBase As Integer = 0, _
            Optional ByVal IgnoreCase As Boolean = False) As Variant
Public Declare Sub Upper Lib "mslib145.dll" (ByRef s As String)
Public Declare Function UpperStr Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function WildcardMatch Lib "mslib145.dll" (ByVal s As String, _
    ByVal Wildcard As String, Optional IgnoreCase As Boolean = False) As Boolean
Public Declare Function WordCount Lib "mslib145.dll" (ByVal s As String) As Long
Public Declare Function WordList Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal ArrayBase As Integer = 0) As Variant
Public Declare Function WordWrap Lib "mslib145.dll" (ByVal s As String, _
            ByVal Width As Long, ByRef NewLen As Long) As String


' Data Conversion Functions ///////////////////////////////////////////////////

' Bit Rotation
Public Declare Function RotlByte Lib "mslib145" (ByVal b As Byte, ByVal Bits As Byte) As Byte
Public Declare Function RotrByte Lib "mslib145" (ByVal b As Byte, ByVal Bits As Byte) As Byte
Public Declare Function RotlInt Lib "mslib145" (ByVal i As Integer, ByVal Bits As Byte) As Integer
Public Declare Function RotrInt Lib "mslib145" (ByVal i As Integer, ByVal Bits As Byte) As Integer
Public Declare Function RotlLong Lib "mslib145" (ByVal l As Long, ByVal Bits As Byte) As Long
Public Declare Function RotrLong Lib "mslib145" (ByVal l As Long, ByVal Bits As Byte) As Long

' Bit Shifting
Public Declare Function ShlByte Lib "mslib145" (ByVal b As Byte, ByVal Bits As Byte) As Byte
Public Declare Function ShrByte Lib "mslib145" (ByVal b As Byte, ByVal Bits As Byte) As Byte
Public Declare Function ShlInt Lib "mslib145" (ByVal i As Integer, ByVal Bits As Byte) As Integer
Public Declare Function ShrInt Lib "mslib145" (ByVal i As Integer, ByVal Bits As Byte) As Integer
Public Declare Function ShlLong Lib "mslib145" (ByVal l As Long, ByVal Bits As Byte) As Long
Public Declare Function ShrLong Lib "mslib145" (ByVal l As Long, ByVal Bits As Byte) As Long

' Base Conversion
Public Declare Function BaseConv Lib "mslib145.dll" (ByVal value As Long, _
            ByVal Base As Integer) As String
Public Declare Function BaseConvDouble Lib "mslib145.dll" (ByVal value As Double, _
            ByVal Base As Integer) As String
Public Declare Function Bin8 Lib "mslib145.dll" (ByVal i As Byte) As String
Public Declare Function Bin16 Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function Bin32 Lib "mslib145.dll" (ByVal i As Long) As String
Public Declare Function DecToBin Lib "mslib145.dll" (ByVal i As Long, _
            Optional ByVal StripLeadingZeroes As Boolean = False) As String

' Byte and Integer overloaded versions? (no proper overloading in VB) ...
Public Declare Function BinToDec Lib "mslib145.dll" (ByVal s As String) As Long
Public Declare Function BitPack Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal Length As Long) As String
Public Declare Function BitUnPack Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal BitPairs As Long) As String
Public Declare Function RotateByte Lib "mslib145.dll" (ByRef b As Byte) As Byte
Public Declare Function RotateInt Lib "mslib145.dll" (ByRef i As Integer) As Integer
Public Declare Function RotateLong Lib "mslib145.dll" (ByRef l As Long) As Long

' Charhex, HexChar, HexInt, HexLong have changed names from V1.07+
Public Declare Function CharToHex Lib "mslib145.dll" (ByVal b As Integer) As String
Public Declare Function HexToChar Lib "mslib145.dll" (ByVal HexPair As String) As Byte
Public Declare Function HexToDouble Lib "mslib145.dll" (ByVal Str As String) As Double
Public Declare Function HexToInt Lib "mslib145.dll" (ByVal Str As String) As Integer
Public Declare Function HexToLong Lib "mslib145.dll" (ByVal Str As String) As Double
Public Declare Function HexToStr Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function IntToHex Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function LongToHex Lib "mslib145.dll" (ByVal l As Double) As String
Public Declare Function PrintR Lib "mslib145.dll" (ByRef v As Variant, _
                Optional ByVal ShowEmpty As Boolean = True) As Long
Public Declare Function StringToHex Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function StrToHex Lib "mslib145.dll" (ByVal s As String, _
                Optional ByVal Length As Long, _
                Optional ByVal WrapWidth As Integer) As String

'Public Declare Function StrToHex Lib "mslib145.dll" (ByVal s As String, _
'            ByVal length As Long, _
'            Optional ByVal WrapWidth As Integer) As String
    
' Misc Conversion routines
Public Declare Function DecimalToRoman Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function RomanToDecimal Lib "mslib145.dll" (ByVal s As String) As Integer
Public Declare Function RomanDigitToDecimal Lib "mslib145.dll" (ByVal c As Byte) As Integer
' Double to ANSI String
Public Declare Function DToA Lib "mslib145.dll" (ByVal d As Double) As String

' Legacy BASIC functions /////////////////////////////////////////////////////////

' CV*/MK* Data Conversion - VB data types (byte sizes)
' Byte                  1 byte  0 to 255 ("C" char)
' Integer               2 bytes -32,768 to 32,767 ("C" short)
' Long (long integer)   4 bytes -2,147,483,648 to 2,147,483,647&  ("C" integer)
' Single (single-precision floating-point)   4 bytes -3.402823E38 to -1.401298E-45 for negative values; 1.401298E-45 to 3.402823E38 for positive values
' Double (double-precision floating-point)   8 bytes -1.79769313486232E308 to
' -4.94065645841247E-324 for negative values; 4.94065645841247E-324 to 1.79769313486232E308 for positive values

Public Declare Function Cvd Lib "mslib145.dll" (ByVal Str As String) As Double
Public Declare Function Cvf Lib "mslib145.dll" (ByVal Str As String) As Single
Public Declare Function Cvi Lib "mslib145.dll" (ByVal Str As String) As Integer
Public Declare Function Cvl Lib "mslib145.dll" (ByVal Str As String) As Long
Public Declare Function Mkd Lib "mslib145.dll" (ByVal d As Double) As String
Public Declare Function Mkf Lib "mslib145.dll" (ByVal f As Single) As String
Public Declare Function Mki Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function Mkl Lib "mslib145.dll" (ByVal l As Long) As String

' Windows API functions ///////////////////////////////////////////////////

Public Declare Function AddEventSource Lib "mslib145.dll" (ByVal AppName As String, _
            Optional ByVal CategoryCount As Integer = 0) As Boolean
Public Declare Function CreateGUID Lib "mslib145.dll" ( _
            Optional ByVal Formatted As Boolean = True) As String
Public Declare Function DiskFree Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function DiskFreeGig Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function DiskFreeMeg Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function DirExists Lib "mslib145.dll" (ByVal DirSpec As String) As Boolean
Public Declare Function DriveExists Lib "mslib145.dll" (ByVal DriveSpec As String) As Boolean
Public Declare Function FileExists Lib "mslib145.dll" (ByVal FileSpec As String) As Boolean
Public Declare Function FileLength Lib "mslib145.dll" (ByVal Filename As String) As Long
Public Declare Function GetAppFileName Lib "mslib145.dll" (Optional ByVal Handle As Long = 0&) As String
Public Declare Function GetAvailablePhysicalMemory Lib "mslib145.dll" () As Double
Public Declare Function GetAvailableSwapfileMemory Lib "mslib145.dll" () As Double
Public Declare Function GetAvailableVirtualMemory Lib "mslib145.dll" () As Double
Public Declare Function GetColourSelection Lib "mslib145.dll" (ByVal hWnd As Long, Optional FullExpand As Boolean = True, _
                        Optional RGBCurrentColour As Long = 0) As Long
Public Declare Function GetCurrentDir Lib "mslib145.dll" () As String
Public Declare Function GetDLLFileName Lib "mslib145.dll" () As String
Public Declare Function GetDiskSize Lib "mslib145.dll" (ByVal DiskLetter As String, _
            Optional ByVal CompensateBy10K As Boolean = True) As Currency
Public Declare Function GetDiskSizeMb Lib "mslib145.dll" (ByVal DiskLetter As String) _
            As Long
Public Declare Function GetDiskSizeGb Lib "mslib145.dll" (ByVal DiskLetter As String) _
            As Double
Public Declare Function GetError Lib "mslib145.dll" () As Long
Public Declare Function GetOpenFile Lib "mslib145.dll" (ByVal hWnd As Any, _
            ByVal Filter As String, ByVal Filename As String, _
            ByVal InitDir As String, ByVal Flags As Integer) As String
Public Declare Function GetLocalDriveStrings Lib "mslib145.dll" () As String
Public Declare Function GetProfileDir Lib "mslib145.dll" (ByVal FolderFlags As Integer) As String
Public Declare Function GetSaveFile Lib "mslib145.dll" (ByVal hWnd As Any, _
            ByVal Filter As String, ByVal Title As String, _
            ByVal InitDir As String, ByVal DefaultName As String, _
            ByVal Flags As Integer) As String
Public Declare Function GetSystemDir Lib "mslib145.dll" () As String
Public Declare Function GetTotalPhysicalMemory Lib "mslib145.dll" () As Double
Public Declare Function GetTotalSwapfileMemory Lib "mslib145.dll" () As Double
Public Declare Function GetTotalVirtualMemory Lib "mslib145.dll" () As Double
Public Declare Function GetUserDir Lib "mslib145.dll" () As String
Public Declare Function GetVolumeFileSystem Lib "mslib145.dll" (ByVal RootDirString As String) As String
Public Declare Function GetVolumeLabel Lib "mslib145.dll" (ByVal RootDirString As String) As String
Public Declare Function GetVolumeNameLength Lib "mslib145.dll" (ByVal RootDirString As String) As Long
Public Declare Function GetVolumeSerial Lib "mslib145.dll" (ByVal RootDirString As String) As Long
Public Declare Function GetWallpaper Lib "mslib145.dll" () As String
Public Declare Function GetWallpaperStyle Lib "mslib145.dll" () As Integer
Public Declare Function GetWindowsDir Lib "mslib145.dll" () As String
Public Declare Function IsClipboardEmpty Lib "mslib145.dll" () As Boolean
Public Declare Function IsEventSource Lib "mslib145.dll" (ByVal AppName As String) _
            As Boolean
Public Declare Function IsNetworked Lib "mslib145.dll" () As Boolean
Public Declare Function IsMousePresent Lib "mslib145.dll" () As Boolean
Public Declare Function IsSafeMode Lib "mslib145.dll" () As Boolean
Public Declare Function IsSlowMachine Lib "mslib145.dll" () As Boolean
Public Declare Function logevent Lib "mslib145.dll" Alias "LogEvent" (ByVal AppName As _
            String, ByVal Message As String, ByVal LogType As _
            Integer, Optional ByVal PostScript As String = vbNullString) As Boolean
Public Declare Function MonitorCount Lib "mslib145.dll" () As Integer
Public Declare Sub PrintScreen Lib "mslib145.dll" ()
Public Declare Function ReadStringFromRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
            ByVal SubKey As String, ByVal value As String) As String
Public Declare Function ReadDWORDFromRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
            ByVal SubKey As String, ByVal value As String, ByRef DWORDValue As Long) As Boolean
Public Declare Function RemoveEventSource Lib "mslib145.dll" (ByVal AppName As String) _
            As Boolean
Public Declare Function SetCurrentDir Lib "mslib145.dll" (ByVal Path As String) As Boolean
Public Declare Function SetWallpaper Lib "mslib145.dll" (ByVal Filename As String, _
            Optional ByVal Style As Integer = 1) As Boolean  ' Default style is centred
Public Declare Function ShellRun Lib "mslib145.dll" (ByVal Command As String) _
            As Boolean
Public Declare Function ShowFileProperties Lib "mslib145.dll" (ByVal s As String, _
            Optional ByVal hWnd As Long = 0) As Boolean
Public Declare Function WriteDWORDToRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
            ByVal SubKey As String, ByVal value As String, ByVal DWORDValue As Long) As Boolean
Public Declare Function WindowsSubVersion Lib "mslib145.dll" () As String
Public Declare Function WindowsVersion Lib "mslib145.dll" () As String
Public Declare Function WindowsVersionMajor Lib "mslib145.dll" () As Long
Public Declare Function WindowsVersionMinor Lib "mslib145.dll" () As Long
Public Declare Sub WinSleep Lib "mslib145.dll" (ByVal Msecs As Integer)
Public Declare Function WriteStringToRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
            ByVal SubKey As String, ByVal value As String, ByVal Data As String) As Boolean
    
' File and Disk Functions ////////////////////////////////////////////////////

Public Declare Function AddTrailingSlash Lib "mslib145.dll" (ByVal Filename As String) As String
Public Declare Function FileCount Lib "mslib145.dll" (ByVal PathSpec As String) As Long
Public Declare Function FileNameMatch Lib "mslib145.dll" (ByVal Filename As String, _
            ByVal Wildcard As String, Optional ByVal IgnoreCase As Boolean) As Boolean
Public Declare Function FileType Lib "mslib145.dll" (ByVal Filename As String) As String
Public Declare Function GetDiskType Lib "mslib145.dll" (ByVal DriveLetter As String) As Integer
Public Declare Function GetNormalisedPath Lib "mslib145.dll" (ByVal Path As String) As String
Public Declare Function IsCDROMDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsHardDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsNetworkDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsRAMDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsReady Lib "mslib145.dll" (ByVal DriveSpec As String) As Boolean
Public Declare Function IsRemovableDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsValidDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function ListFiles Lib "mslib145.dll" (ByVal PathSpec As String, _
            Optional ByVal FileSpecs As String, Optional ByVal ArrayBase As Integer = 0, _
            Optional ByVal IgnoreCase As Boolean = False) As Variant
Public Declare Function MKDirs Lib "mslib145.dll" (ByVal Path As String) As Integer
Public Declare Function MKTempName Lib "mslib145.dll" (Optional ByVal Path As String = "", _
            Optional ByVal FileType As String = ".tmp", _
            Optional ByVal Length As Integer = 8, _
            Optional ByVal Style As Integer = RandomStringAll) As String
Public Declare Function ReadFileToString Lib "mslib145.dll" (ByVal Filename As String, _
            Optional ByVal Bytes As Long = 0, Optional ByRef ErrCode As Integer = 0) As String
' Unlink Returns: 123=Filename empty (ERROR_INVALID_NAME), 2=FNF (ERROR_FILE_NOT_FOUND), 32=File locked (ERROR_SHARING_VIOLATION)
Public Declare Function Unlink Lib "mslib145.dll" (ByVal Filename As String) As Long
' WipeFile Returns: 0=Success, 1=Invalid filename, 2=FNF, 3=Can't open file, 4=Can't Unlink() the file
Public Declare Function WipeFile Lib "mslib145.dll" (ByVal Filename As String, Optional ExtraSecure As Boolean = True) As Integer

' Date and time functions /////////////////////////////////////////////////////

Public Declare Function CTimeToVBDate Lib "mslib145.dll" (ByVal d As Double) As Date
Public Declare Function DSTAdjust Lib "mslib145.dll" (ByVal d As Date) As Double
Public Declare Function DateToHex Lib "mslib145.dll" (ByVal d As Date) As String
Public Declare Function HexToDate Lib "mslib145.dll" (ByVal s As String) As Double
' Alternate declaration
' Public Declare Function HexToDate Lib "mslib145.dll" (ByVal s As String) As Date
Public Declare Function IsLeapYear Lib "mslib145.dll" (ByVal Year As Integer) As Boolean
Public Declare Function ISOToUKDate Lib "mslib145.dll" (ByVal YYYYMMDD As String) As String
Public Declare Function NumOrd Lib "mslib145.dll" (ByVal N As Integer) As String
Public Declare Function PHPDate Lib "mslib145.dll" (ByVal d As Date, _
            Optional ByVal s As String) As String
Public Declare Function PHPDateNow Lib "mslib145.dll" (Optional ByVal s As String) As String
Public Declare Function VBDateStr Lib "mslib145.dll" (ByVal d As Date) As String
Public Declare Function VBDateMsecs Lib "mslib145.dll" (ByVal d As Date) As Integer
Public Declare Function VBDateToCTime Lib "mslib145.dll" (ByVal d As Date) As Double
Public Declare Function UKShortToISODate Lib "mslib145.dll" (ByVal DDsMMsYY As String) As String
Public Declare Function UKToISODate Lib "mslib145.dll" (ByVal DDsMMsYYYY As String) As String

' Maths functions //////////////////////////////////////////////////////////

Public Declare Function Ceil Lib "mslib145" (ByVal d As Double) As Double
Public Declare Function Expr Lib "mslib145.dll" (ByVal s As String, _
                Optional ByRef ErrorCode As Integer = 0) As Double
Public Declare Function Expression Lib "mslib145.dll" (ByVal s As String, _
                Optional ByRef ErrorCode As Integer = 0) As Double
Public Declare Function Floor Lib "mslib145" (ByVal d As Double) As Double
Public Declare Function FMod Lib "mslib145.dll" (ByVal d As Double, ByVal v As Double) As Double
Public Declare Function Gcd Lib "mslib145.dll" (ByVal a As Long, ByVal b As Long) As Long
Public Declare Function GcdDouble Lib "mslib145.dll" (ByVal a As Double, ByVal b As Double) As Double
Public Declare Function HiByte Lib "mslib145" (ByVal i As Integer) As Byte
Public Declare Function HiWord Lib "mslib145" (ByVal l As Long) As Integer
Public Declare Function LoByte Lib "mslib145" (ByVal i As Integer) As Byte
Public Declare Function LoWord Lib "mslib145" (ByVal l As Long) As Integer
Public Declare Function Max Lib "mslib145.dll" (ByVal a As Integer, _
            ByVal b As Integer) As Integer
Public Declare Function Min Lib "mslib145.dll" (ByVal a As Integer, _
            ByVal b As Integer) As Integer
Public Declare Function Integral Lib "mslib145.dll" (ByVal d As Double) As Double
Public Declare Function Fraction Lib "mslib145.dll" (ByVal d As Double) As Double
#If VB5 Then  'VB5 et. al.
Public Declare Function Round Lib "mslib145.dll" (ByVal d As Double, _
            Optional ByVal Places As Integer) As Double
#Else
'Alias for VB6 etc.
Public Declare Function VBRound Lib "mslib145.dll" Alias "Round" (ByVal d As Double, _
    Optional ByVal Places As Integer) As Double
#End If

' IP address Network and Internet ////////////////////////////////////////////

Public Declare Function IPMatch Lib "mslib145.dll" (ByVal Mask As String, _
            ByVal IP As String) As Boolean
Public Declare Function IPToLong Lib "mslib145.dll" (ByVal IP As String) As Double
Public Declare Function LongToIP Lib "mslib145.dll" (ByVal IP As Double) As String
Public Declare Function MatchCIDR Lib "mslib145.dll" (ByVal Mask As String, _
            ByVal IP As String) As Boolean
Public Declare Function URLEncode Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function URLDecode Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function MapNetworkDrive Lib "mslib145.dll" (ByVal ServerPath As String, _
            ByVal DriveLetter As String, _
            ByVal UserName As String, _
            ByVal Password As String, _
            ByRef ErrorCode As Long, _
            Optional ByVal Persistent As Boolean = False, _
            Optional OfferPromptForLogin As Boolean = False) As Boolean
    
Public Declare Function MapNextFreeNetworkDrive Lib "mslib145.dll" (ByVal ServerPath As String, _
            ByVal UserName As String, _
            ByVal Password As String, _
            ByRef ErrorCode As Long, _
            Optional ByVal Persistent As Boolean = False, _
            Optional ByVal OfferPromptForLogin As Boolean = False) As String
    
Public Declare Function UnMapNetworkDrive Lib "mslib145.dll" (ByVal DriveLetter As String, _
            Optional ByVal Persistent As Boolean = False, _
            Optional ByVal ForceIt As Boolean = False) As Long
    
Public Declare Function DisconnectFromServer Lib "mslib145.dll" (ByVal ServerName As String, _
            Optional ByVal ForceIt As Boolean = False) As Long
    
' Encoding functions ////////////////////////////////////////////////////////

'Note: 1.31 Param changed to ByRef to allow arg to be modified
' Debug Crash test
'Public Declare sub Base64Filter Lib "mslib145.dll" (ByVal s As String)
Public Declare Function Base64Filter Lib "mslib145.dll" (ByRef s As String) As String
'Note: Params below have changed from v1.31 - strings should now be ByVal to match DLB BSTR exports
'Note: Params below have changed from v1.02 - strings should now be ByRef
Public Declare Function EncodeString64 Lib "mslib145.dll" (ByVal sInput As String, _
            Optional ByVal WrapWidth As Integer = 0) As String
'Public Declare Function DecodeString64 Lib "mslib145.dll" (ByRef sInput As String) As String
Public Declare Function DecodeString64 Lib "mslib145.dll" (ByVal sInput As String, _
            ByRef NewLength As Long) As String

' Random number and Encryption
Public Declare Function EncryptString Lib "mslib145.dll" (ByVal s As String, _
            ByVal Length As Long, ByVal Password As String, _
            Optional ByVal Salt As String = "", _
            Optional ByVal ExtraSecure As Boolean = True) As Boolean
Public Declare Function Random Lib "mslib145.dll" (ByVal Lo As Long, ByVal Hi As Long) As Long
Public Declare Sub Randomise Lib "mslib145.dll" (Optional ByVal Seed As Integer)
Public Declare Function RandomStr Lib "mslib145.dll" (ByVal Length As Long, _
            Optional ByVal Style As Integer = RandomStringMixedCase) As String

' Mersenne Twister Random Number
Public Declare Sub MTRandomise Lib "mslib145.dll" (Optional ByVal Seed As Integer)
Public Declare Function MTRandomStr Lib "mslib145.dll" (ByVal Length As Long, _
            Optional ByVal Style As Integer = RandomStringMixedCase) As String
Public Declare Function MTRnd Lib "mslib145.dll" (ByVal Low As Long, ByVal High As Long) As Long
Public Declare Function MTRndDouble Lib "mslib145.dll" (ByVal Low As Double, ByVal High As Double) As Double
    
' Console colours as per "C" conventions ///////////////////////////////////////////////

' Could call these DARK* and the LIGHT* versions just * since the DARK* are very dark
' These differ from the TLB/Unicode DLL version constants
Public Const BACKGROUND_BLACK = 0
Public Const FOREGROUND_BLACK = 0
Public Const FOREGROUND_BLUE = 1
Public Const FOREGROUND_GREEN = 2
Public Const FOREGROUND_CYAN = 3
Public Const FOREGROUND_RED = 4
Public Const FOREGROUND_MAGENTA = 5
Public Const FOREGROUND_YELLOW = 6
Public Const FOREGROUND_GRAY = 7        ' Yep, American spelling
Public Const FOREGROUND_GREY = 7        ' UK (correct) spelling
Public Const FOREGROUND_INTENSITY = 8   ' Intensify the text colour

Public Const FOREGROUND_LIGHTBLUE = 1 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTGREEN = 2 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTCYAN = 3 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTRED = 4 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTMAGENTA = 5 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTYELLOW = 6 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_WHITE = FOREGROUND_GREY Or FOREGROUND_INTENSITY

Public Const BACKGROUND_BLUE = 16
Public Const BACKGROUND_GREEN = 32
Public Const BACKGROUND_CYAN = 48
Public Const BACKGROUND_RED = 64
Public Const BACKGROUND_MAGENTA = 80
Public Const BACKGROUND_YELLOW = 96 ' Mustard
Public Const BACKGROUND_GRAY = 112
Public Const BACKGROUND_GREY = 112
Public Const BACKGROUND_INTENSITY = 128
Public Const BACKGROUND_WHITE = BACKGROUND_GREY Or BACKGROUND_INTENSITY

'Console functions //////////////////////////////////////////////////////////

Public Declare Sub Cls Lib "mslib145" ()
Public Declare Function SetConsoleTitle Lib "mslib145" Alias "setConsoleTitle" (ByVal s As String) As Long
Public Declare Sub SetConsoleHTML Lib "mslib145" (ByVal Flag As Boolean)
Public Declare Function GetConsoleTitle Lib "mslib145" Alias "getConsoleTitle" () As String
Public Declare Function ConsoleOpen Lib "mslib145" () As Boolean
Public Declare Sub CloseConsole Lib "mslib145" ()
Public Declare Sub ClearConsoleAttributes Lib "mslib145" ()
Public Declare Function CommandLine Lib "mslib145" () As String
Public Declare Sub ExitProgram Lib "mslib145.dll" (ByVal ExitCode As Long)
Public Declare Function FlushConsole Lib "mslib145" () As Long
Public Declare Function GetArgs Lib "mslib145.dll" (ByVal s As String, _
            ByRef v As Variant) As Integer
Public Declare Function GetConsoleHandle Lib "mslib145.dll" () As Long
Public Declare Sub GotoXY Lib "mslib145" (ByVal x As Integer, ByVal y As Integer)
Public Declare Function HideConsole Lib "mslib145" () As Long
Public Declare Function InKey Lib "mslib145" () As Integer
Public Declare Function InNativeConsole Lib "mslib145" () As Boolean
Public Declare Function IsCursorVisible Lib "mslib145.dll" () As Boolean
Public Declare Function OpenConsole Lib "mslib145" () As Long
Public Declare Function Pause Lib "mslib145" (Optional ByVal s As String = "Press a key...") As Integer
Public Declare Function ReadLn Lib "mslib145" (ByVal l As Long) As String
Public Declare Sub SetConsoleAttributes Lib "mslib145" (ByVal Foreground As Integer, _
            Optional ByVal Background As Integer = 0)
Public Declare Sub SetCursorVisible Lib "mslib145.dll" (ByVal State As Boolean)
Public Declare Function ShowConsole Lib "mslib145" () As Long
Public Declare Function WhereX Lib "mslib145" () As Integer
Public Declare Function WhereY Lib "mslib145" () As Integer
Public Declare Function WriteLn Lib "mslib145" (Optional ByVal s As String = "") As Boolean
'We can use WriteLn as a command to write a CRLF
Public Declare Function Writes Lib "mslib145" (ByVal s As String) As Boolean
    
'Process informations ///////////////////////////////////////////////////////

Public Declare Function GetPID Lib "mslib145.dll" () As Long
Public Declare Function GetProcessMemoryUsed Lib "mslib145.dll" (ByVal PID As Long) As Long
    
'MAPI Email /////////////////////////////////////////////////////////////////

Public Declare Function MapiSend Lib "mslib145.dll" (ByVal hWindParent As Long, _
            Optional ByVal strAttachmentName As String = "", _
            Optional ByVal strSubject As String = "", _
            Optional ByVal strMessage As String = "") As Boolean
    
'RLE Compression for bitmaps etc. //////////////////////////////////////////////////

Public Declare Function RLECompressible Lib "mslib145.dll" (ByVal sInput As String) As Boolean
'short _stdcall RLECompress(LPCSTR buff, const long length, LPSTR* out, long* newlength=NULL)
Public Declare Function RLECompress Lib "mslib145.dll" (ByVal sInput As String, _
            ByRef CompressedString As String, _
            Optional ByRef CompressedLength As Long = 0) As Boolean
'Public Declare Function RLECompress Lib "mslib145.dll" (ByVal sInput As String, _
'    ByVal Length As Long, Optional ByRef NewLength As Long) As String
Public Declare Function RLEByteCount Lib "mslib145.dll" (ByVal sInput As String) As Long
Public Declare Function RLECompressedByteCount Lib "mslib145.dll" (ByVal sInput As String, _
            ByVal Length As Long) As Long
Public Declare Function RLEUncompressedByteCount Lib "mslib145.dll" (ByVal sInput As String) As Long
'short _stdcall RLEUncompress(LPCSTR buff, LPCSTR* out, unsigned long* newlength=NULL)
Public Declare Function RLEUncompress Lib "mslib145.dll" (ByVal sInput As String, _
            ByRef sOutput As String, _
            Optional ByRef NewLength As Long = 0) As Boolean
'Public Declare Function RLEUncompress Lib "mslib145.dll" (ByVal sInput As String, _
'    Optional ByRef NewLength As Long = 0) As String


'// EOD //////////////////////////////////////////////////////////////////////////////////////////
        
'/////////////////////////////////////////////////////////////////////////////////////////////////

'Extras - not in this DLL but nevertheless interesting (uncomment to enable and try out)
'Use as ...
'debug.print vbexpression("msgbox " & chr$(34) & "Hello" & chr$(34) & ",vbInformation")
'vbexpression("pi = 22/7:msgbox pi")
'VB5 Expression - evaluator
'Private Declare Function EbExecuteLine Lib "vba5.dll" (ByVal StringToExec As Long, ByVal Unknownn1 As Long, ByVal Unknownn2 As Long, ByVal fCheckOnly As Long) As Long
'VB6 expression-evaluator
'Private Declare Function EbExecuteLine Lib "vba6.dll" (ByVal StringToExec As Long, ByVal Unknownn1 As Long, ByVal Unknownn2 As Long, ByVal fCheckOnly As Long) As Long

'Public Function VBExpression(sCode As String, Optional fCheckOnly As Boolean = False) As Boolean
'   VBExpression = (EbExecuteLine(StrPtr(sCode), 0&, 0&, Abs(fCheckOnly)) = 0)
'End Function

'/////////////////////////////////////////////////////////////////////////////////////////////////

'Local VB DLL Wrapper Functions //////////////////////////////////////////////////////////////////

Public Sub VariantToArray(ByRef v As Variant, ByRef r() As String)
    ' [in] A variant string array object
    ' [out] A String array copy of the [in] Variant
    ' [return] Cannot return String() in VB5
    
    'Purpose: Convert VB or VBToolbox Variant to a 1-dimensional VB String array()
    'Rationale: Cannot assign string array variants directly to string arrays
    'and there is no built-in conversion function
    
    'NOTE: Below is VB6 and higher only thus we must return a reference via the function body
    'Public Function VariantToArray(ByRef V As Variant) As String()
    
    'Lbound will be affected by the "Option Base" setting
    Dim i As Long
    On Local Error Resume Next
    
    If Not IsEmpty(v) Then
        ReDim r(UBound(v))
        For i = LBound(v) To UBound(v)
            r(i) = v(i)
        Next
'    Else
'        ubound(r)=-1       ' Can't be done
    End If
End Sub
Public Function Base$(value As Variant, BaseVal As Variant)
    'This is implemented as a VB-wrapper to take advantage of VarType()
    'Debug.Print "Base$() VarType(x)="; VarType(x)
    'Returns empty string on error
    Dim b As Byte   'Remove unsigned part
    On Error GoTo Error
    
    b = CByte(BaseVal) 'Convert 0..255 as DLL will only accept a byte 0..16
    Select Case (VarType(value))
    Case vbByte:
        Base$ = StripTerminator(BaseConv(CByte(value), b))  '0 to 255
        'Debug.Print "BaseConv(Byte)"
    Case vbInteger:
        Base$ = StripTerminator(BaseConv(CInt(value), b))   '-32,768 to 32,767 (7FFF) fractions are rounded
        'Debug.Print "BaseConv(Integer)"
    Case vbLong:
        Base$ = StripTerminator(BaseConv(CLng(value), b))   '-2,147,483,648 to 2,147,483,647 (7FFFFFFF) fractions are rounded.
        'Debug.Print "BaseConv(Long)"
    Case Default:
        'Debug.Print "BaseConv(Unknown)"
        Base$ = ""
    End Select
    Exit Function

Error:
    Debug.Print "Error" & Err.Description & " in Base$()"
    Resume Next
End Function
Public Function Bin$(x As Variant)
    ' Bug: CInt() converts -ve integers to +ve
    'Debug.Print "VarType(x)="; VarType(x)
    On Error GoTo Error
    
    Select Case (VarType(x))
    Case vbByte:
        Bin$ = Bin8(x)  ' CByte(Bin8(
        'Debug.Print "Bin(Byte)"
    Case vbInteger:
        Bin$ = Bin16(x)    ' CInt(Bin16(
        'Debug.Print "Bin(Integer)"
    Case vbLong:
        Bin$ = Bin32(x)    ' CLng(Bin32(
        'Debug.Print "Bin(Long)"
    Case Default:
        'Debug.Print "Bin(Unknown)"
        Bin$ = ""

    End Select
    Exit Function

Error:
    Debug.Print "Error" & Err.Description & " in Bin$"
    Resume Next
End Function
Public Function IsVBToolboxDLLInstalled() As Boolean
    'IsDLLInstalled()
    'Logs a system-event error if the DLL was not found
    'Rename IsVBToolboxDLLInstalled() ?
    
    Dim r As Long
    IsVBToolboxDLLInstalled = True
    On Error GoTo NoDll
    
    r = LibVersion()           'This is common to all versions (was _libversion Alias)
    On Error GoTo 0
Fail:
    Exit Function

NoDll:
    IsVBToolboxDLLInstalled = False
    Debug.Print "Error "; Err.Number; " ("; Err.Description; ")  in IsDLLInstalled()"
    App.logevent vbCrLf & "Error " & Format$(Err.Number) & " - (" & Err.Description & ") in IsDLLInstalled", vbLogEventTypeError
    Resume Fail
End Function
Public Function VBStr(s As String) As String
    ' Convert a NULL-terminated C++ string to Vb
    ' Inadvertently named VBString() in earlier released - renamed to avoid conflict with VB
    ' VB happily permits NULL values in the middle of a string and prints as a space
    ' C and C DLLs use the NULL character to mark the end of the allocated string
    Dim i As Integer
    On Local Error Resume Next

    i = InStr(s, Chr$(0))
    If i > 0 Then
        s = Left$(s, i - 1)
    End If
    VBStr = s
End Function
Public Function StripTerminator(ByRef s As String) As String
   ' Strips a single terminator char - same as vbStr()
   Dim i As Integer
   On Local Error Resume Next
   
   i = InStr(s, Chr$(0))
   If i > 0 Then
      s = Left$(s, i - 1)
   End If
   StripTerminator = s
End Function
Public Function DLLVersion() As String
    'Version is an integer in the format "101"%->"1.01"$
    Dim VERNUM As Integer
    Dim Temp As String
    On Error GoTo NoDll

    Temp = "0.00"   'Default return (unknown)

    VERNUM = LibVersion()
    Temp = Format(VERNUM)
    If Len(Temp) = 3 Then
        Temp = Left$(Temp, 1) & "." & Right$(Temp, 2)
    End If
    DLLVersion = Temp
    Exit Function

NoDll:
    DLLVersion = "0.00"
    App.logevent "Error " & Format$(Err.Number) & " - " & Err.Description & ") in DLLVersion()", vbLogEventTypeWarning
    Resume Next
End Function
Public Function IsSet(ByVal x As Variant) As Boolean
    Dim r As Long
    On Error GoTo Error
    IsSet = False
    If VarType(x) = vbArray Then
        r = UBound(x) ' Attempt to trigger error
        IsSet = True
    ElseIf VarType(x) = vbVariant Then
        r = UBound(x) ' Attempt to trigger error
        IsSet = True
    Else
        IsSet = IsEmpty(x)
    End If
Fail:
    Exit Function
Error:
    Resume Fail
End Function
Public Function GetElementCount(v As Variant) As Long
    ' Retrieves the number of elements in a Variant array
    ' If not allocated or not an array then -1 is returned
    On Local Error Resume Next
    GetElementCount = -1
    If Not IsEmpty(v) Then
        GetElementCount = UBound(v) + 1 - LBound(v)
    End If
End Function
Public Function GetProcAddress(ByVal Addr As Long) As Long
    ' Return a procedure's address
    ' Call as x=GetProcAddress(AddressOf Procedure)
    GetProcAddress = Addr
End Function


'EOF //////////////////////////////////////////////////////////////////////////////////

'PRIVATE DEVELOPER'S DEBUG ROUTINES BELOW // Not for consumer-use /////////////////////

'//////////////////////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////////////////////

Public Function BitPackToCArray(s As String, Optional StructWidth As Integer = 32) As String
    ' DEBUG only ///////////////////////////////////////////////////////
    ' A temporary debug-routine - this code may be deleted or ignored
    ' Debug function which creates a "C" source-code array (string) declaration holding Pi to 1302 places BitPacked down to 651 bytes
    ' M Shaw - June 2008 - DEBUGGING and DEVELOPMENT ONLY

    Dim r As String
    Dim l As Integer
    Dim i As Integer
    Dim t As String
    On Error GoTo Error
    
    Debug.Print "s="; StrToHex(s, Len(s))
    t = ""  ' Pre-empt failed return
    r = VBStr(BitPack(s))
    If r <> "" Then
        Debug.Print "r="; StrToHex(r, Len(r))
        t = "unsigned char myarray[]={" & vbCrLf
        l = Len(r)
        For i = 1 To l - 1
            t = t & "0x" & Hex$(Asc(Mid$(r, i, 1))) & ","
            If i > 0 And i Mod StructWidth = 0 Then t = t & vbCrLf
        Next
        t = t & "0x" & Hex$(Asc(Mid$(r, i, 2)))
        ' Print last with no comma postfix
        t = t & vbCrLf & "}; /* Array has " & Format$(l) & " byte(s) */"
    End If
    BitPackToCArray = t
    Exit Function

Error:
    Debug.Print "Error: " & Err.Description & " in BitPackToCArray()"
    Resume Next
End Function
Public Function IsoWeekNumber(d1 As Date) As Integer
    ' DEBUG DEBUG CODE ONLY - June 2008 ///////////////////////////////////////////////
    ' A temporary debug-routine - this code may be deleted or ignored
    ' Attributed to Daniel Maher - included for debug-comparison and checking with PHPDate(x,"W") only
    Dim d2 As Long
    d2 = DateSerial(Year(d1 - WeekDay(d1 - 1) + 4), 1, 3)
    IsoWeekNumber = Int((d1 - d2 + WeekDay(d2) + 5) / 7)
End Function

' ////////////////////////////////////////////////////////////////////////////////////

'Public Sub test()   ' This subroutine block may be safely-deleted
'    ' A temporary test-routine - this code may be safely deleted or simply ignored
'    ' These are basically sanity-checks and quick tests to be run when code is modified or updated
'    ' it's contents will change drastically from day-to-day and it may contain "dead" code
'    ' Yes, the use of GOTO is very bad (even in assembler eh?)
'
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If
'    '1909 - user lockout
'    '2999 - no more drive letters
'    '#define ERROR_BAD_NET_NAME  67L
'    'ERROR_ALREADY_ASSIGNED  85L
'    'ERROR_BAD_DEVICE  1200L
'    'ERROR_BAD_LOGIN  1326L   //Unknown username or bad password
'    'ERROR_SESSION_CREDENTIAL_CONFLICT  1219
'    'ERROR_NOT_CONNECTED  2250
'
'    Dim i As Long    ' Always
'    Dim b As Boolean
'    Dim s As String
'    Dim v As Variant
'GoTo vttest
'GoTo TestLogEvent
'    'Debug.Print "REG:Wallpaper SET=["; WriteStringToRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper", "Fred.bmp"); "]"
'    'Debug.Print "REG:Wallpaper    =["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    'GoTo Wallpaper
'End
'
'    '//////////////////////////////////////////
'    'Test Get disk drive types
''    For i = Asc("C") To Asc("F")
''    Debug.Print "GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''    Next
''    i = Asc("Q")
''    Debug.Print "CHECK GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''
''    i = Asc("Z") + 1
''    Debug.Print "CHECK GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''
''End

'    ' bug - adds vb5.exe in IDE
'TestLogEvent:
'    ' Test "NT" event-logging //////////////////////////////////////////////////////////////////////////
'    Debug.Print "getdllfilename="; GetDLLFileName()
'    'Debug.Print "RemoveEventSource="; RemoveEventSource("VBToolbox")
'    If Not IsEventSource("VBToolbox") Then
'        Debug.Print "VBToolbox is not set as an event-source"
'        Debug.Print "ADDING NEW - AddEventSource="; AddEventSource("VBToolbox", 0)
'    End If
'    Debug.Print "LogEvent="; logevent("VBToolbox", vbCrLf & "Testing SUCCESS message", EVENTLOG_SUCCESS, vbCrLf & "(Error: 0x00)")
'    DoEvents
'
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test ERROR message", EVENTLOG_ERROR_TYPE, vbCrLf & "(Error: 0x01)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test WARNING message", EVENTLOG_WARNING_TYPE, vbCrLf & "(Error: 0x02)")
'    DoEvents
'
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test INFORMATION message", EVENTLOG_INFORMATION_TYPE, vbCrLf & "(Error: 0x03)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test AUDIT-SUCCESS message", EVENTLOG_AUDIT_SUCCESS, vbCrLf & "(Error: 0x04)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test AUDIT-FAILURE message", EVENTLOG_AUDIT_FAILURE, vbCrLf & "(Error: 0x05)")
'    DoEvents
'End

'vttest:
'    'Test query string CGIArgs()
'    'QUERY_STRING=submit=true&arg2=2&another=3
'    ' Useage: i=GetCGIArgs(environ("QUERY_STRING"),v)
'    's = "fred.cgi?one=1&2=two&three=three"
'    s = "submit=true&arg 2=2&another%20one=3&something%20else=four&no encode=5"
'    'Debug.Print "Variant array dimensions are ["; GetArrayDimensions(V); "]"
'    Dim v1(10) As Variant
'    Dim vt(10, 1) As Variant
'    Dim V2 As Variant
'    'vt(1, 0) = "one"
'    'vt(2, 0) = "Two"
'    'vt(3, 0) = 23534
'    Debug.Print "UBound(vt)="; UBound(vt)
'    Debug.Print "Variant array dimensions of VB v1 (x) are ["; GetArrayDimensions(v1); "]"
'    Debug.Print "Variant array dimensions of VB vt (x,y) are ["; GetArrayDimensions(vt); "]"
'    Debug.Print "Variant array dimensions of (empty) v are ["; GetArrayDimensions(v); "]"
'
'    's = "c:\windows\woods*.* /q"
'    i = GetCGIArgs(URLDecode(s), v)
'    'i = GetArgs(s, V)
'    Debug.Print "Type of (empty) v is "; TypeName(VarType((v))); " #"; VarType(v) ' Crash!
'    'V = Tokenise(s, "&")
'    Debug.Print "Returned argument count was "; i
'    If Not IsEmpty(v) Then
'        Debug.Print "Variant array dimensions of (filled) v are ["; GetArrayDimensions(v); "]"
'        Debug.Print "Lbound of v is "; LBound(v)
'        Debug.Print "Ubound of v is "; UBound(v)
'        'Debug.Print "Type of (filled) v is "; VarType((V)) ' Crash!
'        For i = LBound(v) To UBound(v)
''BUG returning wrong type - thus cannot chain other functs without cstr()
'            Debug.Print "item "; i; ":=["; v(i); "] vartype="; VarType(v(i)); "("; TypeName(v(i))
'            'Debug.Print CStr(V(i))
'            'Debug.Print "item "; i; ":=["; (v(i)); "]"
'        Next
'        'Debug.Print i
'    End If
'    Debug.Print "ArgFound(v,  another one)="; ArgFound(v, "another one", True)
'    Debug.Print "ArgVal(v,  another one)=["; ArgVal(v, "another one", True); "]"

'End
'End Sub

'Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If
'    ' Test ListFiles()
'    Dim v As Variant
'    Dim v2 As Variant
'    v = ListFiles("c:\windows\system32\", "*.sys")
'    Debug.Print "Variant array dimensions of v are ["; GetArrayDimensions(v); "]"
'    Debug.Print "Ubound(v)="; UBound(v)
'
'    v2 = ListFiles("c:\*.txt", "")
'    Debug.Print "Ubound(v)="; UBound(v2)
'    If Not IsEmpty(v) Then Debug.Print "v(0)=("; v(0); ") *.sys"
'    If Not IsEmpty(v) Then Debug.Print "v(1)=("; v(1); ") *.sys"
'    If Not IsEmpty(v2) Then Debug.Print "v2(0)=("; v2(0); ") *.txt"
'    If Not IsEmpty(v2) Then Debug.Print "v2(1)=("; v2(1); ") *.txt"
'    End
'End Sub

'public sub Test()
'    ' Test drive-mapping ////////////////////////////////////////////////////////////////////////
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    Dim ErrorCode As Long
'    Dim dr As String
'    Dim ServerName As String
'    Dim UserName As String
'    Dim Password As String
'    ErrorCode = 0
'    ServerName = "\\xxxx"
'    UserName = "Admin"
'    Password = "******"
'
''    Debug.Print "Attaching to server "; ServerName
''    b = AttachToServer(ServerName, UserName, Password, errorcode)
''    Debug.Print "AttachToServer("; ServerName; ")="; b
''    Debug.Print "AttachingToServer errorcode=["; NetErrorMsg(errorcode) "]"
'
'    Debug.Print "Disconnecting..."
'    ErrorCode = DisconnectFromServer(ServerName)
'    Debug.Print "DisconnectFromServer Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "Done."
'
'    dr = "q:"
'    Debug.Print "Unmapping "; dr
'    ErrorCode = UnMapNetworkDrive(dr)
'    Debug.Print "UnMapNetworkDrive=["; NetErrorMsg(ErrorCode); "]"
'
'    'Use vbNullString to pass "NULL" to "C" routines
'    'Debug.Print "MapNetworkDrive="; MapNetworkDrive(ServerName & "\drive-d$", dr, UserName, Password, ErrorCode, False, True)
'    Debug.Print "MapNetworkDrive="; MapNetworkDrive(ServerName & "\drive-d$", dr, vbNullString, vbNullString, ErrorCode)
'    Debug.Print "MapNetworkDrive Q: errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "DriveExists(Q:)="; DriveExists("Q:")
'
'    For i = 1 To 1
'    Debug.Print "Mapping next free drive..."
'    'dr = MapNextFreeNetworkDrive(ServerName & "\drive-d$", UserName, Password, ErrorCode)
'    dr = MapNextFreeNetworkDrive(ServerName & "\drive-d$", vbNullString, vbNullString, ErrorCode)
'    Debug.Print "MapNextFreeNetworkDrive drive return ("; i; ") was ["; dr; "]"
'    Debug.Print "MapNextFreeNetwork Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Next
'
'    Debug.Print "Disconnecting..."
'    ErrorCode = DisconnectFromServer(ServerName)
'    Debug.Print "DisconnectFromServer Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'
'    dr = "q:"
'    Debug.Print "Unmapping "; dr
'    ErrorCode = UnMapNetworkDrive(dr, False, True)
'    Debug.Print "UnMapNetworkDrive=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "DriveExists(Q:)="; DriveExists("Q:")
'    Debug.Print "Done."
'
'End
'' Test ShellRun()
''    Debug.Print ShellRun("mailto:someone@someisp.com?subject=Test email&body=Hello there")
''    Debug.Print ShellRun("http://www.google.com")
''End
'' Test ListFiles()
''    v = ListFiles("c:\temp\*.*", "*.jpg, *.txt, *.log")
''    Debug.Print IsEmpty(v)
''    If Not IsEmpty(v) Then
''        i = UBound(v)
''        Debug.Print "Ubound="; i
''        i = LBound(v)
''        Debug.Print "Lbound="; i
''        Debug.Print "V item one ["; v(LBound(v)); "]"
''        For i = LBound(v) To UBound(v)
''            'If FileType(v(i)) = "jpg" Then
''                Debug.Print "item "; i; " = ["; v(i); "] typ="; FileType(CStr(v(i)))
''            'End If
''        Next
''    Else
''        Debug.Print "Array V is emtpy!"
''    End If
'End
''    Debug.Print RotateLong(RotateLong(987654321))   ' Test little-endian byte rotation
''    Debug.Print RotateLong(RotateLong(0&))          ' Test by cyclic-inverting
''    Debug.Print RotateLong(RotateLong(-1))
''    Debug.Print RotateLong(RotateLong(1))
''    Debug.Print RotateInt(RotateInt(12345))
''    Debug.Print RotateInt(RotateInt(0))
''    Debug.Print RotateInt(RotateInt(-1))
''    Debug.Print RotateInt(RotateInt(1))
''    Debug.Print RotateByte(RotateByte(123))
''    Debug.Print RotateByte(RotateByte(0))
''    Debug.Print RotateByte(RotateByte(1))
'    End
'
''    ' Test JPEGHeader on good and known-damaged files
''    Dim Width As Integer
''    Dim Height As Integer
''    Dim Length As Long
''    Debug.Print JPEGHeader("damaged\bad.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - 512 x 768"
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\bad.jpg")
''    Debug.Print JPEGHeader("damaged\good.jpg", Width, Height, Length)
''    Debug.Print "GOOD Length="; Length; "- 536 x 752 (57762)"
''    Debug.Print "GOOD Width="; Width
''    Debug.Print "GOOD Height="; Height
''    Debug.Print JPEGCheck("damaged\good.jpg")
''    Debug.Print JPEGHeader("damaged\s.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - "
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\suzan.jpg")
''    Debug.Print JPEGHeader("damaged\nosuch.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - "
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\nosuch.jpg")
'End
'' Test for documentation code
''    Dim str As String
''    str = "The quick, brown fox jumped over the lazy dog"
''    v = Tokenise(str, " ")
''    If Not IsEmpty(v) Then
''        For i = LBound(v) To UBound(v)
''            Debug.Print v(i)
''        Next
''    End If
''    End
'End
'
'' ''Console InKey() test /////////////////////////////////////////////////////////
''    ''Dim i As Integer
''    Debug.Print "Opening console"
''    If OpenConsole() Then
''        'i = Inkey()
''        Dim j As Integer
''        i = InKey()
''        Do While i = 0
''            GotoXY 1, 1
''            WriteLn "Waiting..." & Format$(j) & " key=" & Format$(i)
''
''            Debug.Print i
''            DoEvents
''            WinSleep 100
''            DoEvents
''            'If i > 0 Then Exit Do
''            j = j + 1
''            i = InKey()
''        Loop
''        CloseConsole
''    End If
''Debug.Print "closed console"
'End
'
'' Tokenising test
''    Dim a(10) As String
''    a(0) = "1"
''    a(1) = "2"
''    a(3) = "3"
''    Dim size As Integer
''    Dim which As Integer
''    size = 10
''    which = 2
''    Dim v As Variant
''    'v = ArrayTest()
''    'v = GetArgs("/one /two,/time=3 /four")
''    'Debug.Print GetArgs("", v)
''    'Debug.Print GetArgs("/one /two,/time=3 /four", v)
''    'v = Tokenise("/one /two,/time=3 /four", " ,") ' OK/PASS
''    'v = Tokenise("", " ,")   ' OK/PASS
''    i = GetArgs("", v) ' OK/PASS
''    'i = GetArgs("/one /two,/time=3 /four", v) ' OK/PASS
''    Debug.Print i; " item(s) were returned"
''    Debug.Print "Typename ArrayTest()="; TypeName(v)
''    Debug.Print "vartype v="; VarType(v) '8200=vbArray 8192    Array + vbString    8   String
''    Debug.Print "isempty(v)="; IsEmpty(v)
''    Debug.Print "isNull(v)="; IsNull(v)
''    If Not IsEmpty(v) Then
''        Debug.Print "Lbound v="; LBound(v)
''        Debug.Print "Ubound v="; UBound(v)
''        'Debug.Print "v0-"; v(0)
''        For i = LBound(v) To UBound(v)
''            Debug.Print "V("; i; ")=["; v(i); "] len="; Len(v(i))
''        Next
''    End If
''
''    End
'    'Debug.Print "ArrayTest=["; ArrayTest(a, size, which); "]"
'
'    ' Wallpaper and Registry checks ==========================
'Wallpaper:
'
'    Dim mode As Integer
'    Dim wp As String
'    Debug.Print SetWallpaper("C:\Documents and Settings\Admin\Local Settings\Application Data\Microsoft\Wallpaper1.bmp", 4)
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'    Debug.Print "Original wallpaper has been set"
'    wp = GetWallpaper()    'WallpaperStyle | TileWallpaper 1=Normal (centre), 2=(reserved), 4=Stretch, 8=tile
'    mode = GetWallpaperStyle()
'    Debug.Print "start mode=(", mode; ")["; wp; "]" ' Our modes 1=normal, 2=tile, 4=stretch, 8=tile
'    WinSleep 2000
'    Debug.Print "NEW: SetWallpaper="; SetWallpaper("c:\windows\winnt.bmp")
'    WinSleep 2000
'
'    Debug.Print "Change TILED..."; SetWallpaper("", 2)  ' tile
'    WinSleep 2000
'
'    Debug.Print "Change STRETCH..."; SetWallpaper("", 4)  ' Stretch
'    WinSleep 2000
'
'    Debug.Print "Change CENTRED (again)..."; SetWallpaper("c:\_w\", 1)
'    WinSleep 2000
'
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'    Debug.Print "mode=(", mode; ")"
'    Debug.Print "mode: GetWallpaper=["; GetWallpaperStyle(); "] (", mode; ")"
'    Debug.Print "SetWallpaper(original)="; SetWallpaper(wp, mode) ' Put original wallpaper back
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'
'End
'    ' Some sanity checks on Replace() ======================
''    Dim r As String
''    For i = 1 To 10000
''        s = "the quick brown fox jumped over the lazy dog"
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, " ", "")
''        If Len(r) <> 36 Then
''            Debug.Print "["; r; "]"; "(check remove all spaces)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all spaces)"
''        End If
''        s = "ooooooooohooooooooooooeooooooooooooooloolooooooooooooO"    '54
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, "o", "")
''        If Len(r) <> 5 Or r <> "hellO" Then
''            Debug.Print "["; r; "]"; "(check remove all o)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all spaces)"
''            Debug.Print "checked"; i; "FAIL"
''            End
''        End If
''        s = "ooooooooooooooooooooooooooooooooooooooooooooooooo"
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, "o", "")
''        If Len(r) <> 0 Then
''            Debug.Print "["; r; "]"; "(check remove all o)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all o)"
''            Debug.Print "checked"; i; "FAIL"
''            End
''        End If
''        s = RandomStr(100) ' clear memory
''    Next
''    Debug.Print "loop-checked"; i - 1; "OK --------------"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "e", "Q")
''    Debug.Print Replace(s, " ", "Q")
''    Debug.Print Replace(s, "o", "Q")
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print "["; Replace(s, "fox", "dinosaur"); "]"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "quick brown", "dashing silver")
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "", "dinosaur"); "(check null search)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "fox ", ""); "(shrink - null replace)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "fox ", 0); "(shrink - null replace - VB replaces with zero string)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "", ""); "(check null params)"
''    Debug.Print Replace(s, "", 0); "(check null params)"
''    Debug.Print Replace(s, 0, ""); "(check null params)"
''    Debug.Print Replace(s, 0, 0); "(check null params)"
'End ' //////////////////////////////////////////////////////////////////////////////
'
''    PISTR REMOVED 03/09/2009 'PiStr() and BitUnpack mods
''    Debug.Print StrToHex(BitPack("1.234567890"))
''    Debug.Print BitUnPack(BitPack("1.234567890"))
''    For i = 1 To 20: Debug.Print Format$(i, "00"); "=["; PiStr(i); "]"; Len(VBStr(PiStr(i))): Next
'End
'
'    ' Test VB to C date functions //////////////////////////////////////////////////
'    Debug.Print "VBDate(#9/9/2001 1:46:40 AM#)="; VBDate(#9/9/2001 1:46:40 AM#)
'    Debug.Print "VBDateToCTime(#1/1/1970#)="; VBDateToCTime(#1/1/1970#); " (zero day)"
'    Debug.Print "CTimeToVBDate(VBDateToCTime(#1/1/1970#))="; CTimeToVBDate(VBDateToCTime(#1/1/1970#)); " (zero day)"
'    Debug.Print "VBDateToCTime(#9/1/2001 1:46:40 AM#)="; VBDateToCTime(#9/1/2001 1:46:40 AM#)
'    Debug.Print "VBDateToCTime(#9/9/2001#)="; VBDateToCTime(#9/9/2001#)
'    Debug.Print "CTimeToVBDate(VBDateToCTime(#9/9/2001 1:46:40 AM#))="; CTimeToVBDate(VBDateToCTime(#9/9/2001 1:46:40 AM#))
'    Debug.Print "Cycle test NOW="; CTimeToVBDate(VBDateToCTime(Now))
'    Debug.Print "VBDateToCTime(#9/9/2001 1:46:40 AM#)="; VBDateToCTime(#9/9/2001 1:46:40 AM#); " (should be 1000000000)" ' At 01:46:40 UTC on September 9, 2001, the Unix billennium (Unix time number 1000000000) was celebrated."
'    Debug.Print "PHPDate(#9/9/2001 1:46:40 AM#,  U )=("; PHPDate(#9/9/2001 1:46:40 AM#, "U"); ") (should be 1000000000)"
'    Debug.Print "PHPDate(#9/9/2001 1:46:40 AM#,  r )=("; PHPDate(#9/9/2001 1:46:40 AM#, "r"); ")"
'    Debug.Print "VBDateToCTime is:"; 1000000000 - VBDateToCTime(#9/9/2001 1:46:40 AM#); " seconds out"
'    End
'
'GoTo Bpack
'    ' A few test for PHPDate(x,"W")
'    '   Our call, (read from calendar), cross-check from VB code
'    'Check selected dates against a physical calendar for ISO week number values and cross-check back
'    Debug.Print vbStr(PHPDate(Now, "Y/m/d - W")); "(NOW)"; IsoWeekNumber(Now)
'    Debug.Print vbStr(PHPDate(#1/1/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/1/1970#)
'    Debug.Print vbStr(PHPDate(#1/2/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/2/1970#)
'    Debug.Print vbStr(PHPDate(#1/3/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/3/1970#)
'    Debug.Print vbStr(PHPDate(#1/4/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/4/1970#)
'    Debug.Print vbStr(PHPDate(#1/5/1970#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/5/1970#)
'    Debug.Print vbStr(PHPDate(#1/6/1970#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/6/1970#)
'    Debug.Print vbStr(PHPDate(#3/1/1970#, "Y/m/d - W")); "(9)"; IsoWeekNumber(#3/1/1970#)
'    Debug.Print vbStr(PHPDate(#3/2/1970#, "Y/m/d - W")); "(10)"; IsoWeekNumber(#3/2/1970#)
'    Debug.Print vbStr(PHPDate(#1/4/1992#, "Y/m/d - W")); "(1)", IsoWeekNumber(#1/4/1992#)
'    Debug.Print vbStr(PHPDate(#1/5/1992#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/5/1992#)
'    Debug.Print vbStr(PHPDate(#1/6/1992#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/6/1992#)
'    Debug.Print vbStr(PHPDate(#1/28/1992#, "Y/m/d - W")); "(5)"; IsoWeekNumber(#1/28/1992#)
'    Debug.Print vbStr(PHPDate(#5/28/1992#, "Y/m/d - W")); "(22)"; IsoWeekNumber(#5/28/1992#)
'    Debug.Print vbStr(PHPDate(#8/28/1992#, "Y/m/d - W")); "(35)"; IsoWeekNumber(#8/28/1992#)
'    Debug.Print vbStr(PHPDate(#12/28/1992#, "Y/m/d - W")); "(53)"; IsoWeekNumber(#12/28/1992#)
'    Debug.Print vbStr(PHPDate(#1/5/2008#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/5/2008#)
'    Debug.Print vbStr(PHPDate(#1/6/2008#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/6/2008#)
'    Debug.Print vbStr(PHPDate(#1/7/2008#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/7/2008#)
'    Debug.Print vbStr(PHPDate(#1/8/2008#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/8/2008#)
'    Debug.Print vbStr(PHPDate(#1/28/2008#, "Y/m/d - W")); "(5)"; IsoWeekNumber(#1/28/2008#)
'    Debug.Print vbStr(PHPDate(#5/28/2008#, "Y/m/d - W")); "(22)"; IsoWeekNumber(#5/28/2008#)
'    Debug.Print vbStr(PHPDate(#8/28/2008#, "Y/m/d - W")); "(35)"; IsoWeekNumber(#8/28/2008#)
'    Debug.Print vbStr(PHPDate(#12/28/2008#, "Y/m/d - W")); "(52)"; IsoWeekNumber(#12/28/2008#)
'
'    'Debug.Print "PHPDate(#1/1/1970#, r)="; PHPDate(#1/8/1970#, "U")
'    'Debug.Print "PHPDate(#1/1/1970 1:02:03 AM#, "; r; ")="; PHPDate(#1/1/1970 1:02:03 AM#, "r")
'    'Debug.Print "PHPDate(32000 r)=" & PHPDate(32000, "r")
'    'Debug.Print "VBDateToCTime(#1/8/1970 0:0:0#)="; VBDateToCTime(#1/8/1970#)
'End
'
''    Dim d As Date
''    d = #1/1/1970#  ' VB strips 00:00:00 from the end automatically!!!!
''    d = #5/2/2008 12:01:02 AM# ' Unix epoch end (actually ends midnight on 25th)
''    d = #6/20/2008 10:12:01 PM#
'End
'
'Bpack:
''    Dim s As String
''    ' Pi to 1302 places (compresses to 651 bytes)
''    s =  "3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679"
''    s =  b & "8214808651328230664709384460955058223172535940812848111745028410270193852110555964462294895493038196"
''    s =  b & "4428810975665933446128475648233786783165271201909145648566923460348610454326648213393607260249141273"
''    s =  b & "7245870066063155881748815209209628292540917153643678925903600113305305488204665213841469519415116094"
''    s =  b & "3305727036575959195309218611738193261179310511854807446237996274956735188575272489122793818301194912"
''    s =  b & "9833673362440656643086021394946395224737190702179860943702770539217176293176752384674818467669405132"
''    s =  b & "0005681271452635608277857713427577896091736371787214684409012249534301465495853710507922796892589235"
''    s =  b & "4201995611212902196086403441815981362977477130996051870721134999999837297804995105973173281609631859"
''    s =  b & "5024459455346908302642522308253344685035261931188171010003137838752886587533208381420617177669147303"
''    s =  b & "5982534904287554687311595628638823537875937519577818577805321712268066130019278766111959092164201989"
''    s =  b & "3809525720106548586327886593615338182796823030195203530185296899577362259941389124972177528347913151"
''    s =  b & "5574857242454150695950829533116861727855889075098381754637464939319255060400927701671139009848824012"
''    s =  b & "8583616035637076601047101819429555961989467678374494482553797747268471040475346462080466842590694912"
''    Debug.Print "Pi has " & Len(b); " places"
''    Debug.Print BitPackToCArray(b, 32)
'
''    s = "00000"  '
''    s = "900012345067890abc8978"
''    s = "+,-. 0123456790abcde"
''    s = "  +3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679"
''    s = "+1 234 567"
''    Debug.Print "Packing    ["; s
''    Debug.Print "Bitpack=   ["; BitPack(s); "]"
''    Debug.Print "Len=       ["; Len(s); "->"; Len(BitPack(s)); "]"
''    Debug.Print "Bitpack HEX["; StrToHex(BitPack(s)); "]"
''    Debug.Print "BitUnPack= ["; BitUnPack(BitPack(s)); "]"
''    Debug.Print "-------------"
'End
'
''GoTo Skip
''    For i = 1 To 100
''        d = Now
''        Debug.Print CDbl(d); " ";
''        Debug.Print vbStr(VBDate(d)); " ";
''        Debug.Print VBDateMsecs(d); " ";
''        Debug.Print Format(d, "[hh:mm:ss]"); " ";
''        Debug.Print PHPDate(DSTAdjust(d), "H:i:s")
''
''        WinSleep 100
''    Next
''    Debug.Print d, PHPDate(DSTAdjust(d))
'End
'
'Skip:
''
''    Dim u As Double
''    Debug.Print "d is: "; d
''    Debug.Print "d time is: "; Format(d, "Long Time")
''    u = CDbl(d)
''    Debug.Print "D is stored as "; Format(d, "yyyy/mmm/dd")
''
''    Debug.Print "cdbl(d) as u="; u
''    Debug.Print "VBDateToCTime(d)="; VBDateToCTime(d)
''    ' Test for Fraction() and Integral()
''    Debug.Print "Fraction(u):     "; Fraction(u)
''    Debug.Print "Integral(u):"; Integral(u)
''    Debug.Print "VBDateMsecs(u)="; VBDateMsecs(d)
''    'OK (((fraction(39619.4786805556) * 1000000.0))*1000 mod 1000)
''    Debug.Print "fr="; (Fraction((Fraction(u) * 10000#) * 1000#) * 1000)
''    Debug.Print "msecs="; ((Fraction((Fraction(u) * 10000#) * 1000#) * 1000) Mod 1000)
'''    Debug.Print "VBDate(d)="; VBDate(d)
''    '((x-(int x) * 10) mod 1000) -> 437ms
''    Debug.Print "PHPDatenow(d)="; PHPDateNow(d)   '!!!
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d))
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d, "r"))
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d, "c"))
'End
'End Sub
'
''This test-function is not publicly-used and can be commented-out or removed and replaced with a "null" stub to save space
''Public Function NetErrorMsg(ByVal ErrorNumber As Long)
''    NetErrorMsg = ""
''End Function
'
'Public Function NetErrorMsg(ByVal ErrorNumber As Long)
'    Select Case ErrorNumber
'        Case 0
'            NetErrorMsg = "No error"
'        Case 85
'            NetErrorMsg = "Device already assigned"
'        Case 86
'            NetErrorMsg = "Invalid password"
'        Case 113
'            NetErrorMsg = "Out of search handles"
'        Case 170
'            NetErrorMsg = "System is busy"
'        Case 1130
'            NetErrorMsg = "Not enough server storage available - try increasing server's IRPStackSize or PagedPoolSize"
'        Case 1909
'            NetErrorMsg = "User is locked-out"
'        Case 1200
'            NetErrorMsg = "Bad device specified"
'        Case 1201
'            NetErrorMsg = "Out of connections"
'        Case 1202
'            NetErrorMsg = "Device already remembered"
'        Case 1203
'            NetErrorMsg = "No net or bad path"
'        Case 1206
'            NetErrorMsg = "Bad profile"
'        Case 1208
'            NetErrorMsg = "Extended error"
'        Case 1210
'            NetErrorMsg = "Bad computer name"
'        Case 1214
'            NetErrorMsg = "Bad net name"
'        Case 1219
'            NetErrorMsg = "Session credential conflict"
'        Case 1223
'            NetErrorMsg = "User cancelled"
'        Case 1326
'            NetErrorMsg = "Invalid login credentials"
'        Case 2202
'            NetErrorMsg = "Bad username"
'        Case 2250
'            NetErrorMsg = "Not connected"
'        Case 2401
'            NetErrorMsg = "Open files on this connection"
'        Case 2404
'            NetErrorMsg = "Device is currently in use"
'        Case 2999
'            NetErrorMsg = "No more drive letters available"
'        Case Else
'            NetErrorMsg = "Unhandled error - " & Format$(ErrorNumber)
'    End Select
'End Function

'Public Sub test()   ' RLE
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    Dim a As String
'    Dim b As String
'    Dim l As Long
'    a = "The quick brown foxx jumped over        the lazy doggggggggggggggggg"
'    Debug.Print "Source Len(a)="; Len(a)
'    b = RLECompress(a, Len(a))
'    Debug.Print "RLE Compressible? "; RLECompressible(a)
'    Debug.Print "CompressedByteCount=["; RLECompressedByteCount(a, Len(a)); "]"
'    If RLECompressedByteCount(a, Len(a)) >= Len(a) Then
'        Debug.Print "No compression gain possible"
'    Else
'        Debug.Print "Compression gain of "; Len(a) - RLECompressedByteCount(a, Len(a)); " byte(s)"
'    End If
'    Debug.Print "compressed string is ["; b; "]"
'    Debug.Print "UncompressedByteCount=["; RLEUncompressedByteCount(b); "]"
'    Debug.Print "Uncompressed string is ; ["; RLEUncompress(b); "] "
'    Debug.Print "Uncompressed string length is "; Len(RLEUncompress(b))
'    Debug.Print "ByteCount=["; RLEByteCount(b); "]"
'
'End Sub

' /////////////////////////////////////////////////////

Public Sub CallbackSub(ByVal a As String, ByVal b As String)    ' Callback test via AddressOf
    Static count As Integer
    count = count + 1
    Debug.Print "I'm in ur callbackz messin wit ur code - call# "; count
    Debug.Print "CallbackSub(["; a; "],["; b; "])"
End Sub

Public Sub testcb()   ' Callbacks
    ' Who cleans up SysAllocString BSTRs allocated in the DLL?
    ' How it works:
    ' 1) Define a DLL function Foo which has a funct prototype parameter
    '    And any other parame Foo(var,var,..., [function ptr])
    ' 2) Create a matching callback function in VB - they must both match
    ' 3) Declare the DLL function
    ' 4) Get the proc address of the callback function
    ' 5) Call Foo() with the basic raw procaddress (no parameters are possible)
    ' 6) Input can be made with foo if this is separate from the funct var
    '    foo(ByVal i as int, ByVal L as long, etc... ByVal fptr as Long)
    '    Public Declare Sub Foo Lib "mslib145.dll" (ByVal fptr As Long) (void anyfunct)
    ' 7) Memory deallocation must be made by the DLL once the callback exits
    '    use SysFreeString() for strings etc.
    ' 8) If passing strings back to VB via paramlist then VB expects BSTR Unicode strings
    ' 9) Returning SysAllocString() non bstr seems to work OK via FB (check more)

    Dim LongVal As Long
    Dim i As Integer
    ' Testing basic DLL callbacks into VB
    ' Callback test (not part of bit shifting)
    LongVal = GetProcAddress(AddressOf CallbackSub)
    Debug.Print "Test address is "; LongVal

    For i = 1 To 10
        Foo LongVal  ' DLL Callback test   ' It works fine ! :)
    Next
    End ' Release the DLL
End Sub

'Public Sub test()   ' Bit-shifting and Bit-rotation functions
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    ' VB interface triggers Byte overflow OK at 255 and provides external guard
'    ' Not sure whether to implement guard-blocking one excess shifts or allow them to "wrap"
'    ' Decided to mask-off the bits value to the max bit length for rotation
'    ' Rot?* http://en.wikipedia.org/wiki/Circular_shift
'    Dim i As Integer
'    Dim ByteVal As Byte
'    Dim LongVal As Long
'    Dim IntVal As Integer
'
''    ByteVal = &HFF
''    ' Modulus shift OK over 7
''    For i = 0 To 16
''        Debug.Print "Shlbyte("; ByteVal; ","; i; ")="; Bin$(ShlByte(ByteVal, i))
''    Next
'
'    'Modulus shift OK over 7
'    ' Truncate mode gives identity at 64,96,192,224
''    For i = 0 To 16
''        Debug.Print "Shrbyte("; ByteVal; ","; i; ")="; Bin$(ShrByte(ByteVal, i))
''    Next
'
''    IntVal = &HFFFF
''    ' PASS Modulus shift OK over 7
''    For i = 0 To 40
''        Debug.Print "ShlInt("; IntVal; ","; Format$(i, "000"); ")="; Bin$(ShlInt(IntVal, i))
''    Next
'''    For i = 0 To 34
'''        Debug.Print "ShlInt("; IntVal; ","; Format$(i, "000"); ")="; Bin$(ShlInt(IntVal, i))
'''    Next
''    'Modulus shift OK over 7
''    ' Truncate mode gives identity at 64,96,192,224
''    For i = 0 To 40
''        Debug.Print "ShrInt("; IntVal; ","; Format$(i, "000"); ")="; Bin$(ShrInt(IntVal, i))
''    Next
'    '///////////////
'
''    LongVal = &HFFFFFFFF
''    'Pass OK visual
''    For i = 0 To 60
''        Debug.Print "Shllong("; LongVal; ","; Format$(i, "000"); ")="; Bin$(ShlLong(LongVal, i))
''    Next
'''    For i = 0 To 34
'''        Debug.Prlong "Shllong("; longVal; ","; Format$(i, "000"); ")="; Bin$(Shllong(longVal, i))
'''    Next
''    'Modulus shift OK over 7
''    ' Truncate mode gives identity at 64,96,192,224
''    For i = 0 To 60
''        Debug.Print "Shrlong("; LongVal; ","; Format$(i, "000"); ")="; Bin$(ShrLong(LongVal, i))
''    Next
'    '///////////////
'
'
'    ' ROTATE bits test /////////////////////////////
'    ' Modulus e.g.: ?(17 and (8-1))
''    ' PASS - Byte
''    ByteVal = &HCC
''    Debug.Print "Start:"; Now
''    For i = 0 To 50 ' Valid 0..16 inclusive (16 and 0 return original number)
''        Debug.Print "RotLByte(0b"; Bin$(ByteVal); ",";
''        Debug.Print Format(i, "000"); ")=0b"; Bin$(RotlByte(ByteVal, i))
''    Next
'
''    ByteVal = &HCC
''    Debug.Print "Start:"; Now
''    For i = 0 To 19
''        Debug.Print "RotRByte(0b"; Bin$(ByteVal); ","; Format(i, "000"); ")=0b"; Bin$(RotrByte(ByteVal, i))
''    Next
'
''    IntVal = &HC0C0
''    ' PASS visual
''    Debug.Print "Start:"; Now
''    For i = 0 To 64
''        Debug.Print "RotRint(0b"; Bin$(IntVal); ","; Format(i, "000"); ")=0b"; Bin$(RotrInt(IntVal, i))
''    Next
'
''    LongVal = &HC0C0C0C0
''    ' Pass visual
''    Debug.Print "Start:"; Now
''    For i = 0 To 64
''        Debug.Print "RotRLong(0b"; Bin$(LongVal); ","; Format(i, "000"); ")=0b"; Bin$(RotrLong(LongVal, i))
''    Next
'    '///////////////
'
''   PASS 0..255 in blocks (pattern match)
''    IntVal = &HCC
''    Debug.Print "Start:"; Now
''    For i = 127 To 255 ' Valid 0..16 inclusive (16 and 0 return original number)
''         Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    Next
''    'PASS Test 16^n identity
''    i = 0
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    i = 7 ' Shift to high bytes
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    i = 15
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    i = 63
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    i = 127
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
''    i = 255
''    Debug.Print "RotLInt(0b"; Bin$(IntVal); ","; Format$(i, "000"); ")=0b"; Bin$(RotlInt(IntVal, i))
'
''    For i = 64 To 128
''         Debug.Print "RotRInt(0b"; Bin$(intval); ","; i; ")=0b"; Bin$(RotrInt(intval, i))
''    Next
'    '///////////////
''
''   LongVal = &HC00C&
''    ' PASS Rot-1 FAIL SAFE VIA API
''    'OK Debug.Print "RotLlong(0b"; Bin$(LongVal); ","; Format(i, "00"); ")=0b"; Bin$(RotlLong(LongVal, -1))
''    'PASS 0..255
''    For i = 128 To 255 ' Valid 0..16 inclusive (16 and 0 return original number)
''        Debug.Print "RotLlong(0b"; Bin$(LongVal); ","; Format(i, "000"); ")=0b"; Bin$(RotlLong(LongVal, i))
''    Next
'
''    ' PASS Identity @ 0, 64, 96, 128  Powers of 32
''    Debug.Print "RotLLong() identities..."
''    For i = 0 To 7
''        Debug.Print "RotLlong(0b"; Bin$(LongVal); ","; Format(CLng(i) * 32&, "000"); ")=0b"; Bin$(RotlLong(LongVal, i * 32))
''    Next
''    Debug.Print "RotLlong(0b"; Bin$(LongVal); ","; Format(255, "000"); ")=0b"; Bin$(RotlLong(LongVal, 255))
''///////////////
'
'    End ' Release the DLL
'End Sub

'Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    ' Test MKtemp()
'    Debug.Print MKTempName("d:\tempy", 20, RandomStringLower): End
'End Sub


'Public Sub Test()  ' // JOIN ////////////////////////
''    If LibUnicode() Then
''        Debug.Print "Unicode DLL - can't continue"
''        End
''    End If
'
'    ' Testing Join() //////////////////////////////
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If
'    CloseConsole
'    Dim i As Integer
'    Dim j As Long
'    Dim Commas As String
'    Commas = Chr$(34) & "," & Chr$(34)
'    Dim vt As Variant
'    Dim v(5) As String
'    v(0) = "Zero"
'    v(1) = "One"
'    v(2) = "Two"
'    v(3) = "Three"
'    v(4) = "Four"
'    v(5) = "Five"
'    Dim s As String
'
'    Debug.Print "Ubound="; UBound(v)
'    Debug.Print "ArrayDims="; GetArrayDimensions(v)
'    s = Join(v)
'    Debug.Print "Join(v) S=["; s; "]"
'    s = Join(v, "")
'    Debug.Print "Join(v,'') S=["; s; "]"
'    s = Chr$(34) & Join(v, Commas) & Chr$(34)
'    Debug.Print "Join(v,"; Commas; ") S=["; s; "]"
'
'    MTRandomise
'    Randomise
'    For i = LBound(v) To UBound(v)
'        v(i) = MTRandomStr(Random(1, 100), RandomStringAll)
'    Next
'    s = Join(v, "")
'    Debug.Print "Join(v,'') S=["; s; "]"
'
'    v(1) = ""   ' Erase a couple of elements
'    v(3) = ""
'    v(5) = ""
'
'    Debug.Print "Start:"; Now
'    For j = 1 To 1000000     ' Memory-leak loop test
'
'    s = Join(v, , False)
'    'Debug.Print "Join(v=Partial,NULL,False) S=["; s; "]"  ' Pass
'    s = Join(v, "", False)
'    'Debug.Print "Join(v=Partial,'',False) S=["; s; "]"  ' Pass
'    s = Join(v, ",", False)
'    'Debug.Print "Join(v=Partial,',',False) S=["; s; "]"  ' Pass
'    s = Join(v, , True)
'    'Debug.Print "Join(v=Partial,NULL,True) S=["; s; "]"  ' Pass
'    s = Join(v, "", True)
'    'Debug.Print "Join(v=Partial,'',True) S=["; s; "]"  ' Pass
'    s = Join(v, ",", True)
'    'Debug.Print "Join(v=Partial,',',True) S=["; s; "]"  ' Pass
'
'    Next j
'    Debug.Print "Done: "; Now; " "; j; " loops"
'
'    'Handling null arrays safely and without GPF OK
'    Erase v
'    s = Join(v, "+")
'    Debug.Print "Join(v=NULL) S=["; s; "]"
'
'    Dim q(5) As Variant
'    q(0) = "Zero"
'    q(1) = "One"
'    q(5) = "Five"
'    s = Join(q, "+")
'    Debug.Print "Join(q=NULL) S=["; s; "]"
'    Debug.Print "Ubound="; UBound(q)
'    Debug.Print "ArrayDims="; GetArrayDimensions(q)
'    s = Join(q)
'    Debug.Print "Join(q) S=["; s; "]"
'    s = Join(q, "")
'    Debug.Print "Join(q,'') S=["; s; "]"
'    s = Chr$(34) & Join(q, Commas) & Chr$(34)
'    Debug.Print "Join(q,"; Commas; ") S=["; s; "]"
'
'    Erase q
'    s = Join(q, "+")
'    Debug.Print "Join(q=NULL,'+') S=["; s; "]"
'    ' //// Release the DLL ////
'    Erase q
'
'    vt = StrSplit("Hello there old bean", " ")
'    Debug.Print Join(vt, ",")       ' *crash*
'
'    For i = LBound(vt) To UBound(vt)
'        Debug.Print "Variant v"; i; "=["; vt(i); "]"
'    Next
'    VariantToArray vt, v    ' Wrapper function
'    Debug.Print Join(v, ",")
'
'    Debug.Print Join(StrSplit("$1$2$3a$$$5$$", "$"), ",", True)
'    Debug.Print Join(Tokenise("$1$2$3a$$$5$$", "$a2"), ",", True)
'    Erase vt
'    Debug.Print "["; Join(vt, ","); "]"
'
'    vt = StrSplit("$1$2$3a$$$5$$", "$")
'    For i = LBound(vt) To UBound(vt)
'        Debug.Print "v("; i; ")=["; vt(i); "]"
'    Next
'    Debug.Print "Join=["; Join(vt, ",", True); "]"
'
'    Erase vt
''    vt = ListFiles("c:\_txt\", "*.txt")
''    Debug.Print "Listfiles=["; Join(vt, "," & vbCrLf); "]"
'
'    Debug.Print Join(ListFiles("c:\_txt\", "t*.txt"), vbCrLf)
'
'    Debug.Print "V = ListFiles(vbNullString, vbNullString)"
'    vt = ListFiles(vbNullString, vbNullString)
'    Debug.Print "V = ListFiles(vbNullString, '')"
'    vt = ListFiles(vbNullString, "")
'    Debug.Print "V = ListFiles('', vbNullString)"
'    vt = ListFiles("", vbNullString)
'    Debug.Print "V = ListFiles('', '')"
'    vt = ListFiles("", "")
'
''     ///////////////
'    End
'End Sub


'Public Sub Test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'' Testing Filter() /////////////////
''    Public Declare Function Filter Lib "mslib145.dll" (ByRef V As Variant, _
''    ByVal FilterString As String, Optional ByVal Include As Boolean = True, _
''    Optional ByVal Compare As Integer = 0) As Variant
'
'    ' Mem leak test 100,000 loops (Variant() and String()) = *Pass* 14/Aug/2010
'
'    ' Test cases:
'    ' Test string is "the" matching -> "The" in Array
'    ' Modified *after* this test to be VB compliant regarding "" parameter
'
'    ' Input Type| Input State| Filter String | Rtn State| Pass/Fail |
'    '------------------------------------------------------------------
'    ' True,0
'    ' Variant() | NULL       | NULL          | NULL     | Pass | Not valid
'    ' Variant() | NULL       | Valid         | NULL     | Pass | Not valid
'    ' Variant() | Valid      | NULL          | NULL     | Pass | Nothing to find
'    ' Variant() | Valid      | Valid         | NULL     | Pass | Filtered array if case had matched
'
'    ' String()  | NULL       | NULL          | NULL     | Pass | Not valid
'    ' String()  | NULL       | Valid         | NULL     | Pass | Not valid
'    ' String()  | Valid      | NULL          | NULL     | Pass | Nothing to find
'    ' String()  | Valid      | Valid         | NULL     | Pass | Filtered array if case had matched
'
'    ' False, 0
'    ' Variant() | NULL       | NULL          | NULL     | Pass | Not valid
'    ' Variant() | NULL       | Valid         | NULL     | Pass | Not valid
'    ' Variant() | Valid      | NULL          | Array()  | Pass | Entire array
'    ' Variant() | Valid      | Valid         | Array()  | Pass | Entire array
'
'    ' String()  | NULL       | NULL          | NULL     | Pass | Not valid
'    ' String()  | NULL       | Valid         | NULL     | Pass | Not valid
'    ' String()  | Valid      | NULL          | Array()  | Pass | Entire array
'    ' String()  | Valid      | Valid         | Array()  | Pass | Entire array
'
'    ' True,1
'    ' Variant() | NULL       | NULL          | NULL     | Pass | Not valid
'    ' Variant() | NULL       | Valid         | NULL     | Pass | Not valid
'    ' Variant() | Valid      | NULL          | NULL     | Pass | Nothing to find
'    ' Variant() | Valid      | Valid         | Partial()| Pass | Selected items only (include)
'
'    ' String()  | NULL       | NULL          | NULL     | Pass | Not valid
'    ' String()  | NULL       | Valid         | NULL     | Pass | Not valid
'    ' String()  | Valid      | NULL          | NULL     | Pass | Nothing to find
'    ' String()  | Valid      | Valid         | Partial()| Pass | Selected items only (include)
'
'    ' False,1
'    ' Variant() | NULL       | NULL          | NULL     | Pass | Not valid
'    ' Variant() | NULL       | Valid         | NULL     | Pass | Not valid
'    ' Variant() | Valid      | NULL          | NULL     | Pass | Nothing to find
'    ' Variant() | Valid      | Valid         | Partial()| Pass | Selected items only (exclude)
'
'    ' String()  | NULL       | NULL          | NULL     | Pass | Not valid
'    ' String()  | NULL       | Valid         | NULL     | Pass | Not valid
'    ' String()  | Valid      | NULL          | Array()  | Pass | Entire array
'    ' String()  | Valid      | Valid         | Partial()| Pass | Selected items only (exclude)
'
'    ' For each above test with Include True,False
'    ' For each above test with Compare=0,1
'    ' 32 cases 8 x 4
'
'    Dim s As String
'    Dim i As Integer
'    Dim l As Long
'    Dim SearchString As String
'    Dim Include As Boolean
'
'    Dim vt As Variant           ' Return variant object
'    Dim mt As Variant
'
'    Dim V(5) As Variant
'    V(0) = "The"
'    V(1) = "qbf"
'    V(2) = "Jumped"
'    V(3) = "over"
'    V(4) = "The"
'    V(5) = "Lazy dog"
'
'    Dim a(5) As String
'    a(0) = "The"
'    a(1) = "qbf"
'    a(2) = "Jumped"
'    a(3) = "over"
'    a(4) = "The"
'    a(5) = "Lazy dog"
'
'    Dim q() As String ' NULL string array
'    ' /////////////////////
'    CloseConsole
'
'    'vt = Filter(V, "the", False, 1)    ' For test block (above)
'
'''    vt = ListFiles("c:\", "bcmwl5.log")
''    If Not IsEmpty(vt) Then
''        Debug.Print "Lbound(vt)="; LBound(vt)
''        Debug.Print "Ubound(vt)="; UBound(vt)
''        For i = LBound(vt) To UBound(vt)
''        If Not IsEmpty(vt(i)) Then
''                Debug.Print "Variant vt"; i; "=["; vt(i); "]"
''            Else
''                Debug.Print "Variant vt("; i; ") is empty"
''            End If
''        Next
''    Else
''        Debug.Print "Returned Vt is empty"
''    End If
''    End
'
'    'For l = 1 To 100000
'
'    SearchString = "The"
'    Include = True
'
'    'Debug.Print UBound(vt)
'
'    Debug.Print "Testing Variant array v()"
'    vt = Filter(V, SearchString, Include)
'    If Not IsEmpty(vt) Then
'        Debug.Print "Lbound(vt)="; LBound(vt)
'        Debug.Print "Ubound(vt)="; UBound(vt)
'        For i = LBound(vt) To UBound(vt)
'        If Not IsEmpty(vt(i)) Then
'                Debug.Print "Variant vt("; i; ")=["; vt(i); "]"
'            Else
'                Debug.Print "Variant vt("; i; ") is empty"
'            End If
'        Next
'    Else
'        Debug.Print "Returned Vt is empty"
'    End If
'    Debug.Print "---------------------------------"
'
'    Debug.Print "Testing String array a()"
'    vt = Filter(a, SearchString, Include)
'    If Not IsEmpty(vt) Then
'        Debug.Print "Lbound(vt)="; LBound(vt)
'        Debug.Print "Ubound(vt)="; UBound(vt)
'        For i = LBound(vt) To UBound(vt)
'            If Not IsEmpty(vt(i)) Then
'                Debug.Print "Variant vt("; i; ")=["; vt(i); "]"
'            Else
'                Debug.Print "Variant vt("; i; ") is empty"
'            End If
'        Next
'    Else
'        Debug.Print "Returned Vt is empty"
'    End If
'    Debug.Print "---------------------------------"
'
'    Next l  ' memtest loop
'    End
'
'    Dim r() As String
'    If Not IsEmpty(vt) Then
'        VariantToArray vt, r     ' Wrapper function
'        ' Bug returns array not IsEmpty when vt is null
'        If Not IsEmpty(r) Then
'            Debug.Print "Lbound(r)="; LBound(r)
'            Debug.Print "Ubound(r)="; UBound(r)
'            For i = LBound(r) To UBound(r)
'            If Not IsEmpty(r(i)) Then
'                    Debug.Print "Converted variant r("; i; ")=["; r(i); "]"
'                Else
'                    Debug.Print "Converted variant r("; i; ") is empty"
'                End If
'            Next
'        Else
'            Debug.Print "Converted R() is empty"
'        End If
'    Else
'        Debug.Print "Variant VT is empty and can't be converted"
'    End If
'    Debug.Print "---------------------------------"
'
'    End
'End Sub

'Public Function test() As Boolean      ' Join()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'' Based on: http://www.xbeat.net/vbspeed/IsGoodJoin.htm
'' verify correct Join returns, 20020929
'' returns True if all tests are passed
'
'  ' replace "join" with the name of your function to test
'  CloseConsole
'
'    Dim r As String
'    Dim fFailed As Boolean
'    Dim sArr(4) As String
'
'    sArr(0) = ""
'    sArr(1) = "a"
'    sArr(2) = ""
'    sArr(3) = "bc"
'    'sArr(4) = ""       ' Implied/not assigned
'
'    ' -> ""","a","","bc""
'
'    'With New CJoin
'    'With New CJoin2
'    'With New CReplicationPaul
'' Failing on "" infix
'
'    Debug.Print Now; "----------------------------------------"
'
'    ' 1-char delim
'    r = Join(sArr(), ",")
'    If r <> ",a,,bc," Then
'        Debug.Print "Failed with ["; r; "]"
'        fFailed = True
'    Else
'        Debug.Print "Pass: ["; r; "]"
'    End If
'
''    sArr(0) = ""
''    sArr(1) = "a"
''    sArr(2) = ""
''    sArr(3) = "bc"
'    sArr(4) = "d"
'
'    ' 0-char delim
'    r = Join(sArr(), "")
'    If r <> "abcd" Then
'        Debug.Print "Failed with: ["; r; "]"
'        fFailed = True
'    Else
'        Debug.Print "Pass: ["; r; "]"
'    End If
'
'    ' 2-char delim
'    r = Join(sArr(), "12")
'    If r <> "12a1212bc12d" Then
'        Debug.Print "Failed with: ["; r; "]"
'        fFailed = True
'    Else
'        Debug.Print "Pass: ["; r; "]"
'    End If
'
'    ' missing delim
'    r = Join(sArr())
'    If r <> " a  bc d" Then
'        Debug.Print "Failed with: ["; r; "] ?"
'        fFailed = True
'    Else
'        Debug.Print "Pass: ["; r; "]"
'    End If
'
'    ' alignment
'    sArr(0) = "123456789"
'    sArr(1) = "12345678"
'    sArr(2) = "1234567"
'    sArr(3) = "123456"
'    sArr(4) = "12345"
'
'    r = Join(sArr(), ",")
'    If r <> "123456789,12345678,1234567,123456,12345" Then
'        Debug.Print "Failed with: ["; r; "]"
'        fFailed = True
'    Else
'        Debug.Print "Pass: ["; r; "]"
'    End If
'
'    ' handling unbound array
'    ' VB6 Join returns "", but raising error 9 is ok
'    On Error Resume Next
'    Dim sArrUnbound() As String
'    r = Join(sArrUnbound(), ",")
'    If r <> "" Then
'        If Err.Number <> 9 Then
'            Debug.Print "Failed with: ["; r; "]"
'            fFailed = True
'        End If
'    Else
'        Debug.Print "Unbound array Pass: ["; r; "]"
'    End If
'
'  On Error GoTo 0
'
'    ' handling multi-dimensional array
'    ' VB6 Join raises error 5, but raising error 9 is ok, too
'    On Error Resume Next
'    Dim sArr2(0, 0) As String
'    r = Join(sArr2(), ",")
'    If r <> "" Then
'        If Err.Number <> 5 And Err.Number <> 9 Then
'            Debug.Print "Failed with: ["; r; "]"
'            fFailed = True
'        End If
'    Else
'        Debug.Print "Multi dimensional Pass: ["; r; "]"
'    End If
'
'  On Error GoTo 0
'  Debug.Print Now; "----------------------------------------"
'
'    ' Timing tests ///////////////////////////////////////////////
'
'    Dim i As Integer
'    Dim a1() As String
'    ReDim a1(1000) As String
'    Dim Start As Single
'    Dim Finish As Single
'    For i = LBound(a1) To UBound(a1)
'      a1(i) = RandomStr(10, 0)            ' Fill with 10 random data chars
'    Next
'    Start = Timer
'    r = Join(a1, "")        ' Test 1 =  0.046875 s (46ms) static array - 0.0625 s dynamic
'    Finish = Timer
'    Debug.Print "1 Took: "; Finish - Start; "s (start="; Start; ")(end="; Finish; ")"
'    'Debug.Print "["; r; "]"
'    Debug.Print "Len="; Len(r)
'    Debug.Print Now; "----------------------------------------"
'    'End
'
'    r = ""  ' Clear
'    Start = Timer
'    r = Join(a1, ",")       ' Test 2 = 0.078125 s (78ms) static array - 0.0625 s dynamic
'    Finish = Timer
'    Debug.Print "2 Took: "; Finish - Start; "s (start="; Start; ")(end="; Finish; ")"
'    'Debug.Print "["; r; "]"
'    Debug.Print "Len="; Len(r)
'    Debug.Print Now; "----------------------------------------"
'
'    ReDim a1(1000) As String
'    For i = LBound(a1) To UBound(a1)
'      a1(i) = RandomStr(10, 0)            ' Fill with 10 random data chars
'    Next
'
'
'    ' These 2 tests return 0s so a1 is multiplied by x10 to get more accurate timings
'    ' Test 3 = 0.03125/10 -> 0.003125 s -> 312.4 microsecondss est. for original test
'    '   /1000 for ms ->0.31 ms
'    ' Test 4 = 0.359375/10 -> 0.0359375 s -> 35937.5 microseconds  est. for original test
'    '   /1000 for ms ->35.9 ms
'
'    r = ""  ' Clear
'    Start = Timer
'    r = Join(a1, ",")       ' Test 3 = 0s
'    Finish = Timer
'    Debug.Print "3 Took: "; Finish - Start; "s (start="; Start; ")(end="; Finish; ")"
'    Debug.Print "test was x10 so actual time is:"; (Finish - Start) / 10; "s"
''    Debug.Print "["; r; "]"     ' Yep, it's really there!
'    Debug.Print "Len="; Len(r)
'    Debug.Print Now; "----------------------------------------"
'
'    ReDim a1(1000) As String
'    For i = LBound(a1) To UBound(a1)
'      a1(i) = RandomStr(100, 0)            ' Fill with 100 random data chars
'    Next
'    r = ""  ' Clear
'    Start = Timer
'    r = Join(a1, ",")       ' Test 4 = 0s
'    Finish = Timer
'    Debug.Print "4 Took: "; Finish - Start; "s (start="; Start; ")(end="; Finish; ")"
'    Debug.Print "test was x10 so actual time is:"; (Finish - Start) / 10; "s"
''    Debug.Print "["; r; "]"     ' Yep, it's really there!
'    Debug.Print "Len="; Len(r)
'    Debug.Print Now; "----------------------------------------"
'
'    End
'
'
'  test = Not fFailed
'
'End Function

'Public Function test() As Boolean      ' Filter()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    ' Verify correct Filter returns
'    ' returns True if all tests are passed
'    ' Modified from:
'    ' http://www.xbeat.net/vbspeed/IsGoodFilter.htm
'    Dim sSrcArr(1) As String
'    Dim sTrgArr() As String
'    Dim ret As Long
'    Dim vt As Variant
'    Dim i As Integer
'
'    ' init source
'    sSrcArr(0) = "a"
'    sSrcArr(1) = "ab"
'
'    'ret = Filter(sSrcArr, "a", sTrgArr)
'    vt = Filter(sSrcArr, "a")
'    For i = LBound(vt) To UBound(vt)
'        Debug.Print "Vt("; i; ")=["; vt(i); "]"
'    Next
'    VariantToArray Filter(sSrcArr, "a"), sTrgArr
'    If UBound(sTrgArr) <> 1 Then
'      Debug.Print "FAIL 1 ubound="; UBound(sTrgArr)
'    ElseIf sTrgArr(0) <> "a" And sTrgArr(1) <> "ab" Then
'      Debug.Print "FAIL 1"
'    Else
'      Debug.Print "Pass #1"
'    End If
'
'    'sTrgArr Filter(sSrcArr, "b")
'    VariantToArray Filter(sSrcArr, "b"), sTrgArr
'    If UBound(sTrgArr) <> 0 Then
'        Debug.Print "FAIL 2"
'    Else
'      Debug.Print "Pass #2"
'    End If
'
'    'ret = Filter(sSrcArr, "b", sTrgArr, False)
'    VariantToArray Filter(sSrcArr, "b", False), sTrgArr
'    If UBound(sTrgArr) <> 0 Then
'        Debug.Print "FAIL 3"
'    ElseIf sTrgArr(0) <> "a" Then
'        Debug.Print "FAIL 3"
'    Else
'      Debug.Print "Pass #3"
'    End If
'
'  'ret = Filter(sSrcArr, "", sTrgArr)
'  ' "" returns the entire array - bizarre but that's how its implemented I guess
'    VariantToArray Filter(sSrcArr, ""), sTrgArr
'    vt = Filter(sSrcArr, "")      ' Returns empty array
'    If Not IsEmpty(vt) Then
'    For i = LBound(vt) To UBound(vt)
'        Debug.Print "Test #4 Vt("; i; ")=["; vt(i); "]"
'        Next
'    Else
'        Debug.Print "Returned variant is empty"
'    End If
'    If UBound(sTrgArr) <> 1 Then
'        Debug.Print "FAIL 4"
'    ElseIf sTrgArr(0) <> "a" And sTrgArr(1) <> "b" Then
'        Debug.Print "FAIL 4"
'    Else
'        Debug.Print "Pass #4"
'    End If
'
'    'ret = Filter(sSrcArr, "", sTrgArr, False)
'
'    vt = Filter(sSrcArr, "", False)
'    If Not IsEmpty(vt) Then
'        For i = LBound(vt) To UBound(vt)
'            Debug.Print "Test #5 Vt("; i; ")=["; vt(i); "]"
'        Next
'    Else
'        Debug.Print "Test #5 result is EMPTY"
'    End If
'    Erase sTrgArr
'    VariantToArray Filter(sSrcArr, "", False), sTrgArr
'    'If UBound(sTrgArr) <> -1 Then
'    If IsSet(sTrgArr) Then
'        Debug.Print "FAIL 5"
'    Else
'        Debug.Print "Pass #5"
'    End If
'
'    ' init source
'    sSrcArr(0) = "": sSrcArr(1) = ""
'
'    'ret = Filter(sSrcArr, "b", sTrgArr)
'    VariantToArray Filter(sSrcArr, "b"), sTrgArrt
'    'If UBound(sTrgArr) <> -1 Then
'    If IsSet(sTrgArr) Then
'        Debug.Print "FAIL 6"
'    Else
'      Debug.Print "Pass #6"
'    End If
'
'    'ret = Filter(sSrcArr, "", sTrgArr)
'    VariantToArray Filter(sSrcArr, ""), sTrgArr
'    If IsSet(sTrgArr) Then
'    'If UBound(sTrgArr) <> 1 Then
'        Debug.Print "FAIL 7"
'    Else
'        Debug.Print "Pass #7"
'    End If
'
'    Debug.Print " ------------------------------------------------"
'
'  test = True
'
'End Function
' /////////////////////////////////////////

''Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

''    ' Post TLB EncryptString
''    Dim s As String
''    s = "Hello world from VBToolbox Demo"
''    Debug.Print EncryptString(s, Len(s), "secret", "Saltystuff")
''    Debug.Print "Test #1 S is ["; s; "]"
''    Debug.Print EncryptString(s, Len(s), "secret", "Saltystuff")
''    Debug.Print "Test #2 is ["; s; "]"
''
''    Debug.Print EncryptString(s, Len(s), "secret")
''    Debug.Print "Test #3 is ["; s; "]"
''    Debug.Print EncryptString(s, Len(s), "secret")
''    Debug.Print "Test #4 is ["; s; "]"
''    End
''
''End Sub
'
''Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

''    ' Post TLB test of EncodeString64
''    Dim s As String
''    Dim a As String
''    Dim q As String
''    Dim l As Long
''    CloseConsole
''    s = "Hello world from VBToolbox"
''    Debug.Print "Test() Encoding --------------------------------"
''    Debug.Print "Len="; Len(s)
''    a = EncodeString64(s, 0)
''    Debug.Print "S is ["; s; "]"
''    Debug.Print "A is ["; a; "]"
''    q = a   ' Copy the ANSI/BSTR return
''    Debug.Print "Return value Q=A is ["; a; "]"
''    Debug.Print "Test() Decoding --------------------------------"
''    s = ""      ' Clear
''    s = DecodeString64(a, l)
''    Debug.Print "S is ["; s; "]"
''    Debug.Print "New length="; l
''    End
''End Sub
'Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    CloseConsole
'    Dim s As String
'    Dim i As Integer
'
'    Debug.Print "1 Base64Filter=(ABcdeF)["; Base64Filter(vbNullString); "]"   ' ID
'
'    s = ""
'    Debug.Print "1 Base64Filter=(ABcdeF)["; Base64Filter(s); "]"   ' ID
'
'    s = "ABcdeF"
'    Debug.Print "1 Base64Filter=(ABcdeF)["; Base64Filter(s); "]"   ' ID
''    Base64Filter s     ' ID
''    Debug.Print "Base64Filter ["; s; "]"
''
'    s = "_$%^&*!$%^&*()"
'    Debug.Print "2 Base64Filter(_$%^&*!$%^&*())=["; Base64Filter(s); "]" ' "-"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "a"
'    Debug.Print "3 Base64Filter(a)=["; Base64Filter(s); "]"         ' NULL
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "a*#"
'    Debug.Print "4 Base64Filter(a*#)=["; Base64Filter(s); "]"         ' NULL
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = ""
'    Debug.Print "5 Base64Filter(NULL)=["; Base64Filter(s); "]"         ' NULL
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "$"
'    Debug.Print "6 Base64Filter($)=["; Base64Filter(s); "]"         ' NULL
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "*a*$"
'    Debug.Print "7 Base64Filter(*a*$)=["; Base64Filter(s); "]"         ' NULL
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "AB[]{}=c_-d$%^&*F"
'    Debug.Print "8 Base64Filter(AB[]{}=c_-d$%^&*F)=["; Base64Filter(s); "]"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "%[]{}=_$%^&*A"
'    Debug.Print "9 Base64Filter(%[]{}=_$%^&*A)=["; Base64Filter(s); "]"
'    s = "%[]{}=_$%^&*A"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "_-$%^&*A"
'    Debug.Print "10 Base64Filter(_-$%^&*A) ["; Base64Filter(s); "]" ' "-"
'    s = "_-$%^&*A"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "A-$%B^&*C"
'    Debug.Print "11 Base64Filter(A-$%B^&*C) ["; Base64Filter(s); "]" ' "-"
'    s = "A-$%B^&*C"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "A[]{}=_$%^&*"
'    Debug.Print "12 Base64Filter(A[]{}=_$%^&*)=["; Base64Filter(s); "]"
'    s = "A[]{}=_$%^&*"
''    Base64Filter s
''    Debug.Print "Base64Filter ["; s; "]"
'
'    s = "%^&*(abc%^&*d"
'    Debug.Print "12 Base64Filter(%^&*(abc%^&*d)=["; Base64Filter(s); "]"
'
'''base64 characters [A-Z][a-z][0-9][+/=].
''
'    End
'    Dim l As Long
'    For l = 1 To 1000000
'        s = "A[]{}=_$%^&*"
'        s = Base64Filter(s) ' OK
'        If l Mod 10000 = 0 Then Debug.Print l; ":"; s
'        ' VB5 "no parenthesis" bug
'        ' Base64Filter s  ' Crash
'        ' Call Base64Filter(s)  'Crash
'        'Debug.Print s
'    Next
'    Debug.Print "Done"
'
'    End
'
'End Sub

'Public Sub test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'   Examples of VB not modifying function returns and use of parentheses
'    Dim a As String
'    Dim b As String
'
'    a = "  Hello "
'    b = Trim(a)
'    Debug.Print "a=["; a; "]"
'    Debug.Print "b=["; b; "]"
'    '    a = [  Hello ] ' Function parameter unchanged
'    '    b = [Hello]    ' Function return changed
'
'    a = "  Hello "
'    Trim a
'    Debug.Print "a=["; a; "]"
'    '   a=[  Hello ]    ' Function parameter unchanged

'End Sub

'Public Sub Test()
'    If LibUnicode() Then
'        Debug.Print "Unicode DLL - can't continue"
'        End
'    End If

'    ' Misc functions which may need to modify their function parameters (or not)
'    Dim a As String
'    Dim b As String
'    Dim l As Long
'    Dim i As Integer
'
'    CloseConsole
'
'''* PASS * (no leaks)
''    For l = 1 To 10000000
''        a = "Hello world"
''        b = StrRev(a)
''        If l Mod 100000 = 0 Then
''            Debug.Print l
''            Debug.Print "a=["; a; "]"
''            Debug.Print "b=["; b; "]"
''        End If
''        a = "Hello world"
'''        StrRev a                        ' GPFs at more than 1 call
'''        Debug.Print "a FB=["; a; "]"
'''        a = [Hello world]
'''        b = [dlrow olleH]
'''        a FB = [Hello world]
''    Next
'
''    a = "Hello world"
''    b = ReplaceChar(a, "l", "w")
''    Debug.Print "a=["; a; "]"
''    Debug.Print "b=["; b; "]"
''    a = "Hello world"
''    ReplaceChar a, "l", "w"
''    Debug.Print "a FB=["; a; "]"
'
'' '* PASS *
''    a = "   Hello World"
''    b = StripL(a, " ")
''    Debug.Print "StripL a=["; a; "] (should not change)"
''    Debug.Print "StripL b=["; b; "]"
''    a = "   Hello World"
'''    StripL a, " "
'''    Debug.Print "a=["; a; "]"
''
''    a = "Hello World    "
''    b = StripR(a, " ")
''    Debug.Print "StripR a=["; a; "] (should not change)"
''    Debug.Print "StripR b=["; b; "]"
''    a = "Hello World    "
'''    StripR a, " "
'''    Debug.Print "a=["; a; "]"
''
''      a = "   Hello World"
''    b = StripLStr(a, " lHe")
''    Debug.Print "StripLStr a=["; a; "] (should not change)"
''    Debug.Print "StripLStr b=["; b; "]"
''    a = "   Hello World"
'''    StripLstr a, " lhe"
'''    Debug.Print "a=["; a; "]"
''
''    a = "Hello World    "
''    b = StripRStr(a, " dlr")
''    Debug.Print "StripRStr a=["; a; "] (should not change)"
''    Debug.Print "StripRStr b=["; b; "]"
''    a = "Hello World    "
'''    StripRstr a, " dlr"
'''    Debug.Print "a=["; a; "]"
'
'''* PASS * - no leaks *
''    For l = 1 To 10000000   ' 10 million
''        a = "Hello there - the quick brown fox"
''        b = ReplaceChar(a, "l", "w")
''        If l Mod 100000 = 0 Then
''            Debug.Print l
''            Debug.Print "a=["; a; "]"
''            Debug.Print "b=["; b; "]"
''        End If
''    Next
''   End
'' ///////////////////////////////////////
'
''''* PASS * - no leaks *
''    Debug.Print "1"; InStrRev(vbNullString, vbNullString)   ' -> 0
''    Debug.Print "2"; InStrRev(vbNullString, "x")            ' -> 0
''    Debug.Print "3"; InStrRev("x", vbNullString)            ' -> 0
''    Debug.Print "4"; InStrRev("", "x")                      ' -> 0
''    Debug.Print "5"; InStrRev("x", "")  '=>  start if start <= Len(pszString), else 0
''    Debug.Print "6"; InStrRev("hello world", "", 3) ' -> start
''    Debug.Print "7"; InStrRev("hello world", "", 99) ' -> 0
''    Debug.Print "8"; InStrRev("hello world", "x")   ' -> not found 0
''    Debug.Print "9"; InStrRev("hello world", "world", 2) ' -> Start < Len(pszSearch)=>  0
''    Debug.Print "a"; InStrRev("hello world", "wo", 10)    ' -> 7
''    Debug.Print "b"; InStrRev("hello world", "Wo", 10)    ' -> 0 ' default binary cmp fail
''    Debug.Print "c"; InStrRev("hello world", "wo")         '-> 7
''    Debug.Print "d"; InStrRev("hello world", "WO", , vbBinaryCompare)  ' -> 0
''    Debug.Print "e"; InStrRev("hello world", "WO", , vbTextCompare)       '-> 7
''
''    For l = 1 To 10000000   ' 10 million
''        a = "Hello there - the quick brown fox"
''        i = InStrRev(a, "Bro", , vbBinaryCompare)    ' -> 0
''        i = InStrRev(a, "Bro", , vbTextCompare)      ' -> 7
''        If l Mod 100000 = 0 Then
''            Debug.Print l
''            Debug.Print "i=["; i; "]"
''        End If
''    Next
''    End
'' ///////////////////////////////////////
'
'    Dim j As Integer
'    a = ""
'    For i = 1 To 12
'        a = a & Format$(i)
'        Debug.Print CommaStr(a)
'    Next
'    Debug.Print "Done 1  ////////////////////////////////"
'    a = ""
'    For i = 0 To 9
'        If i > 0 Then
'            a = a & Format$(i)
'        End If
'        For j = 0 To 12
'            'b = b & Format$(j)
'            b = "123456789012345"
'            Debug.Print "       Str: len="; Len(a & "." & b) & " ( "; a; "."; b; "),"; j
'            Debug.Print CommaStr(a & "." & b, j)
'        Next
'    Next
'    ' Crash test
'    Debug.Print "CrashTest #1 ["; CommaStr(String$(4000, "9")); "]"
'    Debug.Print "* PASS *" ' * PASS *
'    Debug.Print "CrashTest #2 ["; CommaStr(String$(4000, "9") & "." & String$(4000, "9")); "]"
'    Debug.Print "* PASS *" ' * PASS *
'    ' Multiple dots spaced
'    Debug.Print "CrashTest #3 ["; CommaStr(String$(4000, "9") & "." & String$(100, "9") & "." & String$(100, "9") & "." & String$(100, "9")); "]"
'    Debug.Print "* PASS *" ' * PASS *
'    ' Multiple dot separators
'    Debug.Print "CrashTest #4 ["; CommaStr(String$(1000, "9") & String$(100, ".") & "." & String$(100, "9") & String$(100, "9")); "]"
'    Debug.Print "* PASS *" ' * PASS *
'    End
'End Sub

'Public Sub test() ' /////////////////////////////////
'    Dim s As String
'    Dim b As String
'    Dim l As Long
'    Dim i As Long
'
'' * PASS * no memory leak ANSI
''    Debug.Print StringToBMP(s, Len(s), b, l)
''    Debug.Print "b=["; b; "] (len="; l; ")"
''    s = "Hello world"
''    Debug.Print StringToBMP(s, Len(s), b, l)
''    Debug.Print "b=["; b; "] (len="; l; ")"
''
''    Debug.Print "Start: "; Now; " ///////////////////////////////"
''    For i = 1 To 10000   ' 1 million
''        Call StringToBMP(s, Len(s), b, l)
''        If i Mod 100000 = 0 Then
''            Debug.Print i; " b=["; b; "] (len="; l; ")"
''        End If
''    Next
''    Debug.Print "End  : "; Now; " ///////////////////////////////"
''
''    s = ""
''    Debug.Print "BMPToString ["; BMPToString(b, s, l); "]"
''    Debug.Print "s=["; s; "] len(s)="; Len(s); "len="; l
''
''    s = ""
''    l = 0
''    Debug.Print "BMPToString ["; BMPToString(b, s); "]"
''    Debug.Print "s=["; s; "] len(s)="; Len(s); "len="; l
'
''    b = ""
''    s = "The quick brown foxxxxx jumped over the lazy dog"
''
''    s = "h"
''    Debug.Print RLECompress(s, b)
''    Debug.Print "Compressed b1=["; b; "] len(b)="; Len(b); "len="; l
''    End
'
'
''    l = 0
''    s = ""
''    b = ""
''    Debug.Print "Input string ["; s; "] len="; Len(s); " /////////////////"
''    Debug.Print "Compressed?"; RLECompress(s, b, l)
''    Debug.Print "Compressed b2=["; b; "] len(b)="; Len(b); "len="; l
''    Debug.Print "HEX(b)=["; StrToHex(b, Len(b)); "]" & vbCrLf
''
''    s = ""
''    Debug.Print "*Compressed b=["; b; "] len(b)="; Len(b); "len="; l
''    Debug.Print "RLEUncompress?"; RLEUncompress(b, s)
''    Debug.Print "Unmpressed b=["; s; "] len(b)="; Len(b); "len="; l
''    Debug.Print "RLECompressedByteCount="; RLECompressedByteCount(b, Len(b))  ' wrong
''    Debug.Print "RLEUncompressedByteCount="; RLEUncompressedByteCount(b); ""
''    Debug.Print "Uncompress s=["; s; "] len(s)="; Len(s); "len="; l
''    Debug.Print "///////////////////////////////"
''
''    Debug.Print "Start: "; Now; " ///////////////////////////////"
''    For i = 1 To 100000   ' 1 million
''        s = "Hello world"
''        Call RLECompress(s, b)
''        If i Mod 10000 = 0 Then
''            Debug.Print i; " b=["; b; "] (len="; l; ")"
''        End If
''        Call RLEUncompress(b, s)
''        If i Mod 10000 = 0 Then
''            Debug.Print i; " s=["; s; "] (len="; l; ")"
''        End If
''    Next
''    Debug.Print "End  : "; Now; " ///////////////////////////////"
'
'
''    Problem - do we rlecompress single or zero byte strings to enable chaining
''    rleuncompress(rlecompress("x")) ??
'
'
''TestConsole:
''
'''    Debug.Print "openconsole="; OpenConsole()
'''    Debug.Print "ConsoleOpen="; ConsoleOpen()
'''    WriteLn ("Hello from VBToolbox")
''
''    CloseConsole
''    Debug.Print "LibUnicode?"; LibUnicode
''    Debug.Print "openconsole="; OpenConsole()
''    Debug.Print "ConsoleOpen="; ConsoleOpen()
''    WriteLn ("Hello from VB")
''    For i = 0 To 15
''        GotoXY 20, i + 1
''        If i = 0 Then
''            SetConsoleAttributes i, 1
''        Else
''            SetConsoleAttributes i, 0
''        End If
''        WriteLn "*Foreground Colour " & Format$(i)
''    Next
''    For i = 0 To 15
''        GotoXY 50, i + 1
''        SetConsoleAttributes 15 - i, i * 16
''        WriteLn "*Background Colour " & Hex$(i * 16)
''    Next
''
''    End
'
'
'    End ' ////////////////
'End Sub

'Public Sub test()
'    Dim vt As Variant
'    Dim i As Integer
'    Debug.Print Join(StrSplit("$1$2$3a$$$5$$", "$"), ",", True)
'    Debug.Print Join(Tokenise("$1$2$3a$$$5$$", "$a2"), ",", True)
'    'Erase vt
'    Debug.Print "["; Join(vt, ","); "]"
'
'    vt = StrSplit("$1$2$3a$$$5$$", "$")
'    For i = LBound(vt) To UBound(vt)
'        Debug.Print "v("; i; ")=["; vt(i); "]"
'    Next
'    Debug.Print "Join=["; Join(vt, ",", True); "]"
'
'End Sub

'Public Sub test()
'    ' StrTok and Tokenise ///////////////////////////////
'    Dim s As String
'    Dim i As Integer
'    Cls
'    ' Test for GPF and correct NULL returns
'    ' Test strtoki() or stritok()
'    ' NULL,NULL -> pass
'    ' NULL,"" -> pass
'    ' "",NULL -> pass
'    ' "","" -> pass
'    ' string,"" -> pass -> pass strtoki=NULL (caller returns whole string)
'    '"",string -> pass NULL or ""
'    ' string,<non-found-token> -> pass strtoki=NULL (caller returns whole string)
'    ' string,<found-token-many> -> pass (>1 tokens) == correct count of tokens(N)
'    ' string,<found-token-one> -> pass (>1 tokens) == correct count of tokens(2)
'    ' string,<found-token-one-BOL> -> pass (>1 tokens) == correct count of tokens(2)-> "","<string>"
'    ' string,<found-token-one-EOL> -> pass (>1 tokens) == correct count of tokens(2)-> "<string>",""
'    s = "Hello there the quick brown fox jumps over the lazy dog"
'    Call TestFunc(s, " ")
'    Debug.Print "s["; s; "]"
'
'    's = "Hello there the quick brown fox jumps over the lazy dog"
'    s = "4,5,,6,78,"
'    Dim V As Variant
'    Debug.Print "Start: IsEmpty(V)="; IsEmpty(V)
'    Debug.Print "Start: IsArray(V)="; IsArray(V)
'    Dim j as integer
'    Debug.Print "Start: "; Now; " ///////////////////////////////"
'    For j = 1 To 100000                 ' 1 million loops tested OK 23/Aug/2010 (no memory leaks)
'        V = Tokenise(s, ",", , True)
'        If j Mod 10000 = 0 Then
'            Debug.Print "Loop: "; j
'            If IsArray(V) Then 'If IsEmpty(V) Then 'Can't use IsSet(V) (Note in documentation)
'                Debug.Print "IsEmpty(V)="; IsEmpty(V)
'                For i = LBound(V) To UBound(V)
'                    Debug.Print i; ":["; V(i); "]"
'                Next
'            Else
'                Debug.Print "V is empty"
'            End If
'        End If
'    Next
'    Debug.Print "Ubound="; UBound(V)
'    Debug.Print "Lbound= "; LBound(V)
'    Debug.Print "GetArrayCount="; GetArrayCount(V)
'    End
'End Sub

'Public Sub test()
'    Dim V As Variant
'    Dim s As String
'    Dim i As Long
'    Dim j As Long
'    Cls
'    Debug.Print "Start: "; Now; " ///////////////////////////////"
'    ' 1,000,000 loops in 10s precisely => < 0.000001 s per loop (.01 microsecs)
'    For j = 1 To 1000000                 ' 1 million loops tested OK 23/Aug/2010 (no memory leaks)
'        s = "Hello there the quick brown fox jumps over the lazy dog"
''       s = "4,5,,6,78,"
'        'v = StrSplit(s, ",", , True)
'        'v = StrSplit(s)     ' * PASS *
'        'v = StrSplit("")    ' * PASS *
'        'v = StrSplit(s, , 2)   ' * PASS *
'        'v = StrSplit(s, , , False)   ' * PASS *
'        'v = StrSplit(s, , , False)   ' * PASS *
'        'v = StrSplit(s, , 3, True)   ' * PASS *
'        'v = StrSplit(vbNullString)  ' * PASS *
'        'v = StrSplit(s, "o")  ' * PASS *
'        'v = StrSplit(s, "O")  ' (should => ()) * PASS *
'        'v = StrSplit(s, "O", , True) ' (should => (array)) * PASS *
'        V = StrSplit(s, " ")  ' (should => (array)) * PASS *
'        'If True Then
'        If j Mod 10000 = 0 Then
''            Debug.Print "Loop: "; j
''            If IsArray(v) Then 'If IsEmpty(V) Then 'Can't use IsSet(V) (Note in documentation)
''                Debug.Print "IsEmpty(V)="; IsEmpty(v)
''                For i = LBound(v) To UBound(v)
''                    Debug.Print i; ":["; v(i); "]"
''                Next
''            Else
''                Debug.Print "V is empty"
''            End If
'        End If
'    Next
'    If IsArray(V) Then
'        Debug.Print "Ubound="; UBound(V)
'        Debug.Print "Lbound= "; LBound(V)
'    End If
'    Debug.Print "GetArrayCount="; GetArrayCount(V)
'    Debug.Print "End  : "; Now; " ///////////////////////////////"
'
'    End
'End Sub


'Public Sub test()   ' PrintR() and QSortStr /////////////////////////////////////////
'    Dim V As Variant
'    Dim s As String
'    Dim str As String
'    Dim a(12) As String
'    Dim ia(2) As Integer
'    Dim i As Integer
'    Dim l As Long
'    Dim c As Currency
'    Dim d As Date
'    Dim b As Boolean
'    Dim by As Byte
'    Dim vs(10) As Variant
'    Dim auto() As String
'    Dim Max As Long
'    Dim j As Long
'    CloseConsole
'
'    s = "Hello there the quick brown fox jumps over the lazy dog"
''    Debug.Print "PrintR(Null)->"; PrintR(Null)
''    Debug.Print "PrintR(v(''))->"; PrintR(V)
''    V = StrSplit("a,b,c,d", ",")
''    Debug.Print "PrintR(v)->"; PrintR(V)
''    V = StrSplit(s)
''    Debug.Print "PrintR(v)->"; PrintR(V)
'
'    a(0) = "Zero"
'    a(1) = "One"
'    'a(2) = ""
'    a(3) = "Three"
'    a(4) = "Four is thought by the Chinese to be unlucky"
'    a(5) = "5"
'    'a(6) = "6"
'    a(9) = "Nineteen ninety-nine"
'    a(11) = "Elvener"
'
'    vs(0) = "zero 0 vs"
'    vs(1) = "1 vs"
'    vs(2) = "2 vs"
'    vs(3) = "Three 3"
'    vs(4) = "Four 4"
'    vs(5) = "five 5"
'    vs(6) = "Six 6"
'    vs(7) = "seven 7"
'    vs(8) = "Eight 8 vs"
'    vs(9) = "nine 9 vs"
'    'vs(10) = "Ten 10 **"
'
'    i = 123
'    l = 12345678
'    c = 123456789123.456
''    Debug.Print "PrintR(String())->"; PrintR(a)
''    Debug.Print "PrintR(String)->"; PrintR(s)
''    Debug.Print "PrintR(Integer)->"; PrintR(i)
''    Debug.Print "PrintR(Long)->"; PrintR(l)
''    Debug.Print "PrintR(Double)->"; PrintR(123.456)
''    Debug.Print "PrintR(Currency)->"; PrintR(c)
''    Debug.Print "PrintR(Now)->"; PrintR(Now)
''    d = Now
''    Debug.Print "PrintR(Date)->"; PrintR(d)
''    Debug.Print "PrintR('')->"; PrintR("")
''    Debug.Print "PrintR(vbNullString)->"; PrintR(vbNullString)
''    Erase V
''    Debug.Print "PrintR(V(NULL))->"; PrintR(V)
''    WriteLn "Unknown?"
''    Debug.Print "PrintR(Integer())->"; PrintR(ia)
'
''    Debug.Print "PrintR(Variant$())->"; PrintR(vs)
''    b = True
''    Debug.Print "PrintR(Bool=True)->"; PrintR(b)
''    Debug.Print "PrintR(True)->"; PrintR(True)
''    Debug.Print "PrintR(False)->"; PrintR(False)
''    by = 65
''    Debug.Print "PrintR(Byte)->"; PrintR(by)
'    a(0) = "zero"
'
'''' //////////////////////////
''    Cls
''    For i = LBound(a) To UBound(a)
''        Debug.Print "Note that VB will make an ANSI *copy* of this array when passing to a DLL"
''        Debug.Print "["; a(i); "] BSTR*:varptr(a("; i; "))="; Hex$(VarPtr(a(i))); " - BSTR:StrPtr(a("; i; ")) = "; Hex$(StrPtr(a(i))); ""
''    Next
''    WriteLn "String a()"        ' OK 30/Aug/2010
'''PrintR a ' LOCK ERROR !!!!!!!!
''    Debug.Print QSortStr(a, False, False)
''    PrintR a
''End
''' //////////////////////////
'    OpenConsole
'    Cls
'    Max = 10000000
'    For j = 1 To Max                        ' * BUG * QsortVar was corrupting var Max - now OK
''        For i = LBound(vs) To UBound(vs)
''            Debug.Print "["; vs(i); "]"; Chr$(9); '":varptr(vs("; i; "))="; Hex$(VarPtr(vs(i))); " - ";
''            Debug.Print "strptr(vs("; i; "))="; Hex$(StrPtr(vs(i)))
''        Next
'        'Debug.Print "varptr(vs)="; VarPtr(vs)
'        If j Mod Max / 10 = 0 Then
'            WriteLn "Unsorted Variant vs() normal order, ignore case =>"
'            'PrintR vs, 1
'        End If
'        vs(4) = 4.01 ' Set a deliberate double stooge to test consistency-traps (found a S.A. unlock failure)
'        'V = QSort(vs, False, True) ' TODO: Implement Variant()-Variant->Str
'        Call QSort(vs, False, True) ' TODO: Implement Variant()-Variant->Str
'        If j Mod Max / 10 = 0 Then
'            WriteLn Format$(j) & ":Sorted Variant vs()..."
'            FlushConsole
'            PrintR vs, True
'        End If
'    Next
'End
''    For i = LBound(vs) To UBound(vs)
''        Debug.Print "vs"; i; "=["; vs(i); "]"
''    Next
'
''    Call QSort(vs, True, True)    '
''    WriteLn "Reverse Sorted Variant vs  =>"
''    FlushConsole
''    PrintR vs, True
''
''    Call QSort(Null, True)   '
''    WriteLn "NULL test  => (crash?)"
''    FlushConsole
''
''    Call QSort("wrong", True)   ' Wrong data type test
''    WriteLn "Wrong data test  =>(crash?)"
''    FlushConsole
''
''    ReDim auto(2)
''    auto(0) = "zero auto"
''    auto(2) = "two auto"
''    Call QSort(auto, True)   ' Wrong data type test
''    WriteLn "Auto() string data test  =>"
''    FlushConsole
''    PrintR auto, True
''
''    Call QSort(auto, False)   ' Wrong data type test
''    WriteLn "Auto string data test  =>"
''    FlushConsole
''    PrintR auto, True
'
''    Dim newstr() As String
'    Dim vnt As Variant
''    VariantToArray vs, newstr
''    WriteLn "Converted newstr()"
''    Call QSort(newstr, 0)   ' Variant cast not implemented yet
''    PrintR newstr
'
''    ' Test returning a Variant /////////////////
''    vnt = QSort(StrSplit("1,2,3,4", ","))
''    WriteLn "Chained Variant =>"
''    PrintR vnt, True
''    If IsArray(vnt) And Not IsEmpty(vnt) Then
''        Debug.Print "IsArray(vnt)="; IsArray(vnt)
''        Debug.Print "Lbound(vnt)="; LBound(vnt)
''        Debug.Print "Ubound(vnt)="; UBound(vnt)
''        Debug.Print "GetArrayCount(vnt)="; GetArrayCount(vnt)
''        For i = LBound(vnt) To UBound(vnt)
''            Debug.Print i; "=["; vnt(i); "]"
''        Next
''    Else
''        Debug.Print "Invalid variant"
''    End If
''
''    vnt = QSort(StrSplit("1,2,3,4", ","), True)
''    WriteLn "Chained Variant =>"
''    PrintR vnt, True
''    If IsArray(vnt) And Not IsEmpty(vnt) Then
''        Debug.Print "IsArray(vnt)="; IsArray(vnt)
''        Debug.Print "Lbound(vnt)="; LBound(vnt)
''        Debug.Print "Ubound(vnt)="; UBound(vnt)
''        Debug.Print "GetArrayCount(vnt)="; GetArrayCount(vnt)
''        For i = LBound(vnt) To UBound(vnt)
''            Debug.Print i; "=["; vnt(i); "]"
''        Next
''    Else
''        Debug.Print "Invalid variant"
''    End If
''
'
''' * No leaks - 24/Aug/2010 *
''    Debug.Print GetProcessMemoryUsed(GetPID())
'
''    For j = 1 To 10000000                 ' 1 million loops tested OK 23/Aug/2010 (no memory leaks)
''        vnt = QSort(StrSplit("The quick brown fox jumps over the lazy dog"))
''        If j Mod 10000 = 0 Then
''            Debug.Print "Loop "; j; PrintR(vnt)
''            Debug.Print "MemUsed="; GetProcessMemoryUsed(GetPID()); " byte(s)"
''        End If
''    Next
'
'    End
'End Sub
 
'Public Sub test()      ' Case conversion
''' * No leaks - 24/Aug/2010 * /////////////////////////
'' Lib* managment functions
''    For j = 1 To 10000
''        Debug.Print LibName, LibDate, LibTime, LibVersion, LibUnicode
''    Next
'End Sub
 
'Public Sub test()      ' Case conversion
'''' * No leaks - 25/Aug/2010 * /////////////////////////
''    For j = 1 To 100000
''        s = "hello world"
''        StringToBMP s, Len(s), s, l
''        If j Mod 10000 = 0 Then
''            Debug.Print j, "StringToBMP=["; s; "]"
''        End If
''        BMPToString s, s, l
''        If j Mod 10000 = 0 Then
''            Debug.Print j, "BMPToString=["; s; "]"
''        End If
''    Next
'End Sub
 
 
'Public Sub test()      ' Case conversion
''    For c = 0 To 64
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
''    For c = 65 To 90
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c + 32 <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
''    For c = 91 To 127
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
''    For c = 128 To 159
''        If c <> AscW(LCase$(Chr$(c))) Then
''            'Debug.Print c; "DIFFERS -> "; AscW(LCase$(Chr$(c)))
''            Debug.Print "LUT["; Format$(c) & "]=" & AscW(LCase$(Chr$(c))) & ";"
''        Else
''            'Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        End If
''    Next
''    For c = 160 To 191
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
''    For c = 192 To 214
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c + 32 <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
'    ' skip 215
''    For c = 223 To 255
''        Debug.Print c; " "; AscW(LCase$(Chr$(c)))
''        If c <> AscW(LCase$(Chr$(c))) Then Debug.Print c; "DIFFERS"
''    Next
'
'''''' * No leaks - 25/Aug/2010 * /////////////////////////////////////////////////
''' UPPER/LOWER
''    'For c = 129 To 255: Debug.Print c; " "; AscW(LCase$(Chr$(c))): Next
''    s = ""
''    For c = 32 To 255: s = s & Chr$(c): Next    ' Build ASCI/ANSI string
''    ' < 32 isn't printable in VB
''    Debug.Print "Start ["; s; "]"
''    For j = 1 To 1000000
''        If j Mod 100000 = 0 Then
''            Lower s
''            Debug.Print j; "["; s; "]"
''            Upper s
''            Debug.Print j; "["; s; "]"
''            Call Lower(s)
''            Debug.Print j; "["; s; "]"
''            Call Upper(s)
''            Debug.Print j; "["; s; "]"
''            s = LowerStr(s)
''            Debug.Print j; "["; LowerStr(s); "]"
''            s = UpperStr(s)
''            Debug.Print j; "["; UpperStr(s); "]"
''        Else
''            Call Lower(s)
''            Call Upper(s)
''            Upper s
''            Lower s
''            str = LowerStr(s)   ' OK
''            str = UpperStr(s)    ' OK
'''            LowerStr s  ' Crash (using function as Sub())
'''            UpperStr s  ' Crash (using function as Sub())
'''            Call LowerStr(s)   ' Crash (using function as Sub())
'''            Call UpperStr(s)   ' Crash (using function as Sub())
''        End If
''    Next
''' ////////////////////////
'
'' /////////////////////////
''    For c = 0 To 122
''        If c <> AscW(UCase$(Chr$(c))) Then
''            Debug.Print "Differs ";
''            Debug.Print c, AscW(UCase$(Chr$(c)))
''        End If
''    Next
'    ' 123..127 identity
''    For c = 128 To 223
''        If c <> AscW(UCase$(Chr$(c))) Then
''            Debug.Print "Differs ";
''            Debug.Print c, AscW(UCase$(Chr$(c)))
''        End If
''    Next
''    '128..159 custom
''    For c = 128 To 159  '  Custom
''        If c <> AscW(UCase$(Chr$(c))) Then
''            Debug.Print "LUT["; Format$(c); "]="; AscW(UCase$(Chr$(c))) & "; // " & Format$(c) & ": LCase$=" & Format$(AscW(LCase$(Chr$(c)))) & "  UCase$=" & Format$(AscW(UCase$(Chr$(c))))
''        End If
''    Next
'    '160..223 ID
'
'    '224..254 -32
'
''    For c = 225 To 254  '  -32
''        If c <> AscW(UCase$(Chr$(c))) Then
''            'Debug.Print "Differs ";
''            'Debug.Print c, AscW(UCase$(Chr$(c)))
''            Debug.Print "LUT["; c; "]=", AscW(UCase$(Chr$(c))); ";"
''        End If
''    Next
'    ' 255-> 376
'
'    Debug.Print "End."
'    End
'End Sub
' ////////////////////////////////////////////////////////////////////////////////////



''' ///////////////////////////////////////
'Public Sub test()   ' QSortVal
'
'    Dim i As Integer
'    Dim rv As Variant
'    Dim Max As Long
'
''    Dim va(10) As Variant
''    Dim v As Variant        ' * DONE *
''    ReDim v(10)
'
''    Cls
''
''' /// Dynamic Variant() /////////////////////
'''    Debug.Print "Testing Dynamic Variant QsortLong ..."        ' DYNAMIC - DONE
'''    For i = LBound(v) To UBound(v)
'''        v(i) = CLng(Random(99, 20000))
'''        Debug.Print "v("; i; ")="; v(i)
'''    Next
'''    rv = qsortval(v) '  0x200c
'''    For i = LBound(v) To UBound(v)
'''        Debug.Print "Sorted v("; i; ")="; v(i)
'''    Next
'''    Debug.Print PrintR(rv, True)
''
''' /// Static Variant() //////////////////////
'''    Dim j As Long
'''    Dim newd() As Double
'''    Debug.Print "Testing Static Variant QsortLong ..."        ' * PASS *
'''    Debug.Print "Start ["; Now; "]"
'''    For j = 1 To 10000000
'''        For i = LBound(va) To UBound(va)
'''            If i > 0 And i <= UBound(va) Then
'''                ' Fill the variant with doubles
'''                va(i) = Round(CDbl(Random(99, 100003) / 33.41), 4) ' Double Variant
'''            Else
'''                'va(i) = 0   ' Create Integer inconsistency for Double
'''                va(i) = 0#      ' Valid
'''            End If
'''            '' Create "stooges" //////// (non sortable items)
'''            'va(4) = CLng(12345)
'''            'va(6) = "Hello world"
'''            '' /////////////////////////
'''            ' va(i) = CLng(Random(99, 20000))
'''            If j Mod 100000 = 0 Then
'''                Debug.Print "Unsorted va("; i; ")="; va(i)
'''            End If
'''        Next i
'''        Call QSortVal(va, True) '  0x200c  *NO LEAKS=false,false: *LEAKS=false,true
'''        If j Mod 100000 = 0 Then
'''            If IsArray(va) Then
'''                For i = LBound(va) To UBound(va)
'''                    Debug.Print "Sorted va("; i; ")="; va(i)
'''                Next i
'''                Cls
'''                Debug.Print PrintR(rv, True)
'''            End If
'''        End If
'''    Next j
'''    Debug.Print "J="; j
'''    WriteLn "Done"
'''    Debug.Print "End  : "; Now; " ///////////////////////////////"
''
'''    Dim l(5) As Long             ' * DONE * (Long Static)
'''    'Dim l() As Long             ' * DONE * (Long Dynamic)
'''    'ReDim l(5)
'''    Debug.Print "Testing QsortVal ..."
'''    Debug.Print "Is array? "; IsArray(l)
'''    For i = LBound(l) To UBound(l)
'''        If i < UBound(l) Then l(i) = CLng(Random(99, 20000))
'''        Debug.Print "l("; i; ")="; l(i)
'''    Next
'''    Debug.Print qsortval(l)    '  0x6003
''
'''    'Dim ia(5) As Integer           ' * DONE * (Integer Static)
'''    Dim ia() As Integer             ' * DONE * (Integer Dynamic)
'''    ReDim ia(5)
'''    Debug.Print "Testing QsortVal ..."
'''    Debug.Print "Is array? "; IsArray(ia)
'''    For i = LBound(ia) To UBound(ia)
'''        If i < UBound(ia) Then ia(i) = CInt(Random(99, 10000))
'''        Debug.Print "Integer array ia("; i; ")="; ia(i)
'''    Next
'''    Debug.Print PrintR(QSortVal(ia), True)   '
'''    For i = LBound(ia) To UBound(ia)
'''        Debug.Print "Sorted Integer array ia("; i; ")="; ia(i)
'''    Next
''
'''    'Dim da(5) As Double           ' * DONE * (Double Static)
'''    Dim da() As Double             ' * DONE * (Double Dynamic)
'''    ReDim da(5)
'''    Debug.Print "Testing QsortVal ..."
'''    Debug.Print "Is array? "; IsArray(da)
'''    For i = LBound(da) To UBound(da)
'''        If i < UBound(da) Then da(i) = Round(CDbl(Random(99, 100003) / 33), 2)
'''        Debug.Print "Double array da("; i; ")="; da(i)
'''    Next
'''    Debug.Print PrintR(QSortVal(da), True)   '
'''    For i = LBound(da) To UBound(da)
'''        Debug.Print "Sorted Double array da("; i; ")="; da(i)
'''    Next
'
'    'Dim da(5) As single           ' * DONE * (single Static)
'    Dim va(18) As Variant
'    Dim da() As Single             ' * DONE * (single Dynamic)
'    ReDim da(18)
'    Debug.Print "Testing QsortVal ..."
'    Debug.Print "Is array? "; IsArray(da)
'    For i = LBound(da) To UBound(da)
'        If i < UBound(da) Then da(i) = Round(CSng(Random(99, 100003) / 33.3), 2)
'        Debug.Print "single array da("; i; ")="; da(i)
'    Next
'    Debug.Print PrintR(QSortVal(da), True)   '
'    For i = LBound(da) To UBound(da)
'        Debug.Print "Sorted single array da("; i; ")="; da(i)
'    Next
'    Debug.Print PrintR(QSortVal(da, True), True) '
'    For i = LBound(da) To UBound(da)
'        Debug.Print "Sorted single array da("; i; ")="; da(i)
'    Next
'
'    '/// Single Static Variant() //////////////////////
'    Dim j As Long
'    Dim newd() As Single
'
'    Debug.Print "Testing Static Variant QsortLong (Single) ..."       '
'    Debug.Print "Start ["; Now; "]"
'    Max = 1000000
'    For j = 1 To Max
'        For i = LBound(va) To UBound(va)
'            If i > 0 And i <= UBound(va) Then ' Fill the variant with singles
'                va(i) = Round(CSng(Random(99, 100003) / 33.45), 4) ' single Variant
'            Else
'                va(i) = 0#       ' Valid
'            End If
'
'            If j Mod (Max / 10) = 0 Then
'                Debug.Print Format$(j) & " *******"
'                Debug.Print "Unsorted va("; i; ")="; va(i)
'            End If
'        Next i
'        rv = QSortVal(va, False) '  0x200c  *NO LEAKS=false,false: *LEAKS=false,true
'        If j Mod (Max / 10) = 0 Then
'            If IsArray(va) Then
'                Debug.Print Format$(j) & " *******"
'                For i = LBound(va) To UBound(va)
'                    Debug.Print "Sorted va("; i; ")="; va(i)
'                Next i
'                Cls
'                WriteLn Format$(j) & " *******"
'                FlushConsole
'                Debug.Print PrintR(rv, True)
'            End If
'        End If
'    Next j
'    Debug.Print "J="; j
'    WriteLn "Done"
'    Debug.Print "End  : "; Now; " ///////////////////////////////"
'
'
''
'''    If IsArray(l) Then
'''        Debug.Print IsArray(l)
'''        Debug.Print LBound(l)
'''        Debug.Print UBound(l)
'''        For i = LBound(l) To UBound(l)
'''            Debug.Print "sorted l("; i; ")="; l(i)
'''        Next
'''    Else
'''        Debug.Print "Array empty"
'''    End If
''
'''    rv = qsortval(va) ' 0x600c
'''    Debug.Print PrintR(rv)
''
'''   Empty variant safety tests
'''    Dim mv As Variant ' MT variant - NULL -> OK
'''    WriteLn "Dim x as Variant (empty) ..."
'''    Debug.Print PrintR(qsortval(mv), True)
'''    PrintR mv, True
'''
'''    Dim mav() As Variant ' MT Array variant -> OK
'''    WriteLn "Dim x() as Variant (empty) ..."
'''    Debug.Print PrintR(qsortval(mav), True)
'''    PrintR mav, True
''
''    '////////////////////////////////////
''
''    'On Error GoTo Error
''    Dim ia(5) As Variant                     ' Test random date values (PHPDate is Unix domain)
''    Dim j As Long
''    Dim Max As Long
''    Max = 10000000
''    WriteLn "Uninitialised..."
''    Debug.Print "(max="; Max; ")"
''    PrintR ia, True
''    Debug.Print TypeName(ia)
''    Debug.Print "NEW:Ubound ia="; UBound(ia); " Lbound ia="; LBound(ia)
''    For j = 1 To Max                        ' * BUG * QsortVar was corrupting var Max - now OK
''        For i = LBound(ia) + 1 To UBound(ia)
''            ia(i) = CDate(Random(0, 10000) / 3.1 + 25000) '+ 25569 min valid date
''            'ia(i) = CInt(ia(i))
''            If j = 1 Then
''                Debug.Print "ia("; i; ")="; ia(i); "vartype="; VarType(ia(i)); " typename="; TypeName(ia(i))
''            End If
''        Next
''        If j Mod (Max / 10) = 0 Then
''            WriteLn "Loop " & Format$(j)
''            WriteLn "Unsorted"
''            PrintR ia, True
''        End If
''
''        Call QSortVal(ia)
''If Not IsEmpty(rv) Then
''Debug.Print "Typename rv="; TypeName(rv); " Ubound rv("; UBound(rv); ")"
''End If
'''Debug.Print "3(max="; Max; ")"
''        If j Mod (Max / 10) = 0 Then
''            WriteLn "Sorted"
''            PrintR ia, True
''        End If
''        If j = 1 Then
''            Debug.Print "OUT:Ubound ia="; UBound(ia); " Lbound ia="; LBound(ia)
''            For i = LBound(ia) + 1 To UBound(ia)
''                Debug.Print "OUT: ia("; i; ")="; ia(i); "vartype="; VarType(ia(i)); " typename="; TypeName(ia(i))
''            Next
''        End If
''    Next
''
'''    Dim dt As Date                      ' Test date
'''    PrintR dt
'''    dt = Now
'''    PrintR dt
'''
'''    Dim mda(2, 3) As Variant
'''    WriteLn "Multi-dimensional array..."
'''    mda(0, 1) = "Hello"
'''    mda(1, 2) = "There"
'''    Debug.Print PrintR(mda)
''
''
'    Debug.Print "Done."
'    End
'    Exit Sub
'Error:
'
'    Debug.Print "Error "; Err.Number; " ("; Err.Description; ")"
'    End
'End Sub ' /////////////////////////////


'Public Sub test()
'    Dim a() As String
'    ReDim a(2)
'    a(1) = "Hello"
'    a(2) = 1.4
'    PrintR a
'    Dim Max As Long
'    Dim j As Long
'    Dim i As Long
'    Dim r As Long
'    Dim v As Variant
'
'    Max = 1000000
'    For j = 1 To Max                        ' * BUG * QsortVar was corrupting var Max - now OK
'''        For i = LBound(vs) To UBound(vs)
'''            Debug.Print "["; vs(i); "]"; Chr$(9); '":varptr(vs("; i; "))="; Hex$(VarPtr(vs(i))); " - ";
'''            Debug.Print "strptr(vs("; i; "))="; Hex$(StrPtr(vs(i)))
'''        Next
''        'Debug.Print "varptr(vs)="; VarPtr(vs)
'        If j Mod Max / 10 = 0 Then
'            WriteLn j
'            Debug.Print PrintR(Join(QSort(StrSplit("six, three, one, twelve,6,", ","))))
''            Debug.Print r
'            'Debug.Print PrintR(QSort(StrSplit("1,two,3,hello,5,yello,zero", ",")))
'        Else
'            'Call QSort(StrSplit("1,two,3,hello,5,yello,zero", ","))
'            v = Join(QSort(StrSplit("1,two,3,four,5,six,7,eight", ",")))
'        End If
'    Next
'' //////////////////////////////////////////////////////////////////////
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' Test AllocString: ///////////////
'    ' 1.203125..1.1390625  mU secs per call
'    ' * No leaks *
'    Dim s As String
'    Dim Max As Long
'    Dim j As Long
'    Max = 10000000
'    Dim t As Single
'    t = Timer
'    For j = 1 To Max
'        s = AllocString(100, Asc("*"))
'    Next
'    Debug.Print "Took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'    Debug.Print IsEmpty(s)
'    Debug.Print Len(s); "s=["; s; "]"
'    ' ////////////////////////////////
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' CSVSplit /////////////////////
'    Dim v(10) As Variant
'    v(0) = "  1 "
'    v(1) = "     "
'    v(2) = Chr$(34) & "a" & Chr$(34) & "b,c"
'    v(3) = "  " & Chr$(34) & Chr$(34) & "Hello" & Chr$(34) & Chr$(34)
'    v(5) = Chr$(9) & "5" & Chr$(9)
'    v(8) = Chr$(34) & " eight " & Chr$(34)
'    Dim s As String
'    Dim vmt As Variant
'    Debug.Print "VariantElementCount(v)="; VariantElementCount(v)
'    Debug.Print "VariantElementCount(vmt)="; VariantElementCount(vmt)
'    Cls
'
'    's = "One,two,three,four"
'    's = Join(v, Chr$(34) & "," & Chr$(34))
'    s = Join(v, ",")
''    s = ""
'    s = Chr$(34) & s & Chr$(34)
''    Debug.Print "["; StripLStr(Chr$(34) & Chr$(34), Chr$(34) & Chr$(9) & " "); "]"
''End
'    Dim j As Long
'    Dim Max As Long
'    Max = 100
'    Dim t As Single
'    ' * No leaks *
'    ' Each call took  0.0000083296875  secs - 8.3296875  Mu secs
'    t = Timer
'    WriteLn "Test CSVSplit [" & s & "]"
'    For j = 1 To Max
'        If j Mod Max / 10 = 0 Then
'            Debug.Print "csvsplit="; PrintR(CSVSplit(s))
'            'vmt = CSVSplit(s) ' pass back to a dummy var
'        Else
'            vmt = CSVSplit(s) ' pass back to a dummy var
'        End If
'    Next
'    Debug.Print "IsValidVariant(vmt)="; IsValidVariant(vmt)
'    Debug.Print "Took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'
''    s = "one,2," & Chr$(34) & "Three" & Chr$(34) & "," & Chr$(34) & "four" & Chr$(34) & "a,b,c"
''    Debug.Print "csvsplit="; PrintR(CSVSplit(s))
''    Debug.Print s
'
'    '/////////////////////////
'    Debug.Print "Done."
'    End
'End Sub


'Public Sub test()
''    ' Disk API functions //////////////////////////////////
''    Dim rootdir As String
''    'rootdir = "\\kerys\drive-d$"
''    CloseConsole
''    Dim i As Integer
''    For i = 0 To 25
''        rootdir = Chr$(9) & " " & Chr$(i + Asc("A")) & ":\foo.txt"
''        If IsReady(rootdir) Then
''            Debug.Print "Details for Drive ["; rootdir; "]",
''            Debug.Print "["; GetVolumeFileSystem(rootdir); "]",
''            Debug.Print "["; GetVolumeLabel(rootdir); "]",
''            Debug.Print GetVolumeNameLength(rootdir),
''            Debug.Print Format$(LongToHex(GetVolumeSerial(rootdir)))
''        Else
''            'Debug.Print "Drive "; rootdir; " is not ready; "
''        End If
''    Next
'
''    Dim v() As Variant
''    Dim i As Integer
''    For i = 1 To 10
''        ReDim v(ElementCount(v) + 1)
''        v(i) = i
''        Debug.Print "v("; i; ")="; v(i)
''    Next
'
'    ' /// WordCount /////////
'' Multiples:
''    Each call took  0.00002684375  secs
''    Each call took  26.84375  Mu secs
'' Single
''Each call took  0.0000015875  secs
''Each call took  1.5875  Mu secs
''Took  15.34277  secs
''Each call took  0.00000153427734375 secs
''Each call took  1.53427734375  Mu secs
'    Dim s As String
'    CloseConsole
'    Cls
'    Dim j As Long
'    Dim r As Long
'    Dim Max As Long
'    Dim t As Single
'    Max = 10000000
'    t = Timer
'    WriteLn "Test CSVSplit [" & s & "]"
'    For j = 1 To Max
'If False Then
'        'If j Mod Max / 10 = 0 Then
'            Debug.Print "j="; j
'            s = " "
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = "t"
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = "t "
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = " t"
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = "the"
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = "the-quick"
''            Debug.Print "Wordcount(1) ["; s; "]="; WordCount(s)
''            s = "the-quick  brown-fox      jumped over"
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
'            s = "the-quick  brown-fox  1 2 3    jumped over"
'            Debug.Print "Wordcount(7) ["; s; "]="; WordCount(s)
''            s = " the "
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''            s = String$(10, 9) & String$(10, 32) & "the" & String$(10, 9) & String$(10, 32)
''            Debug.Print "Wordcount ["; s; "]="; WordCount(s)
''
''            s = " the  quick brown fox jumped        over the lazy 123 dog"
''            Debug.Print "Wordcount QBF(10)="; WordCount(s)
''
''            s = " the,quick -brown fox;jumped:;',.+=-over...the lazy 123;dog"
''            Debug.Print "Wordcount QBFPunct(10)="; WordCount(s)
''            s = "! $%^&*(){}[]@~'#<>,.?/|\"
''            Debug.Print "Wordcount PUNCS(0)="; WordCount(s)
''            s = " - - - - - - "
''            Debug.Print "Wordcount HYPHS(0)="; WordCount(s)
''            s = " - - one-word - - - "
''            Debug.Print "Wordcount(1) ["; s; "]="; WordCount(s)
''            s = ""
''            Debug.Print "Wordcount NULL="; WordCount(s)
''            s = String$(100, 9)
''            Debug.Print "Wordcount 100xTAB="; WordCount(s)
''            s = String$(100, 32)
''            Debug.Print "Wordcount 100xSPACE="; WordCount(s)
'        Else
''            s = " "
''            r = WordCount(s)
''            s = "t"
''            r = WordCount(s)
''            s = "t "
''            r = WordCount(s)
''            s = " t"
''            r = WordCount(s)
''            s = "the"
''            r = WordCount(s)
''            s = "the-quick"
''            r = WordCount(s)
''            s = "the-quick  brown-fox      jumped over"
''            r = WordCount(s)
'            s = "the-quick  brown-fox  1 2 3    jumped over"
'            r = WordCount(s)
''            s = " the "
''            r = WordCount(s)
''            s = String$(10, 9) & String$(10, 32) & "the" & String$(10, 9) & String$(10, 32)
''            r = WordCount(s)
''            s = " the  quick brown fox jumped        over the lazy 123 dog"
''            r = WordCount(s)
''            s = " the,quick -brown fox;jumped:;',.+=-over...the lazy 123;dog"
''            r = WordCount(s)
''            s = "! $%^&*(){}[]@~'#<>,.?/|\"
''            r = WordCount(s)
''            s = " - - - - - - "
''            r = WordCount(s)
''            s = " - - one-word - - - "
''            r = WordCount(s)
''            s = ""
''            r = WordCount(s)
''            s = String$(100, 9)
''            r = WordCount(s)
''            s = String$(100, 32)
''            r = WordCount(s)
'        End If
'    Next
'    Debug.Print "Took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'
'    '//////////////////////////////
'    Debug.Print "Done."
'    End
'End Sub

Public Sub PrintArray(ByRef v As Variant)
    Dim i As Integer
    On Local Error Resume Next
    If IsArray(v) Then
        If Not IsEmpty(v) Then
            Debug.Print "Array has "; UBound(v) - LBound(v) + 1; " element(s)"
            For i = LBound(v) To UBound(v)
                Debug.Print "["; i; "]  => ["; v(i); "]"
            Next
        Else
            Debug.Print "Array is empty"
        End If
    Else
        Debug.Print "Object is is not an array"
    End If
End Sub

Public Function isUnicode(bchar As String) As Boolean
    isUnicode = False
    If Len(bchar) > 1 Then
        isUnicode = IsTextUnicode(ByVal bchar, 4, &HF)
    End If
End Function
    
'Public Sub test()
'    Cls
'    Dim s As String
'    s = ""
'    PrintArray WordList(s)
'    s = ")"
'    PrintArray WordList(s)
'    s = "{\rtf1\{}ansi\{}{{...ansicpg1252\\deff0\..."
'    PrintArray WordList(s)
'    s = "-$%^&*("
'    PrintArray WordList(s)
'    s = "-$%^&*(hello"
'    PrintArray WordList(s)
'    s = "    hello   "
'    PrintArray WordList(s)
'    s = "hello-world"
'    PrintArray WordList(s)
'    s = " - - - - Hello-world - - - "
'    PrintArray WordList(s)
'    s = "-ab$c%^d&*e("
'    PrintArray WordList(s)
'    s = "ab$c%^d&*e"
'    PrintArray WordList(s)
'    s = "a^&b$&**(c%&*^d&****e"
'    PrintArray WordList(s)
'    ' Check embedded hyphens
'    s = "hello-$%^&*("
'    PrintArray WordList(s)
'    s = "$%^&*-hello$%^&*("
'    PrintArray WordList(s)
'    s = "$%^&*-hello-$%^&*("
'    PrintArray WordList(s)
'    s = "$%^&*-hello-w$%^&*("
'    PrintArray WordList(s)
'    s = "   the -quick brown- fox jumps over the lazy-dog  "
'    Debug.Print PrintR(WordList(s))
'    s = "   the -quick brown- fox jumps over the lazy-dog  "
'    Debug.Print PrintR(QSort(WordList(s)))
'    s = "   the -quick brown- fox jumps over the lazy-dog  "
'    Debug.Print WordCount(s)
'
'    'printarray WordList(ReadFileToString(("c:\Document-Welcome.rtf")))
'
'    'Debug.Print WordCount(ReadFileToString(("c:\Document-Welcome.rtf")))
'    Debug.Print "Reading..."
'    'Debug.Print PrintR(QSort(WordList(ReadFileToString(("c:\todo_test.TXT")))))
'    Debug.Print "Read"
'    Debug.Print PrintR(QSort(WordList(ReadFileToString(("c:\Document-Welcome.rtf"))), , True))
'
'    'Debug.Print PrintR(WordList(ReadFileToString("c:\Document-Welcome.rtf")))
'    '//////////////////////////////
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' Suspected regression bug in tokenise (was due to faulty declare)
'    Dim s As String
'    Dim v As Variant
'    Dim i As Integer
'    s = "{\colortbl;\red255\green255\blue0"
'    v = Tokenise(s, ";")
'    If IsArray(v) Then
'        Debug.Print "IsArray"
'        For i = LBound(v) To UBound(v)
'            Debug.Print "v("; i; ")=["; v(i); "]"
'        Next
'    End If
'    'PrintR (v)
'
'End Sub

'Public Sub test()
'    ' // SwapStr rapid string swapping via pointers
'    Dim a As String
'    Dim b As String
'    a = "aaaaaa"
'    b = "bbbbbb"
'    Call SwapStr(a, b)
'
'    Debug.Print "a="; a
'    Debug.Print "b="; b
'    End
'End Sub

'Public Sub test()
'    ' MKDirs (create multiple path segments)
'    Dim s As String
'    Cls
'    s = "c:\temp\_one\two\three\four"   ' Should SUCCEED
'    Debug.Print s; "=>"; MKDirs(s)
'    s = "c:temp\_two\three\four\five"   ' Should FAIL
'    Debug.Print s; "=>"; MKDirs(s)
'    s = "\temp\_three\four\five\six"    ' Should SUCCEED
'    Debug.Print s; "=>"; MKDirs(s)
'    s = "temp\_four\five\six\seven"     ' Should FAIL
'    Debug.Print s; "=>"; MKDirs(s)
'    End
'End Sub

'Public Sub test()
'    ' String sorting example
'    Dim s As String
'    Dim r As String
'    s = ""
'    s = s & "--------" & vbCrLf
'    s = s & "15 minutes ago my cat came in yeowling for me to close the cat flaps" & vbCrLf
'    s = s & "- didn't know what he was on about - but I did it, as the black clouds were mounting fast." & vbCrLf
'    s = s & "5 minutes ago a fairly viscous squall hit us." & vbCrLf
'    s = s & "He had noticed something I hadn't." & vbCrLf
'    s = s & "Have you a pet story about their senses?" & vbCrLf
'    s = s & "" & vbCrLf
'    s = s & "Teh quick brown fox jumps over the lazy dog" & vbCrLf
'    s = s & "(a) Item one" & vbCrLf
'    s = s & "ZZZ last line" & vbCrLf
'
'    r = Join(QSort(StrSplit(s, vbCrLf)), vbCrLf)
'    Cls
'    PrintR (r)
'    Debug.Print "["; r; "]"
'
'
'    End
'End Sub

'Public Sub test()
'    ' Cursor control and FindHiddenTopWindow
'    Call OpenConsole
'    Cls
'    Dim i As Long
'    For i = 1 To 1
'    Debug.Print FindHiddenTopWindow()
'    Next
'    Call SetCursorVisible(True)
'    Debug.Print IsCursorVisible()
'
'    Cls
'    Call SetCursorVisible(False)
'    Debug.Print IsCursorVisible()
'
'    Cls
'    Call SetCursorVisible(True)
'    Debug.Print "IsCursorVisible()="; IsCursorVisible()
'    Debug.Print "IsTaskVisible()="; IsTaskVisible()
'    Call SetTaskVisible(True)
'    Debug.Print "IsTaskVisible()="; IsTaskVisible()
'    Call SetTaskVisible(False)
'    Debug.Print "GetConsoleTitle="; GetConsoleTitle
'    SetConsoleTitle "Hello console"
'    Debug.Print "GetConsoleTitle="; GetConsoleTitle
'    Debug.Print "IsConsoleVisible()="; IsConsoleVisible()
'    WriteLn "hiding..."
'    Debug.Print "hiding..."
'    WinSleep 5000
'    HideConsole
'    Debug.Print "IsConsoleVisible()="; IsConsoleVisible()
'    WriteLn "showing"
'    Debug.Print "showing"
'    WinSleep 2000
'    ShowConsole
'    Debug.Print "IsConsoleVisible()="; IsConsoleVisible()
'
'    'SetConsoleVisible False
'    Debug.Print "IsConsoleVisible()="; IsConsoleVisible()
'    'SetConsoleVisible True
'    Debug.Print "IsConsoleVisible()="; IsConsoleVisible()
'
'    ' //////////////////////////////////
'    End
'End Sub

'Public Sub test()
'    ' WordWrap
'    Dim i As Integer
'    Dim l As Long
'    Dim max As Long
'    Dim j As Long
'    Dim s As String
'    Cls
'    Debug.Print "["; WordWrap("the quick brown fox jumps over the lazy dog, now is the time for all good men to come to the aid of the party", 30, l); "]"
'    Debug.Print "Lines="; l
'    max = 10000000
'    Dim t As Single
'    t = Timer
'    For j = 1 To max                        ' * BUG * QsortVar was corrupting var Max - now OK
'        s = WordWrap("the quick brown fox jumps over the lazy dog, now is the time for all good men to come to the aid of the party. Blah black Black-Sheep have you any wool, yes sir, yes sir, three bags-full", 20, l)
'        If j Mod max / 10 = 0 Then
'            Debug.Print j
'        End If
'    Next
'    Debug.Print "Took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / max) * 1000000; " Mu secs"
'' 10,000,000 calls - * No leaks *
'' 109 chars @ 30
''Each call took  0.0000036625  secs
''Each call took  3.6625  Mu secs
'' Longer string 186 chars @ 20
''Each call took  0.000004946875  secs
''Each call took  4.946875  Mu secs
'
'    Debug.Print "["; s; "]"
'    Debug.Print "Done"
'    End
'
'End Sub

'Public Sub test()
'    ' Roman conversion
'    Dim i As Integer
'    Dim l As Long
'    Dim max As Long
'    Dim j As Long
'    Dim s As String
'    Cls
''    Debug.Print "Start:   "; Now
''    For i = 1 To 9999
''        'Debug.Print i; "="; DecimalToRoman(i)
''        If RomanToDecimal(DecimalToRoman(i)) <> i Then
''            Debug.Print "failed at "; i
''            Debug.Print "DecimalToRoman(i)="; DecimalToRoman(i)
''            Debug.Print "RomanToDecimal(DecimalToRoman(i))="; RomanToDecimal(DecimalToRoman(i))
''            End
''        End If
''        Debug.Print i, DecimalToRoman(i)
''    Next
''    Debug.Print "* PASS * "; Now
'
''    Open "c:\roman.txt" For Output As #1
''    For i = 1 To 1000
''        Print #1, i; Tab; DecimalToRoman(i)
''    Next
''    Close #1
'
'    'Debug.Print RomanToDecimal("MMMMMMMMMCMXCIX")
'
'    Debug.Print "Done"
'    End
'End Sub

'Public Sub test()
'    Dim i As Integer
'    Dim l As Long
'    Dim max As Long
'    Dim j As Long
'    Dim s As String
'    Dim t As Single
'    Cls
'    Debug.Print "["; ReverseWords(vbNullString); "]"
'    Debug.Print "["; ReverseWords(""); "]"
'    Debug.Print "["; ReverseWords("T"); "]"
'    Debug.Print "["; ReverseWords("Th"); "]"
'    Debug.Print "["; ReverseWords("The"); "]"
'    Debug.Print "["; ReverseWords("The "); "]"
'    Debug.Print "["; ReverseWords("The quick"); "]"
'    Debug.Print "["; ReverseWords("The quick "); "]"
'    Debug.Print "["; ReverseWords("The quick brown fox"); "]"
'    Debug.Print "["; ReverseWords("The quick brown fox jumped over the lazy dog"); "]"
'    max = 10000000
'    t = Timer
'    Debug.Print "Start./////////////////////////"
'    For j = 1 To max                        ' * BUG * QsortVar was corrupting var Max - now OK
'        s = ReverseWords("The quick brown fox jumped over the lazy dog")
'        If j Mod max / 10 = 0 Then
'            Debug.Print j
'        End If
'    Next
'    Debug.Print "Done. Took "; Timer - t; " secs" ' * No leaks *
'    Debug.Print "Each call took "; (Timer - t) / max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / max) * 1000000; " Mu secs"
''Took  30.70313  secs
''Each call took  0.0000030703125  secs
''Each call took  3.0703125  Mu secs
'
'    End
'End Sub

'Public Sub test()
'    Dim s As String
'    Dim l As Long
'    Cls
''    s = "Hello world" & vbCrLf
''    Debug.Print ReverseWords(s)
''    s = "Hello world" & vbCrLf
''    Debug.Print StrToHex(ReverseWords(s))
''
''    End
'    s = "Hello world" & vbCrLf & "Hello world" & vbCrLf
'    Debug.Print ReverseWords(s)
'    s = "Hello world" & vbCrLf & "Hello world" & vbCrLf
'    Debug.Print StrToHex(ReverseWords(s))
'    s = "The quick brown fox jumped over-the lazy dog"
'    Debug.Print ReverseWords(s)
'    s = "The quick brown fox jumped over-the lazy dog"
'    Debug.Print StrToHex(WordWrap(s, 6, l))
'    s = "The quick brown fox 1.23 jumped over-the lazy dog"
'    s = WordWrap(s, 12, l)
'    Debug.Print "s="; s
'    Debug.Print ReverseWords(s)
'    Debug.Print ReverseWords(s)
'    Debug.Print "s="; s
'    End
'End Sub

'Public Sub test()
'    ' FindClosingBracket, BracketStr /////////////////////////
'    Dim s As String
'    Dim i As Integer
'    Dim p As Integer
'    Dim r As String
'    Dim Max As Long
'    Dim t As Single
'    Dim j As Long
'    '    123456789
'    '             01234567890
'                             123456789012
'    s = "(5*3(+4.2)(/7))+5)(((*6)-345/7)+3-3222)/1.1)"
'    For i = 0 To Len(s) + 1
'        p = FindClosingBracket(s, i)
'        If p > 0 Then
'            Debug.Print i; "="; p; "...."; Mid$(s, i, p - i + 1)
'            Debug.Print "BracketStr=["; BracketStr(s, i); "]"
'            Debug.Print "BracketStr= ["; BracketStr(s, i, True); "]"
'        Else
'            'Debug.Print "i="; i; " not found"
'        End If
'    Next

'    Max = 10000000
'    t = Timer
'    Debug.Print "Start./////////////////////////"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    For j = 1 To Max                        ' * BUG * QsortVar was corrupting var Max - now OK
'        r = BracketStr(s, i)
'        r = BracketStr(s, i, True)
'        If j Mod Max / 10 = 0 Then
'            Debug.Print Comma(j)
'        End If
'    Next
'    ' * NO LEAKS *
'    '10,000,000 loops took  20.23535  secs
'    'Each call took  2.02353515625E-06  secs
'    'Each call took  2.02353515625  Mu secs
'    Debug.Print Comma(Max); " loops took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    End
'End Sub

' //////////////////////////////////

'Public Function Eval(ByVal s As String) As Double
'    ' Remove OCX reference after testing
'    ' Simple scripting evaluation
'    Dim oScriptCtl As New ScriptControl
'    On Local Error Resume Next
'    Eval = 0#
'    oScriptCtl.Language = "VBScript"
'    Eval = oScriptCtl.Eval(s)
'End Function
'
'Public Sub test()
'    On Local Error Resume Next
'    Dim fp As Integer
'    Dim Max As Long
'    Dim t As Single
'    Dim j As Long
'    Dim s As String
'    Dim q As String
'    Dim d As Variant
'    Dim r As Variant
'    Dim ErrCode As Integer
'    Dim ErrString(12) As String
'    ErrString(0) = "No Error"
'    ErrString(1) = "Syntax Error"
'    ErrString(2) = "Division by Zero"
'    ErrString(3) = "Multiple operators found"   ' && // *** etc.
'    ErrString(4) = "Unexpected bracket"         ' Brackets not allowed in this function
'    ErrString(5) = "Number too large"           ' Protected against buffer-overflow
'    ErrString(6) = "Invalid Expression"         ' Expression could not be processed properly
'    ErrString(7) = "Out of Heap Memory"         ' Malloc or operator::new failed
'    ErrString(8) = "Overflow"                   ' Number or internal result too large
'    ErrString(9) = "Hex Digit Overflow"         ' Supplied hex digit was > 8 digits (long)
'    ErrString(10) = "pow() Range Error"         ' Pow values/return was out of range
'    ErrString(11) = "Roman overflow"            '
'    ErrString(12) = "Binary Overflow"           '
'    ErrString(UBound(ErrString)) = "Unknown Error"             ' Generic error
'Cls
'GoTo Skip
'    s = "2^12"  ' 4096
'    d = Expr(s, ErrCode): If d <> 14 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "2 pow 12"  ' 4096
'    d = Expr(s, ErrCode): If d <> 4096 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "--10"
'    d = Expr(s, ErrCode): If d <> 10 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "-+22/-7^10"        ' XOR
'    d = Expr(s, ErrCode): If d <> 9 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "-+22/-7 pow 10"        ' POW
'    d = Expr(s, ErrCode): If Round(d, 2) <> Round(94025.6637898352, 2) Then Debug.Print "Error: "; s; " ("; d; ")("; ErrString(ErrCode); ")": End
'    s = "022/-07 pow 0010"
'    d = Expr(s, ErrCode): If Round(d, 2) <> Round(94025.6637898352, 2) Then Debug.Print "Error: "; s; " ("; d; ")("; ErrString(ErrCode); ")": End
'    s = "7&3"
'    d = Expr(s, ErrCode): If d <> 3 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "15|3&6.5"
'    d = Expr(s, ErrCode): If d <> 6 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "~2&12"
'    d = Expr(s, ErrCode): If d <> 12 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "2=3"
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "7&~2|~7&2=0"   ' VBTrue
'    d = Expr(s, ErrCode): If d <> -1 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "2 pow 12"
'    d = Expr(s, ErrCode): If d <> 4096 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6*2=12" ' VBTrue
'    d = Expr(s, ErrCode): If d <> -1 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "~1"        ' Two's compliment
'    d = Expr(s, ErrCode): If d <> -2 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "not 1"     ' 2's complement
'    d = Expr(s, ErrCode): If d <> -2 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "not -1"     ' 2's complement
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "not -43 or 12"     ' 42 or 12 (vb says 46 so does expr)
'    d = Expr(s, ErrCode): If d <> 46 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "1 > 2 =          0"
'    d = Expr(s, ErrCode): If d <> True Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3<=10"
'    d = Expr(s, ErrCode): If d <> True Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3>=10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3>10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3 < 10"
'    d = Expr(s, ErrCode): If d <> True Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3=10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3==10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3===10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "3====10"
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6 and 15"
'    d = Expr(s, ErrCode): If d <> 6 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6 & 15"
'    d = Expr(s, ErrCode): If d <> 6 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6or 15"    ' Syntax error
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6or15"    ' Syntax error
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6 or15"    ' Syntax error
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6&&15"    ' Syntax error
'    d = Expr(s, ErrCode): If d <> False Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "1024 pow 1024"    ' Syntax error
'    On Error Resume Next
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    Debug.Print "Err="; Err.Number,:     If Err.Number = 6 Then Debug.Print "Test "; Err.Description
'    s = "3 10"      ' Should fail
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "+3 10 12"      ' Should fail
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "0/1"      ' Should fail
'    d = Expr(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "+1+2+3"
'    d = Expr(s, ErrCode): If d <> 6 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    ' Problem when x3 segments join- brackets induce left-right issues which MAY override
'    ' initial bracket precedence
'    s = "1+-3.1428571429*10" ' FAULTY ?
'    d = Expr(s, ErrCode): If d <> -21.428571429 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
'    Cls
'    s = "(1+(22/-7))*(10*1)"
'    d = Expression(s, ErrCode): If d <> -21.428571429 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "1+2+3" ' Expr() bug
'    d = Expression(s, ErrCode): If d <> 6 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
'    s = "(1)" ' Expr() bug
'    d = Expression(s, ErrCode): If d <> 1 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "(-1)" ' Expr() bug
'    d = Expression(s, ErrCode): If d <> -1 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "-(1)" ' Expr() bug
'    d = Expression(s, ErrCode): If d <> -1 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "not (1)" ' Note: Bitwise not logical
'    d = Expression(s, ErrCode): If d <> -2 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
''    If Expression(s) <> VBExpression(s) Then Debug.Print "Error evaluating "; s; " Should be: "; VBExpression(s)
'Cls
'    s = "not (1) and 0xffffffffff"  ' Hex overflow test
'    d = Expression(s, ErrCode): If d <> 0 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "-0x7fffffff"   ' -2147483647 VB and Google
'    d = Expression(s, ErrCode): If d <> -2147483647 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "12345 and 0xff"    ' VB=57
'    d = Expression(s, ErrCode): If d <> 57 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "0x7efe"   ' -257 val(&hfefe) -258 (65278 signed google)
'    d = Expression(s, ErrCode): If d <> 32510 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'Cls
'    s = "0xfefe"   ' -257 val(&hfefe) -258 (VB) 65278 (signed, Google)
'    d = Expression(s, ErrCode): If d <> 65278 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "12345 or 0xfefe"   ' 65279 (Wincalc) -257
'    d = Expression(s, ErrCode): If d <> 65279 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
'    s = "0xff + 0xff"   ' Test multiple hex values
'    d = Expression(s, ErrCode): If d <> 510 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
'    s = "12345 + 0xff * 0xff -0x1234"   '? ((12345& + &hff) * &hff&) -&h1234 -> 3208340
'    d = Expression(s, ErrCode): If d <> 3208340 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "123456 pow  2"
'    d = Expression(s, ErrCode): If d <> 123456 ^ 2 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "6 *(10 pow  23)"
'    d = Expression(s, ErrCode): If d <> 6 * (10 ^ 23) Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "1 and 2 and 3 and 4"
'    d = Expression(s, ErrCode): If d <> 1 And 2 And 3 And 4 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "1 or 3 and 22 or 7 and 231 or 12"  '15
'    d = Expression(s, ErrCode): If d <> 1 And 2 And 3 And 4 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "(12 and (not 3)) or (3 and (not 12))"  '0
'    d = Expression(s, ErrCode): If d <> 15 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "(123.45*76)+(89 pow 10)"  '0
'    d = Expression(s, ErrCode): If d <> (123.45 * 76) + (89 ^ 10) Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "~23 or -411"  '0
'    d = Expression(s, ErrCode): If d <> (Not 23 Or -411) Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "365.25/12"  '0
'    d = Expression(s, ErrCode): If d <> 365.25 / 12 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "(-365.25/+12)*-12.345"  '0
'    d = Expression(s, ErrCode): If d <> (-365.25 / 12) * -12.345 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "0xefff0002 or -234 ^987"  '0
'    d = Expression(s, ErrCode): If d <> (&HEFFF0002 Or -234 Xor 987) Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    '(2682 pow 1007)-4637/5267] err=Syntax Error
'    s = "(531+ not 3923)+1272&8996-(9227^ not 2709)"
'    '(531+ not 3923)+1272 and 8996-(9227 ^(not 2709)) -> VB 8996
'    d = Expression(s, ErrCode): If d <> 8996 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    s = "(((22096.0 = not 5398.0)or 8523.0 or 8582.0)*(5989.0*2508.0))+ not 4182.0"
'    d = Expression(s, ErrCode): If d <> 130001661677# Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'
'Skip:
'    Dim op(19) As String
'    Dim SyntaxErrors As Long
'    Dim OverFlows As Long
'    Dim DivByZeroes As Long
'    Dim MultipleOps As Long
'    Dim UnexpectedBrackets As Long
'    Dim OutOfMemory As Long
'    Dim NumberTooBig As Long
'    Dim HexOverFlows As Long
'    Dim PowRange As Long
'    Dim BinOverflow As Long
'    Dim RomanOverflow As Long
'    Dim InvalidExpresion As Long
'    Dim UnknownErrors As Long
'    Dim MisMatches As Long
'    op(0) = "+"
'    op(1) = "+"
'    op(2) = "-"
'    op(3) = "/"
'    op(4) = "*"
'    op(5) = "&"
'    op(6) = "|"
'    op(7) = "^"
'    op(8) = " pow "
'    op(9) = " and "
'    op(10) = " or "
'    op(11) = " xor "
'    op(12) = "="
'    op(13) = " > "
'    op(14) = " < "
'    op(15) = " >= "
'    op(16) = " <= "
'    op(17) = " != "
'    op(18) = " mod "
'    op(19) = "%"
'    'op(20) = ">>"
'    'op(21) = "<<"
'
'    ' Unary operators (prefix ops)
'    Dim unary(10) As String
'    unary(0) = ""
'    'unary(1) = "~"         ' c compatible
'    unary(1) = " not "      ' vb compatible
'    unary(2) = ""
'    unary(3) = "-"
'    unary(4) = "+"
'    unary(5) = ""
'    unary(6) = ""
'    unary(7) = " not "
'    unary(8) = ""
'    unary(9) = ""
'    unary(10) = ""
'    SyntaxErrors = 0
'    DivByZeroes = 0
'    MultipleOps = 0
'    UnexpectedBrackets = 0
'    NumberTooBig = 0
'    OverFlows = 0
'    InvalidExpresion = 0
'    OutOfMemory = 0
'    HexOverFlows = 0
'    PowRange = 0
'
'    MisMatches = 0
'
''#define EXPR_ERR_SYNTAX 1
''#define EXPR_ERR_DIV_BY_ZERO 2
''#define EXPR_ERR_MULTIPLE_OPS 3
''#define EXPR_ERR_UNEXPECTED_BRACKET 4
''#define EXPR_ERR_NUMBER_TOO_BIG 5
''#define EXPR_ERR_INVALID_EXPR 6
''#define EXPR_ERR_OUT_OF_MEMORY 7
''#define EXPR_ERR_OVERFLOW 8
''#define EXPR_ERR_HEX_OVERFLOW 9
''#define EXPR_ERR_POW_RANGE 10
''#define EXPR_ERR_UNKNOWN 11
'
'    t = Timer
'    s = "0xefff0002 or -234 ^987"  '0
'    's = "22/7*12345"
'    fp = FreeFile()
'    Open "c:\faults.txt" For Output As fp
'    Debug.Print "Start./////////////////////////"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    On Error Resume Next
'Max = 100000
'Randomise Timer ' randomise(peek 64504!) LOL!
'MTRandomise
'    OpenConsole
'    For j = 1 To Max                        ' * BUG * QsortVar was corrupting var Max - now OK
''        s = "(" & Format$(Random(1, 99999)) & op(Random(0, UBound(op))) & _
''            unary(Random(0, UBound(unary))) & Format$(Random(1, 9999)) & ")" & _
''            op(Random(0, 8)) & Format$(Random(1, 9999)) & op(Random(0, UBound(op))) & _
''            Format$(Random(1, 9999)) & op(Random(0, UBound(op))) & _
''            "(" & Format$(Random(1, 9999)) & op(Random(0, UBound(op))) & unary(Random(0, UBound(unary))) & _
''            Format$(Random(1, 9999)) & ")" & op(Random(0, UBound(op))) & unary(Random(0, UBound(unary))) & _
''            Format$(Random(1, 999999))
'        s = "(((((" & Format$(MTRnd(1, 99999)) & op(MTRnd(0, UBound(op))) & "&h" & MTRandomStr(5, RandomStringHexLower) & ")" & _
'        op(MTRnd(0, 8)) & unary(MTRnd(0, UBound(unary))) & Format$(MTRnd(1, 9999)) & ")" & _
'        op(MTRnd(0, 8)) & unary(MTRnd(0, UBound(unary))) & Format$(MTRnd(1, 9999)) & ")" & _
'        op(MTRnd(0, 8)) & unary(MTRnd(0, UBound(unary))) & Format$(MTRnd(1, 9999)) & ")" & _
'        op(MTRnd(0, 8)) & Format$(MTRnd(1, 9999)) & ")" & _
'        op(MTRnd(0, 8)) & Format$(MTRnd(1, 9999))
'
'        Print #fp, Format$(j) & ": TRYING Expr(" & s & ") "
'        d = Expression(s, ErrCode) ' ///////////////////////////////////
'
'        If j Mod Max / 1000 = 0 Then
'            'Debug.Print Comma(j); " s=["; s; "]="; d; " ( err="; ErrString(ErrCode); ")"
'            WriteLn Format$(j) & " - " & Now
'        End If
'
'        If ErrCode = 1 Or ErrCode = 6 Then
'            SyntaxErrors = SyntaxErrors + 1
'            Debug.Print "Mismatch: "; Comma(j); " s=["; s; "] err="; ErrString(ErrCode)
'            Print #fp, "Expr(" & s & ")    "; ErrString(ErrCode); ""
'            If ErrCode = 6 Then InvalidExpresion = InvalidExpresion + 1
'        ElseIf ErrCode = 2 Then
'            DivByZeroes = DivByZeroes + 1
'        ElseIf ErrCode = 3 Then
'            MultipleOps = MultipleOps + 1
'        ElseIf ErrCode = 4 Then
'            UnexpectedBrackets = UnexpectedBrackets + 1
'        ElseIf ErrCode = 5 Then
'            NumberTooBig = NumberTooBig + 1
''        ElseIf ErrCode = 6 Then
''            InvalidExpresion = InvalidExpresion + 1
'        ElseIf ErrCode = 7 Then
'            OutOfMemory = OutOfMemory + 1
'        ElseIf ErrCode = 8 Then
'            OverFlows = OverFlows + 1
'        ElseIf ErrCode = 9 Then
'            HexOverFlows = HexOverFlows + 1
'        ElseIf ErrCode = 10 Then
'            PowRange = PowRange + 1
'        ElseIf ErrCode = 11 Then
'            BinOverflow = BinOverflow + 1
'        ElseIf ErrCode = 12 Then
'            RomanOverflow = RomanOverflow + 1
'        ElseIf ErrCode = 13 Then
'            UnknownErrors = UnknownErrors + 1
'Debug.Print "unknown error trapped"
'            End
'        ElseIf ErrCode = 0 Then                 ' Valid expression so test it
''Debug.Print "VB is evaluating ["; s; "]"
'        q = s
'        q = Replace(q, "^", " xor ")
'        q = Replace(q, "&", " and ")
'        q = Replace(q, "|", " or ")
'        q = Replace(q, "~", " not ")
'        q = Replace(q, "!=", " <> ")
'        q = Replace(q, "pow", "^")
'        r = Eval(q) ' Call vbScript
''Debug.Print "VB is evaluating ["; s; "]"
'        ' Comparing doubles from different implementations is problematic!
'        ' In many cases VBScript returns zero in error
'        If Abs(Abs(r) - Abs(d)) > 1 And r <> 0 Then
'            ' Can't compare bitops as I use unsigned and VB uses signed values
'            'If InStr(q, " and ") = 0 And InStr(q, " or ") = 0 And InStr(q, " xor ") = 0 Then ' Or can't be compared due to sign diffs
'    '        If Not ( Abs(Abs(r) - Abs(d))) > 2 Or (Round(d, 3) = Round(r, 3)) Or ((Round(r, 2) <> Round(d, 2) And (r <> 0 And d <> 0))) Then
'                Debug.Print "Mismatch at "; j; ": "; d; "<>"; r; " for: ?Expression("; q; ") : ("; Round(d, 2); "<>"; Round(r, 2); ") err="; ErrCode
'                Print #fp, "MISMATCH "; d; "<>"; r; " Expr(" & s & ")    "; ErrString(ErrCode); ""
'    '            Close fp
'    '            End
'                MisMatches = MisMatches + 1
'            'End If
'        End If
'
'
'        End If
'    Next
'    Close fp
''' * NO LEAKS
''Start./////////////////////////
''10,088 kbyte(s) in use
''10,000,000 loops took  587.4844  secs
''Each call took  0.0000587484375  secs
''Each call took  58.7484375  Mu secs
''10,036 kbyte(s) in use
''Error Counts:
''---------------------
''75051   DivByZeroes
'    Debug.Print "End. //////////////////////////"
'    Debug.Print Comma(Max); " loops took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    Debug.Print "Error Counts:"
'    Debug.Print "---------------------"
'    If SyntaxErrors > 0 Then
'        Debug.Print SyntaxErrors, " SyntaxErrors"
'    End If
'    If DivByZeroes > 0 Then
'        Debug.Print DivByZeroes, " DivByZeroes"
'    End If
'    If MultipleOps > 0 Then
'        Debug.Print MultipleOps, " Multiple Ops"
'    End If
'    If UnexpectedBrackets > 0 Then
'        Debug.Print UnexpectedBrackets, " Unexpected Brackets"
'    End If
'    If NumberTooBig > 0 Then
'        Debug.Print NumberTooBig, " NumberTooBig"
'    End If
'    If InvalidExpresion > 0 Then
'        Debug.Print InvalidExpresion, " Invalid Expresions"
'    End If
'    If OutOfMemory > 0 Then
'        Debug.Print OutOfMemory, " OutOfMemory"
'    End If
'    If OverFlows > 0 Then
'        Debug.Print OverFlows, " OverFlows"
'    End If
'    If HexOverFlows > 0 Then
'        Debug.Print HexOverFlows, " HexOverFlows"
'    End If
'    If PowRange > 0 Then
'        Debug.Print PowRange, " Pow Range errors"
'    End If
'    If BinOverflow > 0 Then
'        Debug.Print BinOverflow, " Binary overflows"
'    End If
'    If RomanOverflow > 0 Then
'        Debug.Print RomanOverflow, " Roman overflows"
'    End If
'    If UnknownErrors > 0 Then
'        Debug.Print UnknownErrors, " Unknown Errors"
'    End If
'    If MisMatches > 0 Then
'        Debug.Print MisMatches; " MisMatches"
'    End If
'
'    ' Functions have to be replaced before maths expression
'    ' Problem with pow((expr),(expr))
'
'    ' call powstr(string) or call functlib(string,"pow")
'    '? expression("(8219 pow 4904)+3890*134",errcode):? errcode
'    'Fault:
'
'    '? expression("(9323)/1534|4773(2426- not 5091)",errno):? errno
'    '==47737518
'' URGENT BUGS... ///////////////////////////////////
'' cannot handle numbers 4.2961972150697E+113
'    ' still have memory alloc problem
'    ' Check fix on multiple preceding operators (op confused with sign flag)
'    '? expression("531+ not 3923)+1272&8996-(9227^ not 2709)",errcode):? errcode
'
'    ' Permits this line with syntax error... (no operator)
'    ' Should be syntax error (no operator) *****
'    's = "(9323)/1534|4773(2426- not 5091)"
'
'    'd = Expression(s, ErrCode): If d <> 47737518 Then Debug.Print "Error: "; s; " ("; d; ") ("; ErrString(ErrCode); ")": End
'    '(30345-1297)+2749&5753 < (5330 <= +150) pow +12990] err=Invalid Expression
'    ' DONE FAILS due to xE+N or xE-N
'    '? Expression("(((((29534 And 1629) + Not 6072) ^ Not 7369) * 3434) - 233) ^ 48")
'    ' Fails 5376 <> 5377
'    '? Expression("(((((6818/5182)*925)*2345)+2181) xor 502) and 7597") -> 3465
'    ' VBScript Bug:
'    ' ? eval("(31774*9119)*395)") undetected overflow in VBScript????
'    ' when part of :
'    ' Expr/Eval ("(31774*9119)*395")  114450106870
'    '? Expression((((((31774*9119)*395) or 7274)/ not 8578)+9809) and 302)
'    ' VBScript aborts with zero wheras my code continues to evaluate (in error)
'    ' expression("(31774*9119)*395") -> 114450106870
'    ' expr("(31774*9119)*395") -> 0
'    ' WinCalc -> 114450106870
'    ' bug in pow translation (fixed)
'    ' ? expression("(((((41084=&h50301)-7019) round 2 pow 7057)+-3600)+508)+9865",errcode):? errcode:end
'
'    ' Print Expression("(((((7244/1475)+2201)+8949)- not 9569) or 732)")
'    '21244 21245 ( ... or 732 is the problem due to signed value)
''    Debug.Print "MTRandomStr..."
''    Dim i As Integer
''    For i = 1 To 20
''        Debug.Print MTRandomStr(5, RandomStringHex)
''    Next
''    Debug.Print "RandomStr..."
''    For i = 1 To 20
''        Debug.Print RandomStr(5, RandomStringHex)
''    Next
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test1()
'    ' DecToBin
'    Dim i As Long
'    Debug.Print "Testing..."
''    For i = 1 To &H7FFFFFFF
''        If Right$(DecToBin(7, True), 1) = "0" Then
''            Debug.Print "Failed at "; i
''        End If
''        If i Mod 100000 = 0 Then
''            Debug.Print i
''        End If
''    Next
''    For i = 1 To 10001
''        If RomanToDecimal(DecimalToRoman(i)) <> i Then
''            Debug.Print "+ve Failed at"; i; " ( should fail at 10,001)"
''            Debug.Print "DecimalToRoman("; i; ")="; DecimalToRoman(i)
''            Debug.Print "RomanToDecimal("; i; ")="; RomanToDecimal(DecimalToRoman(i))
''            'End
''        End If
''        If i Mod 1000 = 0 Then
''            Debug.Print i
''        End If
''    Next
'    For i = -10000 To 10001
'        If RomanToDecimal(DecimalToRoman(i)) <> i Then
'            Debug.Print "Failed at"; i; " ( should fail at 10,001"
'            Debug.Print "DecimalToRoman("; i; ")="; DecimalToRoman(i)
'            Debug.Print "RomanToDecimal("; i; ")="; RomanToDecimal(DecimalToRoman(i))
'            End
'        End If
'        If i Mod 1000 = 0 Then
'            Debug.Print i
'        End If
'    Next
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test1()
'   Check hextolong, longtohex
'    OpenConsole
'    Dim i As Double
'    For i = 3091600000# To 4294967295#  ' Unsigned long range pass
'        DoEvents
'        If HexToLong(LongToHex(i)) <> i Then
'            Debug.Print "Fail at "; i
'            End
'        End If
'        DoEvents
'        'If i < 2147400000 Then
'            If FMod(i, 100000) = 0# Then
'                WriteLn Format$(i)
'                'Debug.Print i
'            End If
'        'End If
'        DoEvents
'        'WinSleep 10
'    'Print HexToLong("ffffffff"): End
'    Next
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' Replacestr
'    Dim s As String
'    Dim q As String
'    Dim i As Long
'    Dim j As Long
'    Dim t As Single
'    t = Timer
'    Dim Max As Long
'    s = "the quick brown fox jumps over the lazy dog"
'    Max = 100000
'    Debug.Print "Testing..."
'    Debug.Print Replace(s, vbNullString, vbNullString)
'    Debug.Print Replace(s, "", vbNullString)
'    Debug.Print Replace(s, vbNullString, "")
'    Debug.Print Replace(s, " ", vbNullString)
'    Debug.Print Replace(s, vbNullString, " ")
'    Debug.Print Replace(s, " ", "-")
'    Debug.Print Replace(s, " ", "++++++++++")
'    Debug.Print Replace(s, "fox", "hippopotamus")
'    Debug.Print "Start: "; Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    If Max > 10 Then
'        For j = 1 To Max
'            q = Replace(s, vbNullString, vbNullString)
'            q = Replace(s, "", vbNullString)
'            q = Replace(s, vbNullString, "")
'            q = Replace(s, " ", vbNullString)
'            q = Replace(s, vbNullString, " ")
'            q = Replace(s, " ", "-")
'            q = Replace(s, " ", "++++++++++")
'            q = Replace(s, "fox", "hippopotamus")
'            If j Mod (Max / 10) = 0 Then
'                Debug.Print j
'
'            End If
'        Next
'    End If
'    ' * No leaks *
''    100,000 loops took  2.796875  secs
''    Each call took  0.00002796875  secs
''    Each call took  27.96875  Mu secs
''    7,100 kbyte(s) in use
'    Debug.Print Comma(Max); " loops took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' InsertString
'    Dim s As String
'    Dim q As String
'    Dim i As Long
'    Dim j As Long
'    Dim t As Single
'    t = Timer
'    Dim Max As Long
'    s = "the quick brown fox jumps over the lazy dog"
'    Max = 1000000
'    Debug.Print "Testing InsertString..."
'    Debug.Print "["; InsertString(vbNullString, vbNullString); "]"
'    Debug.Print "["; InsertString("", vbNullString); "]"
'    Debug.Print "["; InsertString(vbNullString, ""); "]"
'    Debug.Print "["; InsertString(" ", vbNullString); "]"
'    Debug.Print "["; InsertString(" ", ""); "]"
'    Debug.Print "["; InsertString(s, vbNullString); "]"
'    Debug.Print "["; InsertString(s, " "); "]"
'    Debug.Print "["; InsertString(s, "++++++++++", 1); "]"
'    Debug.Print "["; InsertString(s, "hippopotamus", 3); "]"
'    Debug.Print "Start: "; Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'    If Max > 10 Then
'        For j = 1 To Max
'            q = InsertString(vbNullString, vbNullString)
'            q = InsertString("", vbNullString)
'            q = InsertString(vbNullString, "")
'            q = InsertString(" ", "")
'            q = InsertString(s, vbNullString)
'            q = InsertString(s, " ")
'            q = InsertString(s, "++++++++++", 1)
'            q = InsertString(s, "hippopotamus", 3)
'            If j Mod (Max / 10) = 0 Then
'                Debug.Print j
'            End If
'        Next
'    End If
'    ' * No leaks *
''    1,000,000 loops took  14.32813  secs
''    Each call took  0.00001434375  secs
''    Each call took  14.34375  Mu secs
''    16,996 kbyte(s) in use
'
'    Debug.Print Comma(Max); " loops took "; Timer - t; " secs"
'    Debug.Print "Each call took "; (Timer - t) / Max; " secs"
'    Debug.Print "Each call took "; ((Timer - t) / Max) * 1000000; " Mu secs"
'    Debug.Print Comma(GetProcessMemoryUsed(GetPID()) / 1024); " kbyte(s) in use"
'
'    Debug.Print "Done."
'    End
'End Sub

'Public Sub test()
'    ' Works well at abstracting the RTF header and subsequently processing the remainder of
'    ' the text but cannot sort properly due to the RTF prefix on each \par line
'    Dim s As String
'    Dim q As String
'    Dim l As Long
'    Dim bn As Integer
'    Dim rh As String
'
'    s = "{\rtf1\ansi\ansicpg1252\deff0{\fonttbl{\f0\fnil\fcharset0 Arial;}}"
'    s = s & "{\colortbl ;\red0\green0\blue0;}"
'    '\viewkind4\uc1\pard\cf1\lang2057\ul\b\i\strike\f0\fs28
'    s = s & "\viewkind4\uc1\pard\cf1\lang2057\ul\b\i\strike\f0\fs28 iii\tab 3\tab seigrumyz"
'    s = s & "\par \fs10 iiiv\tab 8\tab secnayeba"
'    s = s & "\par \f0 iiv\tab 7\tab s'ecnayeba"
'    s = s & "\par \b \i iv\tab 6\tab ecnayeba"
'    s = s & "\par \ul v\tab 5\tab setogyz}"
'    q = RTFGetHeader(s, l)
'    Debug.Print "["; q; "]"
'    rh = Mid$(s, l + 1)
'    Debug.Print "rh["; rh; "]"
'    bn = MatchBrackets(q, "{", "}")
'    Debug.Print "Closing brackets needed="; bn ' We need to strip N brackets from RH side which will be == to deficiency
'    Debug.Print "Closing bracket pos in Mid$="; InStrRev(rh, "}")
'    rh = String$(bn, "{") & rh
'    Debug.Print "rh=["; rh; "]"
'    'Debug.Print MatchBrackets(rh, "{", "}") ' Pass 0
'    rh = BracketStr(rh, 1, True)
'    Debug.Print "BracketStr["; rh; "]"
'    Debug.Print PrintR(StrSplit(rh, "\par "))
'    s = q & Join(QSort(StrSplit(rh, "\par "), True)) & String$(bn, "}")      ' Rejoin
'    Call PrintR(s)
'    Debug.Print "Done."
'    End
'End Sub
